import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.io.*;


public class WallsDisplay extends JComponent implements ActionListener{

/* The panel for drawing the beacons should be a square. The variable
   PANELSIZE below should be set to be the height (or width) of that
   panel in pixels. For example, if you want to have a 700 pixel by
   700 pixel panel, PANELSIZE = 700

   This variable also needs to be changed in the file
   WallsDemo.java */
    public static final int PANELSIZE = 700;

    //    protected int[] beaconlocs = new int[33];
    //    protected BeaconData[] newlocs = new BeaconData[15];
    protected BeaconData[] beaconlocs = new BeaconData[15];
    private CricketClient cc;
    private JButton freezeButton;

    public WallsDisplay(JButton freezeButton){
	//	setLayout(new BorderLayout());
	this.setPreferredSize(new Dimension(PANELSIZE, PANELSIZE));
	this.setOpaque(true);
	this.freezeButton = freezeButton;
	//	this.setBackground(Color.RED);
// 	JLabel words = new JLabel("words go here");
// 	words.setLocation(70,60);
// 	words.setSize(400,60);
//	words.setFont(new Font("Sans", Font.BOLD, 24));
//	this.add(words);



    }


    public void initialize() {
	for (int i = 0; i < beaconlocs.length; i++){
	    beaconlocs[i] = new BeaconData();
	}
	this.updateBeacon("me", 0, 0);
// 	beaconlocs[0] = 1;
// 	beaconlocs[1] = 5;
// 	beaconlocs[2] = 5;
// 	beaconlocs[3] = 2;
// 	beaconlocs[4] = 35;
// 	beaconlocs[5] = 150;
// 	beaconlocs[6] = 3;
// 	beaconlocs[7] = 70;
// 	beaconlocs[8] = 150;

// 	beaconlocs[0].putdata("0x01", 5, 5);
// 	beaconlocs[1].putdata("0x02", 35, 150);
// 	beaconlocs[2].putdata("0x03", 70, 150);
// 	System.out.println("beaconloc1 is " + beaconlocs[1] + " and beaconlocs2 is  " +  beaconlocs[2]);


	// blank.lcs.mit.edu (18.24.2.76)  use gpsd port of 2947
	// even though we're really using netcat
	// CricketClient(String ip, int port, String id)
	//cc = new CricketClient("18.24.2.76", 2947,  this);
	cc = new CricketClient("localhost", 2947,  this);
		
	try {
	    cc.connect();
	}
	catch (IOException ie) {
	    System.out.println("Connection failed");
	}
	//	(new Thread(this)).start();
	cc.start();


    }

    public void actionPerformed(ActionEvent evt){
//  	this.updateBeacon("0x05", 40, 300);
//  	this.updateBeacon("0x06", 40, 350);
//         this.updateBeacon("0x03", 40, 300);
//         this.updateBeacon("0x04", 40, 350);
	cc.freeze();
	if (freezeButton.getText() == "Freeze Network") {
	    freezeButton.setText("Unfreeze Network");
	}
	else {
	    freezeButton.setText("Freeze Network");
	}
	repaint();
    }


    public void paint(Graphics g) {


	// Draw the components
	super.paint(g);

        Graphics2D g2 = (Graphics2D) g;

//         // Drawing the shadow
//         g.setColor(Color.DARK_GRAY);
//         g.fillOval(3+45 - 1, 3+20 - 1, 10 + 1, 10 + 1);
//         g.fillRect(3+45 - 1, 3+25, 10 + 2, 130);
//         g.fillOval(3+35 - 1, 3+150 - 1, 30 + 2, 30 + 2);

//         // Drawing the outlines
//         g.setColor(Color.black);
//         g.fillOval(45 - 1, 20 - 1, 10 + 1, 10 + 1);
//         g.fillRect(45 - 1, 25, 10 + 2, 130);
//         g.fillOval(35 - 1, 150 - 1, 30 + 2, 30 + 2);

//         // The white part
//         g.setColor(Color.white);
//         g.fillOval(45, 20, 10, 10);
//         g.fillRect(45, 25, 10, 130);
//         // The red part
//         g.setColor(Color.red);
//         g.fillOval(35, 150, 30, 30);
 
//         // A beacon
//         g.setColor(Color.red);
//         g.fillOval(beaconlocs[1], beaconlocs[2], 5, 5);

	// Paints all the beacons to the screen as red circles
	// requires Graphics g, and an array of beacon locations
	paintbeacons(g, beaconlocs);

         // A test beacon using new beacon class (BeaconData newlocs)
	//         g.setColor(Color.black);
	 //         g.fillOval(beaconlocs[0].xcoord, beaconlocs[0].ycoord, 5, 5);
	//         g.fillOval(beaconlocs[0].xcoord(), beaconlocs[0].ycoord(), 5, 5);

//         // A beacon
//         g.setColor(Color.red);
//         g.fillOval(70, 150, 5, 5);



// 	// The red column representing the temperature

// 	// TODO: To be implemented

// 	// The temperature scaling
// 	g.setColor(Color.BLACK);
// 	g.drawString(""+100,20,20);
// 	g.drawString(""+-30,20,155);
    
    }

    private void paintbeacons(Graphics g, BeaconData[] beaconarray) {

//         // draw Line2D.Double
//         g2.draw(new Line2D.Double(x, y+rectHeight-1, x + rectWidth, y));
//         g2.drawString("Line2D", x, stringY);
//         x += gridWidth;

	// clear screen
	g.setColor(Color.white);
	g.fillRect(0, 0, PANELSIZE, PANELSIZE);

	/* These lines draw the "arrow" of the frame */
 	g.setColor(Color.black);
	g.drawLine(beaconarray[1].xcoord() + PANELSIZE/2, beaconarray[1].ycoord() + PANELSIZE/2, beaconarray[1].xcoord() + beaconarray[2].xcoord() + PANELSIZE/2, beaconarray[1].ycoord() + beaconarray[2].ycoord() + PANELSIZE/2 );
	g.drawLine(beaconarray[2].xcoord() + PANELSIZE/2, beaconarray[2].ycoord() + PANELSIZE/2, beaconarray[1].xcoord() + beaconarray[2].xcoord() + PANELSIZE/2, beaconarray[1].ycoord() + beaconarray[2].ycoord() + PANELSIZE/2 );
	g.drawLine(beaconarray[0].xcoord() + PANELSIZE/2, beaconarray[0].ycoord() + PANELSIZE/2, beaconarray[1].xcoord() + beaconarray[2].xcoord() + PANELSIZE/2, beaconarray[1].ycoord() + beaconarray[2].ycoord() + PANELSIZE/2 );
	//   g.drawString("Line2D", x, stringY);
	//   x += gridWidth;

	g.setColor(Color.red);

	//stuff for drawing strings on the screen
// 	g.setColor(Color.BLACK);
// 	g.drawString(""+100,20,20);
// 	g.drawString(""+-30,20,155);

// 	System.out.println("length of beaconlocs array is " + beaconarray.length); 
	//	System.out.println(beaconarray[3].xcoord());
        for (int i = 0; i < beaconarray.length; i++) {
 	    if (beaconarray[i].valid()) {
		// 		System.out.println(beaconarray[i].xcoord() + " " + beaconarray[i].ycoord() + " ");
		g.fillOval(beaconarray[i].xcoord() + PANELSIZE/2, beaconarray[i].ycoord() + PANELSIZE/2, 5, 5);
	    }
	}
    }

    /*
      ---deprecated--- use updateBeacon instead 
      addBeacon adds a new beacon ID and (x,y) coordinate to the array
      beaconlocs, provided space is available. Otherwise, addBeacon
      prints an error message to the terminal.
    */

//     public void addBeacon(int id, int x, int y) {
// 	for (int i = 0; i < beaconlocs.length; i = i+3) {
// 	    System.out.print(beaconlocs[i] + " ");
// 	    if (beaconlocs[i] == 0) {
// 		beaconlocs[i] = id;
// 		beaconlocs[i+1] = x;
// 		beaconlocs[i+2] = y;
// 		repaint();

    public void updateBeacon(String id, int x, int y) {
	for (int i = 0; i < beaconlocs.length; i++) {
	    //	    System.out.print(beaconlocs[i].id() + " ");
	    if (beaconlocs[i].valid()) {
		if (beaconlocs[i].id().equals(id)) {
		    beaconlocs[i].setxcoord(x);
		    beaconlocs[i].setycoord(y);
		    repaint();
		    return;
		}
	    }
	    
	    else { // it's not valid, we have an empty spot
		beaconlocs[i].putdata(id, x, y);
		repaint();
		return;
	    }    
	}
	System.out.println("Array is full!");
        repaint();

// 	for (int i = 0; i < beaconlocs.length; i = i+3) {
// 	    System.out.print(beaconlocs[i] + " ");
// 	    if (beaconlocs[i] == 0) {
// 		beaconlocs[i] = id;
// 		beaconlocs[i+1] = x;
// 		beaconlocs[i+2] = y;
// 		repaint();
// 		return;
// 	    }
// 	}
// 	System.out.println("Array is full!");
// 	repaint();
    }
    
}
