/*
 * Copyright (c) 2000, 2001 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `LICENSE' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file CRICKETAUTHORS which should have accompanied 
 * this software for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the CRICKETAUTHORS file.
 */
package beaconconfig;
import java.awt.*;

class SquareVertex extends Vertex
{
    protected boolean drawCoord = true;

    public SquareVertex(double x, double y, double z)
    {
	super(x, y);
	this.z = z;
    }

    public void draw(Graphics g, DrawingArea drawArea) 
    {
	Vertex v = drawArea.transform(x, y);
	
	g.setColor(Color.red);
	g.drawRect(Math.round((float)(v.x - DrawingArea.nodeSizeDiv2)), 
		   Math.round((float)(v.y - DrawingArea.nodeSizeDiv2)), 
		   DrawingArea.nodeSize, 
		   DrawingArea.nodeSize);

	if(drawCoord) 
	    g.drawString("("+Util.textOf(x, 2)+", "+Util.textOf(y, 2)+", "+Util.textOf(z, 2)+")",
			 Math.round((float)(v.x+5)),
			 Math.round((float)(v.y+5)));	    
	    

    }

    public void mouseDragged(double x, double y, Vertex anchor, 
			     int modifier) 
    {
	super.mouseDragged(x, y, anchor, modifier);
    }

}
