/*
 * Copyright (c) 2000, 2001 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `LICENSE' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file CRICKETAUTHORS which should have accompanied 
 * this software for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the CRICKETAUTHORS file.
 */
package beaconfinder;

/**
 * Misc. methods for the BeaconFinderApp.
 *
 * @author Allen Miu
 */
public class Util 
{
    public static boolean debugMode = true;

    public static void log(String s) 
    {
	if(debugMode) 
	    System.out.println(s);
    }
    
    public static void assert(boolean pred, String errMsg) 
    {
	if(!pred) {
	    System.out.println("Assertion Error!!!!");
	    System.out.println(errMsg);
	    System.exit(1);
	}
    }

    /*
      public static final int CLOCK_FREQ_HZ  = 15625;
      public static final double TEMPERATURE_C = 20.0;
      public static final double HUMIDITY_PERCENT = 50.0;
      public static final double DELAY_OFFSET_CM = 80.0;
    */

    /* Deprecated:  See cricketdaemon.UnitConv
    public static double b2cm(double bodhi)
    {
	return (double) bodhi*34449.0/CLOCK_FREQ_HZ;
    }

    public static double b2in(double bodhi)
    {
	return (double) bodhi*34449.0/(CLOCK_FREQ_HZ*2.54);
    }
    */

    public static String valueToString(double value, double precision) {
	String result;

	int i = (int) Math.round(value/precision);

	value = i*precision; 
	if(Math.abs(value) < 0.001) // per java doc Double.toString()
	    value = 0.0;
	result = String.valueOf(value);
	int end = result.indexOf(".")+3;
	if(end > result.length())
	    end = result.length();
	return result.substring(0, end);
    }

    /*
      public static int indexOf(Object[] a, Object o)
      {
      for(int i = 0; i < a.length; i++) {
      if(a[i].equals(o))
      return i;
      }
      return -1;
      }
    */
}
