/* color.h */

/* order from msb to lsb is alpha, b, g, r    */

typedef struct colorstruct {
    int	  cid;
    char  *cname;
    long  cpackdata;	/* a,b,g,r */
    float drgba[4];	/* diffuse */
    float srgba[4];	/* specular */
    } COLORDEF;

/* color indices for basic overdrawing */
#define OVER_BLACK 0
#define OVER_WHITE 1
#define OVER_YELLOW 2
#define OVER_PURPLE 2
#define OVER_ORANGE 3

/* rgb mode indices, etc. */
#define UNPACK_RED(c)	((c) & 0xFF)
#define UNPACK_GREEN(c)	(((c) & 0xFF00) >> 8)
#define UNPACK_BLUE(c)	(((c) & 0xFF0000) >> 16)
#define UNPACK_ALPHA(c)	(((c) & 0xFF000000) >> 24)

#define PACK_RED(r)	((r) & 0xFF)
#define PACK_GREEN(g)	(((g) & 0xFF) << 8)
#define PACK_BLUE(b)	(((b) & 0xFF) << 16)
#define PACK_ALPHA(a)	(((a) & 0xFF) << 24)

#define RGB_ABYSS	    0
#define RGB_OFFABYSS	    1
#define RGB_BLACK           2
#define RGB_GREY            3
#define RGB_FLATGREY	    4
#define RGB_WHITE	    5
#define RGB_OFFWHITE	    6
#define RGB_BLUEISHWHITE    7
#define RGB_BLUE	    8
#define RGB_DARKBLUE	    9
#define RGB_GREEN	    10
#define RGB_DARKGREEN	    11
#define RGB_RED		    12
#define RGB_DARKRED	    13
#define RGB_YELLOW	    14
#define RGB_DARKYELLOW	    15
#define RGB_MAGENTA	    16
#define RGB_CYAN	    17
#define RGB_BRIGHTBLUE	    18
#define RGB_PURPLE	    19
#define RGB_TURQUOISE	    20
#define RGB_ORANGE	    21
#define RGB_TURTLEGREEN	    22
#define RGB_BLUEBLACK	    23
#define RGB_NEARABYSS	    24
#define RGB_1		    25
#define RGB_2		    26
#define RGB_3		    27
#define RGB_4		    28
#define RGB_5		    29
#define RGB_6		    30
#define RGB_7		    31
#define RGB_8		    32
#define RGB_9		    33
#define RGB_10		    34
#define RGB_11		    35
#define RGB_ALICEBLUE            36
#define RGB_ANTIQUEWHITE         37
#define RGB_ANTIQUEWHITE1        38
#define RGB_ANTIQUEWHITE2        39
#define RGB_ANTIQUEWHITE3        40
#define RGB_ANTIQUEWHITE4        41
#define RGB_AQUAMARINE           42
#define RGB_AQUAMARINE1          43
#define RGB_AQUAMARINE2          44
#define RGB_AQUAMARINE3          45
#define RGB_AQUAMARINE4          46
#define RGB_AZURE                47
#define RGB_AZURE1               48
#define RGB_AZURE2               49
#define RGB_AZURE3               50
#define RGB_AZURE4               51
#define RGB_BEIGE                52
#define RGB_BISQUE               53
#define RGB_BISQUE1              54
#define RGB_BISQUE2              55
#define RGB_BISQUE3              56
#define RGB_BISQUE4              57
#define RGB_BLACK_               58
#define RGB_BLANCHEDALMOND       59
#define RGB_BLUE1                60
#define RGB_BLUE2                61
#define RGB_BLUE3                62
#define RGB_BLUE4                63
#define RGB_BLUEVIOLET           64
#define RGB_BROWN                65
#define RGB_BROWN1               66
#define RGB_BROWN2               67
#define RGB_BROWN3               68
#define RGB_BROWN4               69
#define RGB_BURLYWOOD            70
#define RGB_BURLYWOOD1           71
#define RGB_BURLYWOOD2           72
#define RGB_BURLYWOOD3           73
#define RGB_BURLYWOOD4           74
#define RGB_CADETBLUE            75
#define RGB_CADETBLUE1           76
#define RGB_CADETBLUE2           77
#define RGB_CADETBLUE3           78
#define RGB_CADETBLUE4           79
#define RGB_CHARTREUSE           80
#define RGB_CHARTREUSE1          81
#define RGB_CHARTREUSE2          82
#define RGB_CHARTREUSE3          83
#define RGB_CHARTREUSE4          84
#define RGB_CHOCOLATE            85
#define RGB_CHOCOLATE1           86
#define RGB_CHOCOLATE2           87
#define RGB_CHOCOLATE3           88
#define RGB_CHOCOLATE4           89
#define RGB_CORAL                90
#define RGB_CORAL1               91
#define RGB_CORAL2               92
#define RGB_CORAL3               93
#define RGB_CORAL4               94
#define RGB_CORNFLOWERBLUE       95
#define RGB_CORNSILK             96
#define RGB_CORNSILK1            97
#define RGB_CORNSILK2            98
#define RGB_CORNSILK3            99
#define RGB_CORNSILK4           100
#define RGB_CYAN1               101
#define RGB_CYAN2               102
#define RGB_CYAN3		103
#define RGB_CYAN4		104
#define RGB_DARKGOLDENROD4	105
#define RGB_DARKERGREEN		106
#define RGB_DARKKHAKI		107
#define RGB_DARKOLIVEGREEN	108
#define RGB_DARKOLIVEGREEN1	109
#define RGB_DARKOLIVEGREEN2	110
#define RGB_DARKOLIVEGREEN3	111
#define RGB_DARKOLIVEGREEN4	112
#define RGB_DARKORANGE		113
#define RGB_DARKORANGE1		114
#define RGB_DARKORANGE2		115
#define RGB_DARKORANGE3		116
#define RGB_DARKORANGE4		117
#define RGB_DARKORCHID		118
#define RGB_DARKORCHID1		119
#define RGB_DARKORCHID2		120
#define RGB_DARKORCHID3		121
#define RGB_DARKORCHID4		122
#define RGB_DARKSALMON		123
#define RGB_DARKSEAGREEN	124
#define RGB_DARKSEAGREEN1	125
#define RGB_DARKSEAGREEN2	126
#define RGB_DARKSEAGREEN3	127
#define RGB_DARKSEAGREEN4	128
#define RGB_DARKSLATEBLUE	129
#define RGB_DARKSLATEGRAY	130
#define RGB_DARKSLATEGRAY1	131
#define RGB_DARKSLATEGRAY2	132
#define RGB_DARKSLATEGRAY3	133
#define RGB_DARKSLATEGRAY4	134
#define RGB_DARKSLATEGREY	135
#define RGB_DARKTURQUOISE	136
#define RGB_DARKVIOLET		137
#define RGB_DEEPPINK		138
#define RGB_DEEPPINK1		139
#define RGB_DEEPPINK2		140
#define RGB_DEEPPINK3		141
#define RGB_DEEPPINK4		142
#define RGB_DEEPSKYBLUE		143
#define RGB_DEEPSKYBLUE1	144
#define RGB_DEEPSKYBLUE2	145
#define RGB_DEEPSKYBLUE3	146
#define RGB_DEEPSKYBLUE4	147
#define RGB_DIMGRAY		148
#define RGB_DIMGREY		149
#define RGB_DODGERBLUE		150
#define RGB_DODGERBLUE1		151
#define RGB_DODGERBLUE2		152
#define RGB_DODGERBLUE3		153
#define RGB_DODGERBLUE4		154
#define RGB_FIREBRICK		155
#define RGB_FIREBRICK1		156
#define RGB_FIREBRICK2		157
#define RGB_FIREBRICK3		158
#define RGB_FIREBRICK4		159
#define RGB_FLORALWHITE		160
#define RGB_FORESTGREEN		161
#define RGB_GAINSBORO		162
#define RGB_GHOSTWHITE		163
#define RGB_GOLD		164
#define RGB_GOLD1		165
#define RGB_GOLD2		166
#define RGB_GOLD3		167
#define RGB_GOLD4		168
#define RGB_GOLDENROD		169
#define RGB_GOLDENROD1		170
#define RGB_GOLDENROD2		171
#define RGB_GOLDENROD3		172
#define RGB_GOLDENROD4		173
#define RGB_GREY_		174
#define RGB_GREY0		175
#define RGB_GREY1		176
#define RGB_GREY2		177
#define RGB_GREY3		178
#define RGB_GREY4		179
#define RGB_GREY5		180
#define RGB_GREY6		181
#define RGB_GREY7		182
#define RGB_GREY8		183
#define RGB_GREY9		184
#define RGB_GREY10		185
#define RGB_GREY11		186
#define RGB_GREY12		187
#define RGB_GREY13		188
#define RGB_GREY14		189
#define RGB_GREY15		190
#define RGB_GREY16		191
#define RGB_GREY17		192
#define RGB_GREY18		193
#define RGB_GREY19		194
#define RGB_GREY20		195
#define RGB_GREY21		196
#define RGB_GREY22		197
#define RGB_GREY23		198
#define RGB_GREY24		199
#define RGB_GREY25		200
#define RGB_GREY26		201
#define RGB_GREY27		202
#define RGB_GREY28		203
#define RGB_GREY29		204
#define RGB_GREY30		205
#define RGB_GREY31		206
#define RGB_GREY32		207
#define RGB_GREY33		208
#define RGB_GREY34		209
#define RGB_GREY35		210
#define RGB_GREY36		211
#define RGB_GREY37		212
#define RGB_GREY38		213
#define RGB_GREY39		214
#define RGB_GREY40		215
#define RGB_GREY41		216
#define RGB_GREY42		217
#define RGB_GREY43		218
#define RGB_GREY44		219
#define RGB_GREY45		220
#define RGB_GREY46		221
#define RGB_GREY47		222
#define RGB_GREY48		223
#define RGB_GREY49		224
#define RGB_GREY50		225
#define RGB_GREY51		226
#define RGB_GREY52		227
#define RGB_GREY53		228
#define RGB_GREY54		229
#define RGB_GREY55		230
#define RGB_GREY56		231
#define RGB_GREY57		232
#define RGB_GREY58		233
#define RGB_GREY59		234
#define RGB_GREY60		235
#define RGB_GREY61		236
#define RGB_GREY62		237
#define RGB_GREY63		238
#define RGB_GREY64		239
#define RGB_GREY65		240
#define RGB_GREY66		241
#define RGB_GREY67		242
#define RGB_GREY68		243
#define RGB_GREY69		244
#define RGB_GREY70		245
#define RGB_GREY71		246
#define RGB_GREY72		247
#define RGB_GREY73		248
#define RGB_GREY74		249
#define RGB_GREY75		250
#define RGB_GREY76		251
#define RGB_GREY77		252
#define RGB_GREY78		253
#define RGB_GREY79		254
#define RGB_GREY80		255
#define RGB_GREY81		256
#define RGB_GREY82		257
#define RGB_GREY83		258
#define RGB_GREY84		259
#define RGB_GREY85		260
#define RGB_GREY86		261
#define RGB_GREY87		262
#define RGB_GREY88		263
#define RGB_GREY89		264
#define RGB_GREY90		265
#define RGB_GREY91		266
#define RGB_GREY92		267
#define RGB_GREY93		268
#define RGB_GREY94		269
#define RGB_GREY95		270
#define RGB_GREY96		271
#define RGB_GREY97		272
#define RGB_GREY98		273
#define RGB_GREY99		274
#define RGB_GREY100		275
#define RGB_GREEN1		276
#define RGB_GREEN2		277
#define RGB_GREEN3		278
#define RGB_GREEN4		279
#define RGB_GREENYELLOW		280
#define RGB_HONEYDEW		281
#define RGB_HONEYDEW1		282
#define RGB_HONEYDEW2		283
#define RGB_HONEYDEW3		284
#define RGB_HONEYDEW4		285
#define RGB_HOTPINK		286
#define RGB_HOTPINK1		287
#define RGB_HOTPINK2		288
#define RGB_HOTPINK3		289
#define RGB_HOTPINK4		290
#define RGB_INDIANRED		291
#define RGB_INDIANRED1		292
#define RGB_INDIANRED2		293
#define RGB_INDIANRED3		294
#define RGB_INDIANRED4		295
#define RGB_IVORY		296
#define RGB_IVORY1		297
#define RGB_IVORY2		298
#define RGB_IVORY3		299
#define RGB_IVORY4		300
#define RGB_KHAKI		301
#define RGB_KHAKI1		302
#define RGB_KHAKI2		303
#define RGB_KHAKI3		304
#define RGB_KHAKI4		305
#define RGB_LAVENDER		306
#define RGB_LAVENDERBLUSH	307
#define RGB_LAVENDERBLUSH1	308
#define RGB_LAVENDERBLUSH2	309
#define RGB_LAVENDERBLUSH3	310
#define RGB_LAVENDERBLUSH4	311
#define RGB_LAWNGREEN		312
#define RGB_LEMONCHIFFON	313
#define RGB_LEMONCHIFFON1	314
#define RGB_LEMONCHIFFON2	315
#define RGB_LEMONCHIFFON3	316
#define RGB_LEMONCHIFFON4	317
#define RGB_LIGHTBLUE		318
#define RGB_LIGHTBLUE1		319
#define RGB_LIGHTBLUE2		320
#define RGB_LIGHTBLUE3		321
#define RGB_LIGHTBLUE4		322
#define RGB_LIGHTCORAL		323
#define RGB_LIGHTCYAN		324
#define RGB_LIGHTCYAN1		325
#define RGB_LIGHTCYAN2		326
#define RGB_LIGHTCYAN3		327
#define RGB_LIGHTCYAN4		328
#define RGB_LIGHTGOLDENROD	329
#define RGB_LIGHTGOLDENROD1	330
#define RGB_LIGHTGOLDENROD2	331
#define RGB_LIGHTGOLDENROD3	332
#define RGB_LIGHTGOLDENROD4	333
#define RGB_LIGHTGOLDENRODYELLOW	334
#define RGB_LIGHTGRAY		335
#define RGB_LIGHTGREY		336
#define RGB_LIGHTPINK		337
#define RGB_LIGHTPINK1		338
#define RGB_LIGHTPINK2		339
#define RGB_LIGHTPINK3		340
#define RGB_LIGHTPINK4		341
#define RGB_LIGHTSALMON		342
#define RGB_LIGHTSALMON1	343
#define RGB_LIGHTSALMON2	344
#define RGB_LIGHTSALMON3	345
#define RGB_LIGHTSALMON4	346
#define RGB_LIGHTSEAGREEN	347
#define RGB_LIGHTSKYBLUE	348
#define RGB_LIGHTSKYBLUE1	349
#define RGB_LIGHTSKYBLUE2	350
#define RGB_LIGHTSKYBLUE3	351
#define RGB_LIGHTSKYBLUE4	352
#define RGB_LIGHTSLATEBLUE	353
#define RGB_LIGHTSLATEGRAY	354
#define RGB_LIGHTSLATEGREY	355
#define RGB_LIGHTSTEELBLUE	356
#define RGB_LIGHTSTEELBLUE1	357
#define RGB_LIGHTSTEELBLUE2	358
#define RGB_LIGHTSTEELBLUE3	359
#define RGB_LIGHTSTEELBLUE4	360
#define RGB_LIGHTYELLOW		361
#define RGB_LIGHTYELLOW1	362
#define RGB_LIGHTYELLOW2	363
#define RGB_LIGHTYELLOW3	364
#define RGB_LIGHTYELLOW4	365
#define RGB_LIMEGREEN		366
#define RGB_LINEN		367
#define RGB_MAGENTA1		368
#define RGB_MAGENTA2		369
#define RGB_MAGENTA3		370
#define RGB_MAGENTA4		371
#define RGB_MAROON		372
#define RGB_MAROON1		373
#define RGB_MAROON2		374
#define RGB_MAROON3		375
#define RGB_MAROON4		376
#define RGB_MEDIUMAQUAMARINE	377
#define RGB_MEDIUMBLUE		378
#define RGB_MEDIUMORCHID	379
#define RGB_MEDIUMORCHID1	380
#define RGB_MEDIUMORCHID2	381
#define RGB_MEDIUMORCHID3	382
#define RGB_MEDIUMORCHID4	383
#define RGB_MEDIUMPURPLE	384
#define RGB_MEDIUMPURPLE1	385
#define RGB_MEDIUMPURPLE2	386
#define RGB_MEDIUMPURPLE3	387
#define RGB_MEDIUMPURPLE4	388
#define RGB_MEDIUMSEAGREEN	389
#define RGB_MEDIUMSLATEBLUE	390
#define RGB_MEDIUMSPRINGGREEN	391
#define RGB_MEDIUMTURQUOISE	392
#define RGB_MEDIUMVIOLETRED	393
#define RGB_MIDNIGHTBLUE	394
#define RGB_MINTCREAM		395
#define RGB_MISTYROSE		396
#define RGB_MISTYROSE1		397
#define RGB_MISTYROSE2		398
#define RGB_MISTYROSE3		399
#define RGB_MISTYROSE4		400
#define RGB_MOCCASIN		401
#define RGB_NAVAJOWHITE		402
#define RGB_NAVAJOWHITE1	403
#define RGB_NAVAJOWHITE2	404
#define RGB_NAVAJOWHITE3	405
#define RGB_NAVAJOWHITE4	406
#define RGB_OLDLACE		407
#define RGB_OLIVEDRAB		408
#define RGB_OLIVEDRAB1		409
#define RGB_OLIVEDRAB2		410
#define RGB_OLIVEDRAB3		411
#define RGB_OLIVEDRAB4		412
#define RGB_ORANGE1		413
#define RGB_ORANGE2		414
#define RGB_ORANGE3		415
#define RGB_ORANGE4		416
#define RGB_ORANGERED		417
#define RGB_ORANGERED1		418
#define RGB_ORANGERED2		419
#define RGB_ORANGERED3		420
#define RGB_ORANGERED4		421
#define RGB_ORCHID		422
#define RGB_ORCHID1		423
#define RGB_ORCHID2		424
#define RGB_ORCHID3		425
#define RGB_ORCHID4		426
#define RGB_PALEGOLDENROD	427
#define RGB_PALEGREEN		428
#define RGB_PALEGREEN1		429
#define RGB_PALEGREEN2		430
#define RGB_PALEGREEN3		431
#define RGB_PALETURQUOISE1	432
#define RGB_PALETURQUOISE2	433
#define RGB_PALETURQUOISE3	434
#define RGB_PALETURQUOISE4	435
#define RGB_PALEVIOLETRED	436
#define RGB_PALEVIOLETRED1	437
#define RGB_PALEVIOLETRED2	438
#define RGB_PALEVIOLETRED3	439
#define RGB_PALEVIOLETRED4	440
#define RGB_PAPAYAWHIP		441
#define RGB_PEACHPUFF		442
#define RGB_PEACHPUFF1		443
#define RGB_PEACHPUFF2		444
#define RGB_PEACHPUFF3		445
#define RGB_PEACHPUFF4		446
#define RGB_PERU		447
#define RGB_PINK		448
#define RGB_PINK1		449
#define RGB_PINK2		450
#define RGB_PINK3		451
#define RGB_PINK4		452
#define RGB_PLUM		453
#define RGB_PLUM1		454
#define RGB_PLUM2		455
#define RGB_PLUM3		456
#define RGB_PLUM4		457
#define RGB_POWDERBLUE		458
#define RGB_PURPLE1		459
#define RGB_PURPLE2		460
#define RGB_PURPLE3		461
#define RGB_PURPLE4		462
#define RGB_RED1		463
#define RGB_RED2		464
#define RGB_RED3		465
#define RGB_RED4		466
#define RGB_ROSYBROWN		467
#define RGB_ROSYBROWN1		468
#define RGB_ROSYBROWN2		469
#define RGB_ROSYBROWN3		470
#define RGB_ROSYBROWN4		471
#define RGB_ROYALBLUE		472
#define RGB_ROYALBLUE1		473
#define RGB_ROYALBLUE2		474
#define RGB_ROYALBLUE3		475
#define RGB_ROYALBLUE4		476
#define RGB_SADDLEBROWN		477
#define RGB_SALMON		478
#define RGB_SALMON1		479
#define RGB_SALMON2		480
#define RGB_SALMON3		481
#define RGB_SALMON4		482
#define RGB_SANDYBROWN		483
#define RGB_SEAGREEN		484
#define RGB_SEAGREEN1		485
#define RGB_SEAGREEN2		486
#define RGB_SEAGREEN3		487
#define RGB_SEAGREEN4		488
#define RGB_SEASHELL		489
#define RGB_SEASHELL1		490
#define RGB_SEASHELL2		491
#define RGB_SEASHELL3		492
#define RGB_SEASHELL4		493
#define RGB_SIENNA		494
#define RGB_SIENNA1		495
#define RGB_SIENNA2		496
#define RGB_SIENNA3		497
#define RGB_SIENNA4		498
#define RGB_SKYBLUE		499
#define RGB_SKYBLUE1		500
#define RGB_SKYBLUE2		501
#define RGB_SKYBLUE3		502
#define RGB_SKYBLUE4		503
#define RGB_SLATEBLUE		504
#define RGB_SLATEBLUE1		505
#define RGB_SLATEBLUE2		506
#define RGB_SLATEBLUE3		507
#define RGB_SLATEBLUE4		508
#define RGB_SLATEGRAY		509
#define RGB_SLATEGRAY1		510
#define RGB_SLATEGRAY2		511
#define RGB_SLATEGRAY3		512
#define RGB_SLATEGRAY4		513
#define RGB_SLATEGREY		514
#define RGB_SNOW		515
#define RGB_SNOW1		516
#define RGB_SNOW2		517
#define RGB_SNOW3		518
#define RGB_SNOW4		519
#define RGB_SPRINGGREEN		520
#define RGB_SPRINGGREEN1	521
#define RGB_SPRINGGREEN2	522
#define RGB_SPRINGGREEN3	523
#define RGB_SPRINGGREEN4	524
#define RGB_STEELBLUE		525
#define RGB_STEELBLUE1		526
#define RGB_STEELBLUE2		527
#define RGB_STEELBLUE3		528
#define RGB_STEELBLUE4		529
#define RGB_TAN	        	530
#define RGB_TAN1		531
#define RGB_TAN2		532
#define RGB_TAN3		533
#define RGB_TAN4		534
#define RGB_THISTLE		535
#define RGB_THISTLE1		536
#define RGB_THISTLE2		537
#define RGB_THISTLE3		538
#define RGB_THISTLE4		539
#define RGB_TOMATO		540
#define RGB_TOMATO1		541
#define RGB_TOMATO2		542
#define RGB_TOMATO3		543
#define RGB_TOMATO4		544
#define RGB_TURQUOISE1		545
#define RGB_TURQUOISE2		546
#define RGB_TURQUOISE3		547
#define RGB_TURQUOISE4		548
#define RGB_VIOLET		549
#define RGB_VIOLETRED		550
#define RGB_VIOLETRED1		551
#define RGB_VIOLETRED2		552
#define RGB_VIOLETRED3		553
#define RGB_VIOLETRED4		554
#define RGB_WHEAT		555
#define RGB_WHEAT1		556
#define RGB_WHEAT2		557
#define RGB_WHEAT3		558
#define RGB_WHEAT4		559
#define RGB_WHITESMOKE		560
#define RGB_YELLOW1		561
#define RGB_YELLOW2		562
#define RGB_YELLOW3		563
#define RGB_YELLOW4		564
#define RGB_YELLOWGREEN		565

extern long num_colors;

#define NUM_COLORS 512
extern int random_index_table[NUM_COLORS];

#define NUM_DCOLORS 14
extern int determ_index_table[NUM_DCOLORS];

extern COLORDEF fixed_color_table[];
#define DCOLOR(id) c3f(fixed_color_table[id].drgba)	    /* needs lmcolor (LMC_AD) to work */
#define SCOLOR(id) c3f(fixed_color_table[id].srgba)	    /* needs lmcolor (LMC_SPECULAR) to work */
/* #define COLOR(id) SCOLOR(id) */
#define COLOR(id) lmcolor(LMC_AD), DCOLOR(id), lmcolor(LMC_SPECULAR), SCOLOR(id) 
#define RCOLOR(col) lmcolor(LMC_AD), cpack(col), lmcolor(LMC_SPECULAR), cpack(col)
#define CPACKDATA(id) (fixed_color_table[id].cpackdata)
#define CPACK(id) cpack(CPACKDATA(id))

#define RANDOMCOLORID(id) (random_index_table[(id) % NUM_COLORS])
#define RANDOMCOLOR(id) COLOR(RANDOMCOLORID(id))

/* deterministic color */
#define DETERMCOLORID(id) (determ_index_table[(id) % NUM_DCOLORS])
#define DETERMCOLOR(id) COLOR(determ_index_table[(id) % NUM_COLORS])

extern int
init_color();

extern long
lerp_color(
    long p,
    long q,
    float t);


