#include <stdio.h>
#include "color.h"

int random_index_table[NUM_COLORS];

int determ_index_table[NUM_DCOLORS] = {
	RGB_ABYSS,
	RGB_RED,
	RGB_GREEN,
	RGB_YELLOW,
	RGB_BLUE,
	RGB_MAGENTA,
	RGB_CYAN,
	RGB_WHITE,
	RGB_PINK,
	RGB_ORANGE,
	RGB_DARKGREEN,
	RGB_GREY,
	RGB_BROWN,
	RGB_CHARTREUSE};

COLORDEF fixed_color_table[] =	{
    { RGB_ABYSS,	"none",	  	    (long)0x00000000 },
    { RGB_ABYSS,	"abyss",	    (long)0x80000000 },
    { RGB_OFFABYSS,	"offabyss",	    (long)0x80353030 },
    { RGB_BLACK,	"black",	    (long)0x80808080 },
    { RGB_GREY,	    	"grey",		    (long)0x80e0e0e0 },
    { RGB_FLATGREY,	"flatgrey",	    (long)0x80808080 },
    { RGB_WHITE,	"white",	    (long)0x80FFFFFF },
    { RGB_OFFWHITE,	"offwhite",	    (long)0x80CCCCCC },
    { RGB_BLUEISHWHITE,	"blueishwhite",	    (long)0x80FFCCCC },
    { RGB_BLUE,		"blue",		    (long)0x80FF0000 },
    { RGB_DARKBLUE,	"darkblue",	    (long)0x80c00000 },
    { RGB_GREEN,	"green",	    (long)0x8000FF00 },
    { RGB_DARKGREEN,	"darkgreen",	    (long)0x8000c000 },
    { RGB_RED,	    	"red",		    (long)0x800000FF },
    { RGB_DARKRED,	"darkred",	    (long)0x80000080 },
    { RGB_YELLOW,	"yellow",	    (long)0x8000FFFF },
    { RGB_DARKYELLOW,	"darkyellow",	    (long)0x8000b0b0 },
    { RGB_MAGENTA,	"magenta",	    (long)0x80FF00FF },
    { RGB_CYAN,		"cyan",		    (long)0x80FFFF00 },
    { RGB_BRIGHTBLUE,	"brightblue",	    (long)0x80FFC000 },
    { RGB_PURPLE,	"purple",	    (long)0x80FF80C0 },
    { RGB_TURQUOISE,	"turquoise",	    (long)0x80C0C040 },
    { RGB_ORANGE,	"orange",	    (long)0x800080FF },
    { RGB_TURTLEGREEN,	"turtlegreen",	    (long)0x80466C46 },
    { RGB_BLUEBLACK,	"blueblack",	    (long)0x8030100A },
    { RGB_NEARABYSS,	"nearabyss",	    (long)0x80101010 },
    { RGB_1,		"1",		    (long)0x80C800C8 },
    { RGB_2,		"2",		    (long)0x80B0D056 },
    { RGB_3,		"3",		    (long)0x80C80030 },
    { RGB_4,		"4",		    (long)0x804040C8 },
    { RGB_5,		"5",		    (long)0x80708858 },
    { RGB_6,		"6",		    (long)0x80A08060 },
    { RGB_7,		"7",		    (long)0x8000B0FF },
    { RGB_8,		"8",		    (long)0x80FFFF80 },
    { RGB_9,		"9",		    (long)0x80808000 },
    { RGB_10,		"10",		    (long)0x803000C8 },
    { RGB_11,		"11",		    (long)0x80FF7070 },

    { RGB_ALICEBLUE, 		"aliceblue", 	(long)0x8000f8f0 },
    { RGB_ANTIQUEWHITE, 	"antiquewhite", 	(long)0x8000ebfa },
    { RGB_ANTIQUEWHITE1, 	"antiquewhite1", 	(long)0x8000efff },
    { RGB_ANTIQUEWHITE2, 	"antiquewhite2", 	(long)0x8000dfee },
    { RGB_ANTIQUEWHITE3, 	"antiquewhite3", 	(long)0x8000c0cd },
    { RGB_ANTIQUEWHITE4, 	"antiquewhite4", 	(long)0x8000838b },
    { RGB_AQUAMARINE, 		"aquamarine", 	(long)0x8000ff7f },
    { RGB_AQUAMARINE1, 		"aquamarine1", 	(long)0x8000ff7f },
    { RGB_AQUAMARINE2, 		"aquamarine2", 	(long)0x8000ee76 },
    { RGB_AQUAMARINE3, 		"aquamarine3", 	(long)0x8000cd66 },
    { RGB_AQUAMARINE4, 		"aquamarine4", 	(long)0x80008b45 },
    { RGB_AZURE, 		"azure", 	(long)0x8000fff0 },
    { RGB_AZURE1, 		"azure1", 	(long)0x8000fff0 },
    { RGB_AZURE2, 		"azure2", 	(long)0x8000eee0 },
    { RGB_AZURE3, 		"azure3", 	(long)0x8000cdc1 },
    { RGB_AZURE4, 		"azure4", 	(long)0x80008b83 },
    { RGB_BEIGE, 		"beige", 	(long)0x8000f5f5 },
    { RGB_BISQUE, 		"bisque", 	(long)0x8000e4ff },
    { RGB_BISQUE1, 		"bisque1", 	(long)0x8000e4ff },
    { RGB_BISQUE2, 		"bisque2", 	(long)0x8000d5ee },
    { RGB_BISQUE3, 		"bisque3", 	(long)0x8000b7cd },
    { RGB_BISQUE4, 		"bisque4", 	(long)0x80007d8b },
    { RGB_BLACK_,	        "black",        (long)0x80808080 },
    { RGB_BLANCHEDALMOND, 	"blanchedalmond", 	(long)0x8000ebff },
    { RGB_BLUE1, 		"blue1", 	(long)0x80000000 },
    { RGB_BLUE2, 		"blue2", 	(long)0x80000000 },
    { RGB_BLUE3, 		"blue3", 	(long)0x80000000 },
    { RGB_BLUE4, 		"blue4", 	(long)0x80000000 },
    { RGB_BLUEVIOLET, 		"blueviolet", 	(long)0x80002b8a },
    { RGB_BROWN, 		"brown", 	(long)0x80002aa5 },
    { RGB_BROWN1, 		"brown1", 	(long)0x800040ff },
    { RGB_BROWN2, 		"brown2", 	(long)0x80003bee },
    { RGB_BROWN3, 		"brown3", 	(long)0x800033cd },
    { RGB_BROWN4, 		"brown4", 	(long)0x8000238b },
    { RGB_BURLYWOOD, 		"burlywood", 	(long)0x8000b8de },
    { RGB_BURLYWOOD1, 		"burlywood1", 	(long)0x8000d3ff },
    { RGB_BURLYWOOD2, 		"burlywood2", 	(long)0x8000c5ee },
    { RGB_BURLYWOOD3, 		"burlywood3", 	(long)0x8000aacd },
    { RGB_BURLYWOOD4, 		"burlywood4", 	(long)0x8000738b },
    { RGB_CADETBLUE, 		"cadetblue", 	(long)0x80009e5f },
    { RGB_CADETBLUE1, 		"cadetblue1", 	(long)0x8000f598 },
    { RGB_CADETBLUE2, 		"cadetblue2", 	(long)0x8000e58e },
    { RGB_CADETBLUE3, 		"cadetblue3", 	(long)0x8000c57a },
    { RGB_CADETBLUE4, 		"cadetblue4", 	(long)0x80008653 },
    { RGB_CHARTREUSE, 		"chartreuse", 	(long)0x8000ff7f },
    { RGB_CHARTREUSE1, 		"chartreuse1", 	(long)0x8000ff7f },
    { RGB_CHARTREUSE2, 		"chartreuse2", 	(long)0x8000ee76 },
    { RGB_CHARTREUSE3, 		"chartreuse3", 	(long)0x8000cd66 },
    { RGB_CHARTREUSE4, 		"chartreuse4", 	(long)0x80008b45 },
    { RGB_CHOCOLATE, 		"chocolate", 	(long)0x800069d2 },
    { RGB_CHOCOLATE1, 		"chocolate1", 	(long)0x80007fff },
    { RGB_CHOCOLATE2, 		"chocolate2", 	(long)0x800076ee },
    { RGB_CHOCOLATE3, 		"chocolate3", 	(long)0x800066cd },
    { RGB_CHOCOLATE4, 		"chocolate4", 	(long)0x8000458b },
    { RGB_CORAL, 		"coral", 	(long)0x80007fff },
    { RGB_CORAL1, 		"coral1", 	(long)0x800072ff },
    { RGB_CORAL2, 		"coral2", 	(long)0x80006aee },
    { RGB_CORAL3, 		"coral3", 	(long)0x80005bcd },
    { RGB_CORAL4, 		"coral4", 	(long)0x80003e8b },
    { RGB_CORNFLOWERBLUE, 	"cornflowerblue", 	(long)0x80009564 },
    { RGB_CORNSILK, 		"cornsilk", 	(long)0x8000f8ff },
    { RGB_CORNSILK1, 		"cornsilk1", 	(long)0x8000f8ff },
    { RGB_CORNSILK2, 		"cornsilk2", 	(long)0x8000e8ee },
    { RGB_CORNSILK3, 		"cornsilk3", 	(long)0x8000c8cd },
    { RGB_CORNSILK4, 		"cornsilk4", 	(long)0x8000888b },
    { RGB_CYAN1, 		"cyan1", 	(long)0x8000ff00 },
    { RGB_CYAN2, 		"cyan2", 	(long)0x8000ee00 },
    { RGB_CYAN3, 		"cyan3", 	(long)0x8000cd00 },
    { RGB_CYAN4, 		"cyan4", 	(long)0x80008b00 },
    { RGB_DARKGOLDENROD4, 	"darkgoldenrod4", 	(long)0x8000658b },
    { RGB_DARKERGREEN, 		"darkergreen", 	(long)0x80006400 },
    { RGB_DARKKHAKI, 		"darkkhaki", 	(long)0x8000b7bd },
    { RGB_DARKOLIVEGREEN, 	"darkolivegreen", 	(long)0x80006b55 },
    { RGB_DARKOLIVEGREEN1, 	"darkolivegreen1", 	(long)0x8000ffca },
    { RGB_DARKOLIVEGREEN2, 	"darkolivegreen2", 	(long)0x8000eebc },
    { RGB_DARKOLIVEGREEN3, 	"darkolivegreen3", 	(long)0x8000cda2 },
    { RGB_DARKOLIVEGREEN4, 	"darkolivegreen4", 	(long)0x80008b6e },
    { RGB_DARKORANGE, 		"darkorange", 	(long)0x80008cff },
    { RGB_DARKORANGE1, 		"darkorange1", 	(long)0x80007fff },
    { RGB_DARKORANGE2, 		"darkorange2", 	(long)0x800076ee },
    { RGB_DARKORANGE3, 		"darkorange3", 	(long)0x800066cd },
    { RGB_DARKORANGE4, 		"darkorange4", 	(long)0x8000458b },
    { RGB_DARKORCHID, 		"darkorchid", 	(long)0x80003299 },
    { RGB_DARKORCHID1, 		"darkorchid1", 	(long)0x80003ebf },
    { RGB_DARKORCHID2, 		"darkorchid2", 	(long)0x80003ab2 },
    { RGB_DARKORCHID3, 		"darkorchid3", 	(long)0x8000329a },
    { RGB_DARKORCHID4, 		"darkorchid4", 	(long)0x80002268 },
    { RGB_DARKSALMON, 		"darksalmon", 	(long)0x800096e9 },
    { RGB_DARKSEAGREEN,		"darkseagreen", 	(long)0x8000bc8f },
    { RGB_DARKSEAGREEN1, 	"darkseagreen1", 	(long)0x8000ffc1 },
    { RGB_DARKSEAGREEN2, 	"darkseagreen2", 	(long)0x8000eeb4 },
    { RGB_DARKSEAGREEN3, 	"darkseagreen3", 	(long)0x8000cd9b },
    { RGB_DARKSEAGREEN4, 	"darkseagreen4", 	(long)0x80008b69 },
    { RGB_DARKSLATEBLUE, 	"darkslateblue", 	(long)0x80003d48 },
    { RGB_DARKSLATEGRAY, 	"darkslategray", 	(long)0x80004f2f },
    { RGB_DARKSLATEGRAY1, 	"darkslategray1", 	(long)0x8000ff97 },
    { RGB_DARKSLATEGRAY2, 	"darkslategray2", 	(long)0x8000ee8d },
    { RGB_DARKSLATEGRAY3, 	"darkslategray3", 	(long)0x8000cd79 },
    { RGB_DARKSLATEGRAY4, 	"darkslategray4", 	(long)0x80008b52 },
    { RGB_DARKSLATEGREY, 	"darkslategrey", 	(long)0x80004f2f },
    { RGB_DARKTURQUOISE, 	"darkturquoise", 	(long)0x8000ce00 },
    { RGB_DARKVIOLET, 		"darkviolet", 	(long)0x80000094 },
    { RGB_DEEPPINK, 		"deeppink", 	(long)0x800014ff },
    { RGB_DEEPPINK1, 		"deeppink1", 	(long)0x800014ff },
    { RGB_DEEPPINK2, 		"deeppink2", 	(long)0x800012ee },
    { RGB_DEEPPINK3, 		"deeppink3", 	(long)0x800010cd },
    { RGB_DEEPPINK4, 		"deeppink4", 	(long)0x80000a8b },
    { RGB_DEEPSKYBLUE, 		"deepskyblue", 	(long)0x8000bf00 },
    { RGB_DEEPSKYBLUE1, 	"deepskyblue1",	(long)0x8000bf00 },
    { RGB_DEEPSKYBLUE2, 	"deepskyblue2",	(long)0x8000b200 },
    { RGB_DEEPSKYBLUE3, 	"deepskyblue3",	(long)0x80009a00 },
    { RGB_DEEPSKYBLUE4, 	"deepskyblue4",	(long)0x80006800 },
    { RGB_DIMGRAY, 		"dimgray", 	(long)0x80006969 },
    { RGB_DIMGREY, 		"dimgrey", 	(long)0x80006969 },
    { RGB_DODGERBLUE, 		"dodgerblue", 	(long)0x8000901e },
    { RGB_DODGERBLUE1, 		"dodgerblue1", 	(long)0x8000901e },
    { RGB_DODGERBLUE2, 		"dodgerblue2", 	(long)0x8000861c },
    { RGB_DODGERBLUE3, 		"dodgerblue3", 	(long)0x80007418 },
    { RGB_DODGERBLUE4, 		"dodgerblue4", 	(long)0x80004e10 },
    { RGB_FIREBRICK, 		"firebrick", 	(long)0x800022b2 },
    { RGB_FIREBRICK1, 		"firebrick1", 	(long)0x800030ff },
    { RGB_FIREBRICK2, 		"firebrick2", 	(long)0x80002cee },
    { RGB_FIREBRICK3, 		"firebrick3", 	(long)0x800026cd },
    { RGB_FIREBRICK4, 		"firebrick4", 	(long)0x80001a8b },
    { RGB_FLORALWHITE, 		"floralwhite", 	(long)0x8000faff },
    { RGB_FORESTGREEN, 		"forestgreen", 	(long)0x80008b22 },
    { RGB_GAINSBORO, 		"gainsboro", 	(long)0x8000dcdc },
    { RGB_GHOSTWHITE, 		"ghostwhite", 	(long)0x8000f8f8 },
    { RGB_GOLD, 		"gold", 	(long)0x8000d7ff },
    { RGB_GOLD1, 		"gold1", 	(long)0x8000d7ff },
    { RGB_GOLD2, 		"gold2", 	(long)0x8000c9ee },
    { RGB_GOLD3, 		"gold3", 	(long)0x8000adcd },
    { RGB_GOLD4, 		"gold4", 	(long)0x8000758b },
    { RGB_GOLDENROD, 		"goldenrod", 	(long)0x8000a5da },
    { RGB_GOLDENROD1, 		"goldenrod1", 	(long)0x8000c1ff },
    { RGB_GOLDENROD2, 		"goldenrod2", 	(long)0x8000b4ee },
    { RGB_GOLDENROD3, 		"goldenrod3", 	(long)0x80009bcd },
    { RGB_GOLDENROD4, 		"goldenrod4", 	(long)0x8000698b },
    { RGB_GREY_, 		"grey_", 	(long)0x80000000 },
    { RGB_GREY0, 		"grey0", 	(long)0x80000000 },
    { RGB_GREY1, 		"grey1", 	(long)0x80000303 },
    { RGB_GREY2, 		"grey2", 	(long)0x80000505 },
    { RGB_GREY3, 		"grey3", 	(long)0x80000808 },
    { RGB_GREY4, 		"grey4", 	(long)0x80000a0a },
    { RGB_GREY5, 		"grey5", 	(long)0x80000d0d },
    { RGB_GREY6, 		"grey6", 	(long)0x80000f0f },
    { RGB_GREY7, 		"grey7", 	(long)0x80001212 },
    { RGB_GREY8, 		"grey8", 	(long)0x80001414 },
    { RGB_GREY9, 		"grey9", 	(long)0x80001717 },
    { RGB_GREY10, 		"grey10", 	(long)0x80001a1a },
    { RGB_GREY11, 		"grey11", 	(long)0x80001c1c },
    { RGB_GREY12, 		"grey12", 	(long)0x80001f1f },
    { RGB_GREY13, 		"grey13", 	(long)0x80002121 },
    { RGB_GREY14, 		"grey14", 	(long)0x80002424 },
    { RGB_GREY15, 		"grey15", 	(long)0x80002626 },
    { RGB_GREY16, 		"grey16", 	(long)0x80002929 },
    { RGB_GREY17, 		"grey17", 	(long)0x80002b2b },
    { RGB_GREY18, 		"grey18", 	(long)0x80002e2e },
    { RGB_GREY19, 		"grey19", 	(long)0x80003030 },
    { RGB_GREY20, 		"grey20", 	(long)0x80003333 },
    { RGB_GREY21, 		"grey21", 	(long)0x80003636 },
    { RGB_GREY22, 		"grey22", 	(long)0x80003838 },
    { RGB_GREY23, 		"grey23", 	(long)0x80003b3b },
    { RGB_GREY24, 		"grey24", 	(long)0x80003d3d },
    { RGB_GREY25, 		"grey25", 	(long)0x80004040 },
    { RGB_GREY26, 		"grey26", 	(long)0x80004242 },
    { RGB_GREY27, 		"grey27", 	(long)0x80004545 },
    { RGB_GREY28, 		"grey28", 	(long)0x80004747 },
    { RGB_GREY29, 		"grey29", 	(long)0x80004a4a },
    { RGB_GREY30, 		"grey30", 	(long)0x80004d4d },
    { RGB_GREY31, 		"grey31", 	(long)0x80004f4f },
    { RGB_GREY32, 		"grey32", 	(long)0x80005252 },
    { RGB_GREY33, 		"grey33", 	(long)0x80005454 },
    { RGB_GREY34, 		"grey34", 	(long)0x80005757 },
    { RGB_GREY35, 		"grey35", 	(long)0x80005959 },
    { RGB_GREY36, 		"grey36", 	(long)0x80005c5c },
    { RGB_GREY37, 		"grey37", 	(long)0x80005e5e },
    { RGB_GREY38, 		"grey38", 	(long)0x80006161 },
    { RGB_GREY39, 		"grey39", 	(long)0x80006363 },
    { RGB_GREY40, 		"grey40", 	(long)0x80006666 },
    { RGB_GREY41, 		"grey41", 	(long)0x80006969 },
    { RGB_GREY42, 		"grey42", 	(long)0x80006b6b },
    { RGB_GREY43, 		"grey43", 	(long)0x80006e6e },
    { RGB_GREY44, 		"grey44", 	(long)0x80007070 },
    { RGB_GREY45, 		"grey45", 	(long)0x80007373 },
    { RGB_GREY46, 		"grey46", 	(long)0x80007575 },
    { RGB_GREY47, 		"grey47", 	(long)0x80007878 },
    { RGB_GREY48, 		"grey48", 	(long)0x80007a7a },
    { RGB_GREY49, 		"grey49", 	(long)0x80007d7d },
    { RGB_GREY50, 		"grey50", 	(long)0x80007f7f },
    { RGB_GREY51, 		"grey51", 	(long)0x80008282 },
    { RGB_GREY52, 		"grey52", 	(long)0x80008585 },
    { RGB_GREY53, 		"grey53", 	(long)0x80008787 },
    { RGB_GREY54, 		"grey54", 	(long)0x80008a8a },
    { RGB_GREY55, 		"grey55", 	(long)0x80008c8c },
    { RGB_GREY56, 		"grey56", 	(long)0x80008f8f },
    { RGB_GREY57, 		"grey57", 	(long)0x80009191 },
    { RGB_GREY58, 		"grey58", 	(long)0x80009494 },
    { RGB_GREY59, 		"grey59", 	(long)0x80009696 },
    { RGB_GREY60, 		"grey60", 	(long)0x80009999 },
    { RGB_GREY61, 		"grey61", 	(long)0x80009c9c },
    { RGB_GREY62, 		"grey62", 	(long)0x80009e9e },
    { RGB_GREY63, 		"grey63", 	(long)0x8000a1a1 },
    { RGB_GREY64, 		"grey64", 	(long)0x8000a3a3 },
    { RGB_GREY65, 		"grey65", 	(long)0x8000a6a6 },
    { RGB_GREY66, 		"grey66", 	(long)0x8000a8a8 },
    { RGB_GREY67, 		"grey67", 	(long)0x8000abab },
    { RGB_GREY68, 		"grey68", 	(long)0x8000adad },
    { RGB_GREY69, 		"grey69", 	(long)0x8000b0b0 },
    { RGB_GREY70, 		"grey70", 	(long)0x8000b3b3 },
    { RGB_GREY71, 		"grey71", 	(long)0x8000b5b5 },
    { RGB_GREY72, 		"grey72", 	(long)0x8000b8b8 },
    { RGB_GREY73, 		"grey73", 	(long)0x8000baba },
    { RGB_GREY74, 		"grey74", 	(long)0x8000bdbd },
    { RGB_GREY75, 		"grey75", 	(long)0x8000bfbf },
    { RGB_GREY76, 		"grey76", 	(long)0x8000c2c2 },
    { RGB_GREY77, 		"grey77", 	(long)0x8000c4c4 },
    { RGB_GREY78, 		"grey78", 	(long)0x8000c7c7 },
    { RGB_GREY79, 		"grey79", 	(long)0x8000c9c9 },
    { RGB_GREY80, 		"grey80", 	(long)0x8000cccc },
    { RGB_GREY81, 		"grey81", 	(long)0x8000cfcf },
    { RGB_GREY82, 		"grey82", 	(long)0x8000d1d1 },
    { RGB_GREY83, 		"grey83", 	(long)0x8000d4d4 },
    { RGB_GREY84, 		"grey84", 	(long)0x8000d6d6 },
    { RGB_GREY85, 		"grey85", 	(long)0x8000d9d9 },
    { RGB_GREY86, 		"grey86", 	(long)0x8000dbdb },
    { RGB_GREY87, 		"grey87", 	(long)0x8000dede },
    { RGB_GREY88, 		"grey88", 	(long)0x8000e0e0 },
    { RGB_GREY89, 		"grey89", 	(long)0x8000e3e3 },
    { RGB_GREY90, 		"grey90", 	(long)0x8000e5e5 },
    { RGB_GREY91, 		"grey91", 	(long)0x8000e8e8 },
    { RGB_GREY92, 		"grey92", 	(long)0x8000ebeb },
    { RGB_GREY93, 		"grey93", 	(long)0x8000eded },
    { RGB_GREY94, 		"grey94", 	(long)0x8000f0f0 },
    { RGB_GREY95, 		"grey95", 	(long)0x8000f2f2 },
    { RGB_GREY96, 		"grey96", 	(long)0x8000f5f5 },
    { RGB_GREY97, 		"grey97", 	(long)0x8000f7f7 },
    { RGB_GREY98, 		"grey98", 	(long)0x8000fafa },
    { RGB_GREY99, 		"grey99", 	(long)0x8000fcfc },
    { RGB_GREY100, 		"grey100", 	(long)0x8000ffff },
    { RGB_GREEN1, 		"green1", 	(long)0x8000ff00 },
    { RGB_GREEN2, 		"green2", 	(long)0x8000ee00 },
    { RGB_GREEN3, 		"green3", 	(long)0x8000cd00 },
    { RGB_GREEN4, 		"green4", 	(long)0x80008b00 },
    { RGB_GREENYELLOW, 		"greenyellow", 	(long)0x8000ffad },
    { RGB_HONEYDEW, 		"honeydew", 	(long)0x8000fff0 },
    { RGB_HONEYDEW1, 		"honeydew1", 	(long)0x8000fff0 },
    { RGB_HONEYDEW2, 		"honeydew2", 	(long)0x8000eee0 },
    { RGB_HONEYDEW3, 		"honeydew3", 	(long)0x8000cdc1 },
    { RGB_HONEYDEW4, 		"honeydew4", 	(long)0x80008b83 },
    { RGB_HOTPINK, 		"hotpink", 	(long)0x800069ff },
    { RGB_HOTPINK1, 		"hotpink1", 	(long)0x80006eff },
    { RGB_HOTPINK2, 		"hotpink2", 	(long)0x80006aee },
    { RGB_HOTPINK3, 		"hotpink3", 	(long)0x800060cd },
    { RGB_HOTPINK4, 		"hotpink4", 	(long)0x80003a8b },
    { RGB_INDIANRED, 		"indianred", 	(long)0x80005ccd },
    { RGB_INDIANRED1, 		"indianred1", 	(long)0x80006aff },
    { RGB_INDIANRED2, 		"indianred2", 	(long)0x800063ee },
    { RGB_INDIANRED3, 		"indianred3", 	(long)0x800055cd },
    { RGB_INDIANRED4, 		"indianred4", 	(long)0x80003a8b },
    { RGB_IVORY, 		"ivory", 	(long)0x8000ffff },
    { RGB_IVORY1, 		"ivory1", 	(long)0x8000ffff },
    { RGB_IVORY2, 		"ivory2", 	(long)0x8000eeee },
    { RGB_IVORY3, 		"ivory3", 	(long)0x8000cdcd },
    { RGB_IVORY4, 		"ivory4", 	(long)0x80008b8b },
    { RGB_KHAKI, 		"khaki", 	(long)0x8000e6f0 },
    { RGB_KHAKI1, 		"khaki1", 	(long)0x8000f6ff },
    { RGB_KHAKI2, 		"khaki2", 	(long)0x8000e6ee },
    { RGB_KHAKI3, 		"khaki3", 	(long)0x8000c6cd },
    { RGB_KHAKI4, 		"khaki4", 	(long)0x8000868b },
    { RGB_LAVENDER, 		"lavender", 	(long)0x8000e6e6 },
    { RGB_LAVENDERBLUSH, 	"lavenderblush", 	(long)0x8000f0ff },
    { RGB_LAVENDERBLUSH1, 	"lavenderblush1", 	(long)0x8000f0ff },
    { RGB_LAVENDERBLUSH2, 	"lavenderblush2", 	(long)0x8000e0ee },
    { RGB_LAVENDERBLUSH3, 	"lavenderblush3", 	(long)0x8000c1cd },
    { RGB_LAVENDERBLUSH4, 	"lavenderblush4", 	(long)0x8000838b },
    { RGB_LAWNGREEN, 		"lawngreen", 	(long)0x8000fc7c },
    { RGB_LEMONCHIFFON, 	"lemonchiffon", 	(long)0x8000faff },
    { RGB_LEMONCHIFFON1, 	"lemonchiffon1", 	(long)0x8000faff },
    { RGB_LEMONCHIFFON2, 	"lemonchiffon2", 	(long)0x8000e9ee },
    { RGB_LEMONCHIFFON3, 	"lemonchiffon3", 	(long)0x8000c9cd },
    { RGB_LEMONCHIFFON4, 	"lemonchiffon4", 	(long)0x8000898b },
    { RGB_LIGHTBLUE, 		"lightblue", 	(long)0x8000d8ad },
    { RGB_LIGHTBLUE1, 		"lightblue1", 	(long)0x8000efbf },
    { RGB_LIGHTBLUE2, 		"lightblue2", 	(long)0x8000dfb2 },
    { RGB_LIGHTBLUE3, 		"lightblue3", 	(long)0x8000c09a },
    { RGB_LIGHTBLUE4, 		"lightblue4", 	(long)0x80008368 },
    { RGB_LIGHTCORAL, 		"lightcoral", 	(long)0x800080f0 },
    { RGB_LIGHTCYAN, 		"lightcyan", 	(long)0x8000ffe0 },
    { RGB_LIGHTCYAN1, 		"lightcyan1", 	(long)0x8000ffe0 },
    { RGB_LIGHTCYAN2, 		"lightcyan2", 	(long)0x8000eed1 },
    { RGB_LIGHTCYAN3, 		"lightcyan3", 	(long)0x8000cdb4 },
    { RGB_LIGHTCYAN4, 		"lightcyan4", 	(long)0x80008b7a },
    { RGB_LIGHTGOLDENROD, 	"lightgoldenrod", 	(long)0x8000ddee },
    { RGB_LIGHTGOLDENROD1, 	"lightgoldenrod1", 	(long)0x8000ecff },
    { RGB_LIGHTGOLDENROD2, 	"lightgoldenrod2", 	(long)0x8000dcee },
    { RGB_LIGHTGOLDENROD3, 	"lightgoldenrod3", 	(long)0x8000becd },
    { RGB_LIGHTGOLDENROD4, 	"lightgoldenrod4", 	(long)0x8000818b },
    { RGB_LIGHTGOLDENRODYELLOW, "lightgoldenrodyellow", 	(long)0x8000fafa },
    { RGB_LIGHTGRAY, 		"lightgray", 	(long)0x8000d3d3 },
    { RGB_LIGHTGREY, 		"lightgrey", 	(long)0x8000d3d3 },
    { RGB_LIGHTPINK, 		"lightpink", 	(long)0x8000b6ff },
    { RGB_LIGHTPINK1, 		"lightpink1", 	(long)0x8000aeff },
    { RGB_LIGHTPINK2, 		"lightpink2", 	(long)0x8000a2ee },
    { RGB_LIGHTPINK3, 		"lightpink3", 	(long)0x80008ccd },
    { RGB_LIGHTPINK4, 		"lightpink4", 	(long)0x80005f8b },
    { RGB_LIGHTSALMON, 		"lightsalmon", 	(long)0x8000a0ff },
    { RGB_LIGHTSALMON1, 	"lightsalmon1", 	(long)0x8000a0ff },
    { RGB_LIGHTSALMON2, 	"lightsalmon2", 	(long)0x800095ee },
    { RGB_LIGHTSALMON3, 	"lightsalmon3", 	(long)0x800081cd },
    { RGB_LIGHTSALMON4, 	"lightsalmon4", 	(long)0x8000578b },
    { RGB_LIGHTSEAGREEN, 	"lightseagreen", 	(long)0x8000b220 },
    { RGB_LIGHTSKYBLUE, 	"lightskyblue", 	(long)0x8000ce87 },
    { RGB_LIGHTSKYBLUE1, 	"lightskyblue1", 	(long)0x8000e2b0 },
    { RGB_LIGHTSKYBLUE2, 	"lightskyblue2", 	(long)0x8000d3a4 },
    { RGB_LIGHTSKYBLUE3, 	"lightskyblue3", 	(long)0x8000b68d },
    { RGB_LIGHTSKYBLUE4, 	"lightskyblue4", 	(long)0x80007b60 },
    { RGB_LIGHTSLATEBLUE, 	"lightslateblue", 	(long)0x80007084 },
    { RGB_LIGHTSLATEGRAY, 	"lightslategray", 	(long)0x80008877 },
    { RGB_LIGHTSLATEGREY, 	"lightslategrey", 	(long)0x80008877 },
    { RGB_LIGHTSTEELBLUE, 	"lightsteelblue", 	(long)0x8000c4b0 },
    { RGB_LIGHTSTEELBLUE1, 	"lightsteelblue1", 	(long)0x8000e1ca },
    { RGB_LIGHTSTEELBLUE2, 	"lightsteelblue2", 	(long)0x8000d2bc },
    { RGB_LIGHTSTEELBLUE3, 	"lightsteelblue3", 	(long)0x8000b5a2 },
    { RGB_LIGHTSTEELBLUE4, 	"lightsteelblue4", 	(long)0x80007b6e },
    { RGB_LIGHTYELLOW, 		"lightyellow", 	(long)0x8000ffff },
    { RGB_LIGHTYELLOW1, 	"lightyellow1", 	(long)0x8000ffff },
    { RGB_LIGHTYELLOW2, 	"lightyellow2", 	(long)0x8000eeee },
    { RGB_LIGHTYELLOW3, 	"lightyellow3", 	(long)0x8000cdcd },
    { RGB_LIGHTYELLOW4, 	"lightyellow4", 	(long)0x80008b8b },
    { RGB_LIMEGREEN, 		"limegreen", 	(long)0x8000cd32 },
    { RGB_LINEN, 		"linen", 	(long)0x8000f0fa },
    { RGB_MAGENTA1, 		"magenta1", 	(long)0x80ee00ee },
    { RGB_MAGENTA2, 		"magenta2", 	(long)0x80dd00dd },
    { RGB_MAGENTA3, 		"magenta3", 	(long)0x80cc00cc },
    { RGB_MAGENTA4, 		"magenta4", 	(long)0x80800080 },
    { RGB_MAROON, 		"maroon", 	(long)0x800030b0 },
    { RGB_MAROON1, 		"maroon1", 	(long)0x800034ff },
    { RGB_MAROON2, 		"maroon2", 	(long)0x800030ee },
    { RGB_MAROON3, 		"maroon3", 	(long)0x800029cd },
    { RGB_MAROON4, 		"maroon4", 	(long)0x80001c8b },
    { RGB_MEDIUMAQUAMARINE, 	"mediumaquamarine", 	(long)0x8000cd66 },
    { RGB_MEDIUMBLUE, 		"mediumblue", 	(long)0x80000000 },
    { RGB_MEDIUMORCHID, 	"mediumorchid", 	(long)0x800055ba },
    { RGB_MEDIUMORCHID1, 	"mediumorchid1", 	(long)0x800066e0 },
    { RGB_MEDIUMORCHID2, 	"mediumorchid2", 	(long)0x80005fd1 },
    { RGB_MEDIUMORCHID3, 	"mediumorchid3", 	(long)0x800052b4 },
    { RGB_MEDIUMORCHID4, 	"mediumorchid4", 	(long)0x8000377a },
    { RGB_MEDIUMPURPLE, 	"mediumpurple", 	(long)0x80007093 },
    { RGB_MEDIUMPURPLE1, 	"mediumpurple1", 	(long)0x800082ab },
    { RGB_MEDIUMPURPLE2, 	"mediumpurple2", 	(long)0x8000799f },
    { RGB_MEDIUMPURPLE3, 	"mediumpurple3", 	(long)0x80006889 },
    { RGB_MEDIUMPURPLE4, 	"mediumpurple4", 	(long)0x8000475d },
    { RGB_MEDIUMSEAGREEN, 	"mediumseagreen", 	(long)0x8000b33c },
    { RGB_MEDIUMSLATEBLUE, 	"mediumslateblue", 	(long)0x8000687b },
    { RGB_MEDIUMSPRINGGREEN, 	"mediumspringgreen", 	(long)0x8000fa00 },
    { RGB_MEDIUMTURQUOISE, 	"mediumturquoise", 	(long)0x8000d148 },
    { RGB_MEDIUMVIOLETRED, 	"mediumvioletred", 	(long)0x800015c7 },
    { RGB_MIDNIGHTBLUE, 	"midnightblue", 	(long)0x80001919 },
    { RGB_MINTCREAM, 		"mintcream", 	(long)0x8000fff5 },
    { RGB_MISTYROSE, 		"mistyrose", 	(long)0x8000e4ff },
    { RGB_MISTYROSE1, 		"mistyrose1", 	(long)0x8000e4ff },
    { RGB_MISTYROSE2, 		"mistyrose2", 	(long)0x8000d5ee },
    { RGB_MISTYROSE3, 		"mistyrose3", 	(long)0x8000b7cd },
    { RGB_MISTYROSE4, 		"mistyrose4", 	(long)0x80007d8b },
    { RGB_MOCCASIN, 		"moccasin", 	(long)0x8000e4ff },
    { RGB_NAVAJOWHITE, 		"navajowhite", 	(long)0x8000deff },
    { RGB_NAVAJOWHITE1, 	"navajowhite1", 	(long)0x8000deff },
    { RGB_NAVAJOWHITE2, 	"navajowhite2", 	(long)0x8000cfee },
    { RGB_NAVAJOWHITE3, 	"navajowhite3", 	(long)0x8000b3cd },
    { RGB_NAVAJOWHITE4, 	"navajowhite4", 	(long)0x8000798b },
    { RGB_OLDLACE, 		"oldlace", 	(long)0x8000f5fd },
    { RGB_OLIVEDRAB, 		"olivedrab", 	(long)0x80008e6b },
    { RGB_OLIVEDRAB1, 		"olivedrab1", 	(long)0x8000ffc0 },
    { RGB_OLIVEDRAB2, 		"olivedrab2", 	(long)0x8000eeb3 },
    { RGB_OLIVEDRAB3, 		"olivedrab3", 	(long)0x8000cd9a },
    { RGB_OLIVEDRAB4, 		"olivedrab4", 	(long)0x80008b69 },
    { RGB_ORANGE1, 		"orange1", 	(long)0x8000a5ff },
    { RGB_ORANGE2, 		"orange2", 	(long)0x80009aee },
    { RGB_ORANGE3, 		"orange3", 	(long)0x800085cd },
    { RGB_ORANGE4, 		"orange4", 	(long)0x80005a8b },
    { RGB_ORANGERED, 		"orangered", 	(long)0x800045ff },
    { RGB_ORANGERED1, 		"orangered1", 	(long)0x800045ff },
    { RGB_ORANGERED2, 		"orangered2", 	(long)0x800040ee },
    { RGB_ORANGERED3, 		"orangered3", 	(long)0x800037cd },
    { RGB_ORANGERED4, 		"orangered4", 	(long)0x8000258b },
    { RGB_ORCHID, 		"orchid", 	(long)0x800070da },
    { RGB_ORCHID1, 		"orchid1", 	(long)0x800083ff },
    { RGB_ORCHID2, 		"orchid2", 	(long)0x80007aee },
    { RGB_ORCHID3, 		"orchid3", 	(long)0x800069cd },
    { RGB_ORCHID4, 		"orchid4", 	(long)0x8000478b },
    { RGB_PALEGOLDENROD, 	"palegoldenrod", 	(long)0x8000e8ee },
    { RGB_PALEGREEN, 		"palegreen", 	(long)0x8000fb98 },
    { RGB_PALEGREEN1, 		"palegreen1", 	(long)0x8000ff9a },
    { RGB_PALEGREEN2, 		"palegreen2", 	(long)0x8000ee90 },
    { RGB_PALEGREEN3, 		"palegreen3", 	(long)0x8000cd7c },
    { RGB_PALETURQUOISE1, 	"paleturquoise1", 	(long)0x8000ffbb },
    { RGB_PALETURQUOISE2, 	"paleturquoise2", 	(long)0x8000eeae },
    { RGB_PALETURQUOISE3, 	"paleturquoise3", 	(long)0x8000cd96 },
    { RGB_PALETURQUOISE4, 	"paleturquoise4", 	(long)0x80008b66 },
    { RGB_PALEVIOLETRED, 	"palevioletred", 	(long)0x800070db },
    { RGB_PALEVIOLETRED1, 	"palevioletred1", 	(long)0x800082ff },
    { RGB_PALEVIOLETRED2, 	"palevioletred2", 	(long)0x800079ee },
    { RGB_PALEVIOLETRED3, 	"palevioletred3", 	(long)0x800068cd },
    { RGB_PALEVIOLETRED4, 	"palevioletred4", 	(long)0x8000478b },
    { RGB_PAPAYAWHIP, 		"papayawhip", 	(long)0x8000efff },
    { RGB_PEACHPUFF, 		"peachpuff", 	(long)0x8000daff },
    { RGB_PEACHPUFF1, 		"peachpuff1", 	(long)0x8000daff },
    { RGB_PEACHPUFF2, 		"peachpuff2", 	(long)0x8000cbee },
    { RGB_PEACHPUFF3, 		"peachpuff3", 	(long)0x8000afcd },
    { RGB_PEACHPUFF4, 		"peachpuff4", 	(long)0x8000778b },
    { RGB_PERU, 		"peru", 	(long)0x800085cd },
    { RGB_PINK, 		"pink", 	(long)0x8000c0ff },
    { RGB_PINK1, 		"pink1", 	(long)0x8000b5ff },
    { RGB_PINK2, 		"pink2", 	(long)0x8000a9ee },
    { RGB_PINK3, 		"pink3", 	(long)0x800091cd },
    { RGB_PINK4, 		"pink4", 	(long)0x8000638b },
    { RGB_PLUM, 		"plum", 	(long)0x8000a0dd },
    { RGB_PLUM1, 		"plum1", 	(long)0x8000bbff },
    { RGB_PLUM2, 		"plum2", 	(long)0x8000aeee },
    { RGB_PLUM3, 		"plum3", 	(long)0x800096cd },
    { RGB_PLUM4, 		"plum4", 	(long)0x8000668b },
    { RGB_POWDERBLUE, 		"powderblue", 	(long)0x8000e0b0 },
    { RGB_PURPLE1, 		"purple1", 	(long)0x8000309b },
    { RGB_PURPLE2, 		"purple2", 	(long)0x80002c91 },
    { RGB_PURPLE3, 		"purple3", 	(long)0x8000267d },
    { RGB_PURPLE4, 		"purple4", 	(long)0x80001a55 },
    { RGB_RED1, 		"red1", 	(long)0x800000ff },
    { RGB_RED2, 		"red2", 	(long)0x800000ee },
    { RGB_RED3, 		"red3", 	(long)0x800000cd },
    { RGB_RED4, 		"red4", 	(long)0x8000008b },
    { RGB_ROSYBROWN, 		"rosybrown", 	(long)0x80008fbc },
    { RGB_ROSYBROWN1, 		"rosybrown1", 	(long)0x8000c1ff },
    { RGB_ROSYBROWN2, 		"rosybrown2", 	(long)0x8000b4ee },
    { RGB_ROSYBROWN3, 		"rosybrown3", 	(long)0x80009bcd },
    { RGB_ROSYBROWN4, 		"rosybrown4", 	(long)0x8000698b },
    { RGB_ROYALBLUE, 		"royalblue", 	(long)0x80006941 },
    { RGB_ROYALBLUE1, 		"royalblue1", 	(long)0x80007648 },
    { RGB_ROYALBLUE2, 		"royalblue2", 	(long)0x80006e43 },
    { RGB_ROYALBLUE3, 		"royalblue3", 	(long)0x80005f3a },
    { RGB_ROYALBLUE4, 		"royalblue4", 	(long)0x80004027 },
    { RGB_SADDLEBROWN, 		"saddlebrown", 	(long)0x8000458b },
    { RGB_SALMON, 		"salmon", 	(long)0x800080fa },
    { RGB_SALMON1, 		"salmon1", 	(long)0x80008cff },
    { RGB_SALMON2, 		"salmon2", 	(long)0x800082ee },
    { RGB_SALMON3, 		"salmon3", 	(long)0x800070cd },
    { RGB_SALMON4, 		"salmon4", 	(long)0x80004c8b },
    { RGB_SANDYBROWN, 		"sandybrown", 	(long)0x8000a4f4 },
    { RGB_SEAGREEN, 		"seagreen", 	(long)0x80008b2e },
    { RGB_SEAGREEN1, 		"seagreen1", 	(long)0x8000ff54 },
    { RGB_SEAGREEN2, 		"seagreen2", 	(long)0x8000ee4e },
    { RGB_SEAGREEN3, 		"seagreen3", 	(long)0x8000cd43 },
    { RGB_SEAGREEN4, 		"seagreen4", 	(long)0x80008b2e },
    { RGB_SEASHELL, 		"seashell", 	(long)0x8000f5ff },
    { RGB_SEASHELL1, 		"seashell1", 	(long)0x8000f5ff },
    { RGB_SEASHELL2, 		"seashell2", 	(long)0x8000e5ee },
    { RGB_SEASHELL3, 		"seashell3", 	(long)0x8000c5cd },
    { RGB_SEASHELL4, 		"seashell4", 	(long)0x8000868b },
    { RGB_SIENNA, 		"sienna", 	(long)0x800052a0 },
    { RGB_SIENNA1, 		"sienna1", 	(long)0x800082ff },
    { RGB_SIENNA2, 		"sienna2", 	(long)0x800079ee },
    { RGB_SIENNA3, 		"sienna3", 	(long)0x800068cd },
    { RGB_SIENNA4, 		"sienna4", 	(long)0x8000478b },
    { RGB_SKYBLUE, 		"skyblue", 	(long)0x8000ce87 },
    { RGB_SKYBLUE1, 		"skyblue1", 	(long)0x8000ce87 },
    { RGB_SKYBLUE2, 		"skyblue2", 	(long)0x8000c07e },
    { RGB_SKYBLUE3, 		"skyblue3", 	(long)0x8000a66c },
    { RGB_SKYBLUE4, 		"skyblue4", 	(long)0x8000704a },
    { RGB_SLATEBLUE, 		"slateblue", 	(long)0x80005a6a },
    { RGB_SLATEBLUE1, 		"slateblue1", 	(long)0x80006f83 },
    { RGB_SLATEBLUE2, 		"slateblue2", 	(long)0x8000677a },
    { RGB_SLATEBLUE3, 		"slateblue3", 	(long)0x80005969 },
    { RGB_SLATEBLUE4, 		"slateblue4", 	(long)0x80003c47 },
    { RGB_SLATEGRAY, 		"slategray", 	(long)0x80008070 },
    { RGB_SLATEGRAY1, 		"slategray1", 	(long)0x8000e2c6 },
    { RGB_SLATEGRAY2, 		"slategray2", 	(long)0x8000d3b9 },
    { RGB_SLATEGRAY3, 		"slategray3", 	(long)0x8000b69f },
    { RGB_SLATEGRAY4, 		"slategray4", 	(long)0x80007b6c },
    { RGB_SLATEGREY, 		"slategrey", 	(long)0x80008070 },
    { RGB_SNOW, 		"snow", 	(long)0x8000faff },
    { RGB_SNOW1, 		"snow1", 	(long)0x8000faff },
    { RGB_SNOW2, 		"snow2", 	(long)0x8000e9ee },
    { RGB_SNOW3, 		"snow3", 	(long)0x8000c9cd },
    { RGB_SNOW4, 		"snow4", 	(long)0x8000898b },
    { RGB_SPRINGGREEN, 		"springgreen", 	(long)0x8000ff00 },
    { RGB_SPRINGGREEN1,		"springgreen1",	(long)0x8000ff00 },
    { RGB_SPRINGGREEN2,		"springgreen2",	(long)0x8000ee00 },
    { RGB_SPRINGGREEN3,		"springgreen3",	(long)0x8000cd00 },
    { RGB_SPRINGGREEN4,		"springgreen4",	(long)0x80008b00 },
    { RGB_STEELBLUE, 		"steelblue", 	(long)0x80008246 },
    { RGB_STEELBLUE1, 		"steelblue1", 	(long)0x8000b863 },
    { RGB_STEELBLUE2, 		"steelblue2", 	(long)0x8000ac5c },
    { RGB_STEELBLUE3, 		"steelblue3", 	(long)0x8000944f },
    { RGB_STEELBLUE4, 		"steelblue4", 	(long)0x80006436 },
    { RGB_TAN, 		        "tan",    	(long)0x8000b4d2 },
    { RGB_TAN1, 		"tan1", 	(long)0x8000a5ff },
    { RGB_TAN2, 		"tan2", 	(long)0x80009aee },
    { RGB_TAN3, 		"tan3", 	(long)0x800085cd },
    { RGB_TAN4, 		"tan4", 	(long)0x80005a8b },
    { RGB_THISTLE, 		"thistle", 	(long)0x8000bfd8 },
    { RGB_THISTLE1, 		"thistle1", 	(long)0x8000e1ff },
    { RGB_THISTLE2, 		"thistle2", 	(long)0x8000d2ee },
    { RGB_THISTLE3, 		"thistle3", 	(long)0x8000b5cd },
    { RGB_THISTLE4, 		"thistle4", 	(long)0x80007b8b },
    { RGB_TOMATO, 		"tomato", 	(long)0x800063ff },
    { RGB_TOMATO1, 		"tomato1", 	(long)0x800063ff },
    { RGB_TOMATO2, 		"tomato2", 	(long)0x80005cee },
    { RGB_TOMATO3, 		"tomato3", 	(long)0x80004fcd },
    { RGB_TOMATO4, 		"tomato4", 	(long)0x8000368b },
    { RGB_TURQUOISE1, 		"turquoise1", 	(long)0x8000f500 },
    { RGB_TURQUOISE2, 		"turquoise2", 	(long)0x8000e500 },
    { RGB_TURQUOISE3, 		"turquoise3", 	(long)0x8000c500 },
    { RGB_TURQUOISE4, 		"turquoise4", 	(long)0x80008600 },
    { RGB_VIOLET, 		"violet", 	(long)0x800082ee },
    { RGB_VIOLETRED, 		"violetred", 	(long)0x800020d0 },
    { RGB_VIOLETRED1, 		"violetred1", 	(long)0x80003eff },
    { RGB_VIOLETRED2, 		"violetred2", 	(long)0x80003aee },
    { RGB_VIOLETRED3, 		"violetred3", 	(long)0x800032cd },
    { RGB_VIOLETRED4, 		"violetred4", 	(long)0x8000228b },
    { RGB_WHEAT, 		"wheat", 	(long)0x8000def5 },
    { RGB_WHEAT1, 		"wheat1", 	(long)0x8000e7ff },
    { RGB_WHEAT2, 		"wheat2", 	(long)0x8000d8ee },
    { RGB_WHEAT3, 		"wheat3", 	(long)0x8000bacd },
    { RGB_WHEAT4, 		"wheat4", 	(long)0x80007e8b },
    { RGB_WHITESMOKE, 		"whitesmoke", 	(long)0x8000f5f5 },
    { RGB_YELLOW1, 		"yellow1", 	(long)0x8000ffff },
    { RGB_YELLOW2, 		"yellow2", 	(long)0x8000eeee },
    { RGB_YELLOW3, 		"yellow3", 	(long)0x8000cdcd },
    { RGB_YELLOW4, 		"yellow4", 	(long)0x80008b8b },
    { RGB_YELLOWGREEN, 		"yellowgreen", 	(long)0x8000cd9a },
    
    { -1 }
};    	/* end fixed_color_table[] */


static float spec_factor = 0.75;
static float diff_factor = 0.45;
static float emis_factor = 0.10;

int
init_color()
{
short k, nc=0;
COLORDEF *cd;

    /* initialize floating point values for c3f()*/
    cd = fixed_color_table;
    while (cd->cid != -1)    {

	cd->drgba[0] = diff_factor * UNPACK_RED(cd->cpackdata) / 255.0;
	cd->drgba[1] = diff_factor * UNPACK_GREEN(cd->cpackdata) / 255.0;
	cd->drgba[2] = diff_factor * UNPACK_BLUE(cd->cpackdata) / 255.0;
	cd->drgba[3] = diff_factor * UNPACK_ALPHA(cd->cpackdata) / 255.0;

	cd->srgba[0] = spec_factor * UNPACK_RED(cd->cpackdata) / 255.0;
	cd->srgba[1] = spec_factor * UNPACK_GREEN(cd->cpackdata) / 255.0;
	cd->srgba[2] = spec_factor * UNPACK_BLUE(cd->cpackdata) / 255.0;
	cd->srgba[3] = spec_factor * UNPACK_ALPHA(cd->cpackdata) / 255.0;

	cd++;
	nc++;
	}

    for (k = 0; k < NUM_COLORS; k++)
	random_index_table[k] = rand() % nc;

    fprintf (stderr, "init %d colors (%d random)\n", nc, NUM_COLORS);

    return (1);
}

long
lerp_color (
    long p,
    long q,
    float t)
{
unsigned char r, g, b, a;
    
    r = (1.0 - t) * UNPACK_RED(p) + t * UNPACK_RED(q);
    g = (1.0 - t) * UNPACK_GREEN(p) + t * UNPACK_GREEN(q);
    b = (1.0 - t) * UNPACK_BLUE(p) + t * UNPACK_BLUE(q);
    a = (1.0 - t) * UNPACK_ALPHA(p) + t * UNPACK_ALPHA(q);

    return (PACK_ALPHA(a) | PACK_BLUE(b) | PACK_GREEN(g) | PACK_RED(r));
}


main()
{
   short k, nc=0;
   COLORDEF *cd;

   init_color();
    /* initialize floating point values for c3f()*/
    cd = fixed_color_table;
    while (cd->cid != -1)    {
	printf("%d %.3f %.3f %.3f    %s\n",nc,
	cd->drgba[0] , cd->drgba[1] , cd->drgba[2] ,cd->cname);
	cd++;
	nc++;
    }
}
