/* csblayers.c : routine to get the layers used in the DXF file and
   create a layer file */ 
#include <stdio.h>
/*#include "color.h"*/

typedef struct tmplate {
    int index;
    char cname[100];
} TEMPLATE;

TEMPLATE coltable[500] ;
/*
TEMPLATE coltable[] = {
   {247, "ARCH7"},
   {26 , "AT-BENCH"},
   {21 , "BAY-BENCH"},
   {36 , "CL-BRDRM"},
   {36 , "CL-COFFEE"},
   {36 , "CL-COPY"},
   {36 , "CL-CORR"},
   {36 , "CL-ELEC"},
   {36 , "CL-EV"},
   {36 , "CL-EVLOB"},
   {36 , "CL-EXHIBIT"},
   {28 , "CL-LOGGIA"},
   {36, "CL-OFFICE"},
   {36, "CL-PENTHS"},
   {36, "CL-RESTRM"},
   {36, "CL-STR"},
   {36, "CL-STOR"},
   {36, "CL-STAIR1"},
   {36, "CL-STAIR12"},
   {26 , "COPE-STONE"},
   {35 , "DR-DR"},
   {124 , "DR-FR"},
   {124 , "DR-JM"},
   {124 , "DR-SL"},
   {124 , "DR-SW"},
   {27 , "DRHD-CORR"},
   {27 , "DRHD-ELEC"},
   {27 , "DRHD-EV"},
   {27 , "DRHD-OFFICE"},
   {27 , "DRHD-STAIR12"},
   {247 , "DRHD-TILE2"},
   {27 , "EL-2D"},
   {30 , "FL-BALCONY"},
   {30 , "FL-BRDRM"},
   {30 , "FL-COFFEE"},
   {30 , "FL-COPY"},
   {35 , "FL-CORR"},
   {30 , "FL-ELEC"},
   {30 , "FL-EV"},
   {30 , "FL-EVLOB"},
   {30 , "FL-EXHIBIT"},
   {14 , "FL-LOGGIA"},
   {22 , "FL-OFFICE"},
   {22 , "FL-PENTHS"},
   {30 , "FL-RESTRM"},
   {30 , "FL-ROOF"},
   {30 , "FL-STOR"},
   {18 , "GLS-WLS"},
   {114 , "PLNT-FL"},
   {114 , "PLNTR"},
   {26 , "PLNT-STONECOPE"},
   {26 , "PLNT-STNCOPE"},
   {11 , "PLNT-WL"},
   {7 , "SKYLHT"},
   {7 , "STAIR1"},
   {7 , "STAIR2"},
   {7 , "STAIR3"},
   {92 , "STAIR4"},
   {7 , "STAIR"},
   {62 , "STAIR4-FR"},
   {62 , "STAIR4-RL"},
   {26 , "STNCOPE"},
   {33 , "WL-BRDRM"},
   {27 , "WL-COFFEE"},
   {27 , "WL-COPY"},
   {30 , "WL-CORR"},
   {30 , "WL-ELEC"},
   {30 , "WL-ELEV"},
   {30 , "WL-EV"},
   {33 , "WL-EXHIBIT"},
   {27 , "WL-FR"},
   {27 , "WL-OFFICE"},
   {247 , "WL-PENTHS"},
   {36 , "WL-RESTRM"},
   {127 , "WL-SIGB"},
   {127 , "WL-SIGT"},
   {15 , "WL-SIGM"},
   {29 , "WL-STOR"},
   {27 , "WL-STR"},
   {27 , "WL-STAIR12"},
   {105 , "WL-TILE1"},
   {247 , "WL-TILE2"},
   {102 , "WL-TILE3"},
   {105 , "WN-FR"},
   {18 , "WN-GL"},
   {-1, "none"}
};
*/

Findstring(str1,str2)
char *str1, *str2;
{
   int length1, length2,i,j,num;
   length1 = strlen(str1);
   length2 = strlen(str2);

   for(i=0;i<= (length2 -length1);i++){
      num =0;
      for(j=0;j<length1;j++){
        if(str2[i+j] == str1[j])
          num++;
      }
      if(num == length1)
        return(num);
   }
   return(0);
}

Find_color(layername)
char *layername;
{
   static rand =10;
   int i =0;
   int bestindex = -1, bestlength = -1;
   int length;
   
   while ( coltable[i].index != -1) {  
     if (length = Findstring(coltable[i].cname,layername)){
        if (length > bestlength){  
          bestindex = coltable[i].index;
          bestlength = length;
        }
     }
     i++;
   }
   if (bestindex > 0 )
       return (bestindex);
  rand += 10;
  fprintf(stderr,"%s has random color\n",layername);
  return(rand);
}

readcmap(filename)
char *filename;
{
   FILE *cmap;
   char line[256];
   float r,g,b;
   int i=0;
   if (! (cmap = fopen(filename,"r"))){
     fprintf(stderr,"can't open csb.ctab\n");
     exit(0);
   }
   while(fgets(line,256,cmap) != NULL){
     sscanf(line,"%d %g %g %g %s",&coltable[i].index,&r,&g,&b,coltable[i].cname);
     i++;
   }
   coltable[i].index = -1;
   fclose(cmap);
}


main(argc,argv)
int argc;
char *argv[];
{
   char layername[256];
   int color;
   int gotlayer = 0;
   int DXFgroupcode;
   FILE * dxffile;
   char DXFgroupvalue[256];
   if (argc < 2){
     fprintf(stderr,"need a dxf file\n");
     exit(0);
   }
   /*readcmap(argv[1]);*/
   dxffile=fopen(argv[1],"r");
   if (!dxffile) {
     fprintf(stderr,"could not open %s\n",argv[1]);
     exit(0);
   }
   /*FIND THE LAYER TABLE*/
   while(1) {
      if (fscanf(dxffile,"%d",&DXFgroupcode) == EOF) {
         fprintf(stderr,"Failed: The DXF file didn't have a layer table \n");
         exit();
      }
      if (fscanf(dxffile,"%s",DXFgroupvalue) == EOF ) { 
         fprintf(stderr,"Failed: The DXF file didn't have a layer table \n");
         exit();
      }
      if (DXFgroupcode == 2 && !strcmp(DXFgroupvalue,"LAYER"))
         break;
   }
   

   /*WALK THROUGH LAYER TABLE*/
   while (1){
      fscanf(dxffile,"%d",&DXFgroupcode); 
      fscanf(dxffile,"%s",DXFgroupvalue);
      switch (DXFgroupcode ) {
         case 2 : strcpy (layername,DXFgroupvalue);gotlayer = 1; break;
         case 62 :  color = atoi(DXFgroupvalue);break;
         case 0 : if (gotlayer) {
	   /*color = Find_color(layername);*/
	   /*if color >= 0 layer is on
	     if color < 0 layer is off*/
	   if (color >= 0) 
	     printf("%s	Y	%d\n",layername,color);
	   else
	     printf("%s N       %d\n",layername,-color);
	   gotlayer = 0;
	   color=0;
                  }
                  if (!strcmp(DXFgroupvalue,"ENDTAB")) exit(); 
                  break;
      }
   }
   /*add an extra layer for the doors*/
   /*printf("A-DOOR Y        12");*/
}
