/*getrooms.c
  this sucks but it is an outline of one approach to extracting
  roomlabels from MIT floorplans
  build w/ gmake -f Makefile2 (I know, I suck)
*/



#include "acad2ug.h"
#include "assert.h"
#include "stdlib.h"

#define TRUE 1
#define FALSE 0

/* Global variables */

/* DXF groups consist of a code and a value */
int DXFgroupcode ;
char DXFgroupvalue[256];
/* id of last vertex and face in current block */
int Lastv =0;
int Lastw =0;
int Lastf =0;

int Lineno=0, /* line number of current Entity in dxf file  */
CurLineno=0;  /* Current line number in dxf file  */

/*Table of layers containing only ones that are turned on */
LAYER  *Layertable = NULL;
/*Total number of layers */
int  Numlayers =1;
short Nolayerfile = TRUE; /* there is an user wants-specified layer file ? */

short Nocolorfile = TRUE; /* there is an user-specified color file ? */
float Colortable[256][4];
char Prefix[50];
short Inablock = FALSE;   /* Processing BLOCKS section */
short InEntities = FALSE; /* Processing ENTITIES section */
short WantFix1 = FALSE;   
short WantFix2 = FALSE;   
short WantFix3 = FALSE;   
short Want2D = FALSE;   
short WantPlanv = FALSE;   
short WantPrefix = FALSE;   
short WantNoDefs = FALSE;   
short WantArcs=TRUE;
short Debugging =0; 

/* direction of z axis for Entity Coordinate system (ECS)*/
/* VERTEX Ecs; */
/* World Coordinate system (WCS) axes */   
/* static VERTEX Wcs_x = {1.0,0.0,0.0}; */
/* static VERTEX Wcs_y = {0.0,1.0,0.0}; */
/* static VERTEX Wcs_z = {0.0,0.0,1.0}; */

/* Matrix to transform from ECS to WCS */
double Ecs_matrix[4][4];

/* Each DXF BLOCK will become a BLK structure */
BLK *First_block = NULL;
BLK *Last_block = NULL;
BLK *Cur_block = NULL;
INSTANCE *Instance_list= NULL;

void dispatch_on_group(int, char[]);
extern void GetTwoLines(void);
extern void start_timer(void);
extern void Setup_files(void);
extern void Process_args(int, char*[]);
extern void Skip(char[]);
extern int Wantlayer(char[]);
void error(void);
void ProcessText(void);

/* dispatch_on_group(code,type):
 * Looks at the type of an entity and calls functions to 
 * process its groups
 */
void
dispatch_on_group(code,type)
int code;
char type[];
{
  /* char layer[50]; */
  /* int layerindex; */

   if (code != 0) { 
   /* skip the junk groups that appear before a new entity */
     Skip("");
     return;
   }
   Lineno = CurLineno;   /* begining of a new entity */
   if(!strcmp(type,"SECTION")){
     /* Skip(type); */
     GetTwoLines();
     return; 
   }else if(!strcmp(type,"ENDBLK")){
     Skip(type);
   }else if(!strcmp(type,"SEQEND")){
     Skip(type);
   }else if(!strcmp(type,"ENDSEC")) {
     Skip(type);
   }else if (!strcmp(type,"POINT")){
     Skip(type);
   }else if (!strcmp(type,"TEXT")){
     ProcessText(); 
   }else if (!strcmp(type,"SHAPE")){
     Skip(type);
   }else if (!strcmp(type,"ATTDEF")){
     Skip(type);
   }else if (!strcmp(type,"ATTRIB")){
     Skip(type);
   }else if (!strcmp(type,"VERTEX")){
     Skip(type);
   }else if (!strcmp(type,"DIMENSION")){
     Skip(type);
   }else if (!strcmp(type,"BLOCK")){
     Skip(type);
   }else if(!strcmp(type,"LINE")) {
     Skip(type);
   }
   else if (!strcmp(type,"INSERT"))
     Skip(type);
   else if (!strcmp(type,"CIRCLE")) {
     Skip(type);
   }
   else if (!strcmp(type,"ARC"))
     Skip(type);
   else if (!strcmp(type,"SOLID"))
     Skip(type);
   else if (!strcmp(type,"POLYLINE")) {
     Skip(type);
   }
   else if (!strcmp(type,"3DLINE"))
     Skip(type);
   else if (!strcmp(type,"3DFACE"))
     Skip(type);
   else{
     /* fprintf(stderr,"Unkown entity : %s in line %d\n",type,Lineno); */
     Skip ("");
   }
}  

void  
error()
{
   fprintf(stderr,"error on  line %d of %s.dxf\n",Lineno,Mainfilename);
   exit(2);
}

#define ACADREFLEN 8
#define LABELLEN   16

typedef struct {
  int floor_rotate;
  int room_rotate;
  int type_rotate;
  int misc_rotate;
  int size_rotate;

  char floor_acadref[ACADREFLEN];
  char room_acadref[ACADREFLEN];
  char type_acadref[ACADREFLEN];
  char misc_acadref[ACADREFLEN];
  char size_acadref[ACADREFLEN];
  char line_acadref[ACADREFLEN];

  VERTEX floor_v;
  VERTEX room_v;
  VERTEX type_v;
  VERTEX misc_v;
  VERTEX size_v;

  char floor_l[LABELLEN];
  char room_l[LABELLEN];
  char type_l[LABELLEN];
  char misc_l[LABELLEN];
  char size_l[LABELLEN];

  /* line vertices */
  VERTEX start;
  VERTEX finish;
} Label;

void
setRotate(Label *l, int index) 
{
  switch(index) {
  case 0:
    l->floor_rotate = 1;
    break;
  case 1:
    l->room_rotate = 1;
    break;
  case 2:
    l->type_rotate = 1;
    break;
  case 3:
    l->misc_rotate = 1;
    break;
  case 4:
    l->size_rotate = 1;
    break;
  default:
    fprintf(stderr, "setRotate incorrect index %d\n", index);
    error();
  }
}

int
allRotate(Label *l)
{
  return 
    (!(l->floor_l[0]) || l->floor_rotate) && 
    (!(l->room_l[0])  || l->room_rotate) && 
    (!(l->type_l[0])  || l->type_rotate) &&
    (!(l->misc_l[0])  || l->misc_rotate) &&
    (!(l->size_l[0])  || l->size_rotate);
}

/* should find out the length of x label and length of y label
   with respect to font size */
/* assume: size 18 font: width is 17.75 and height is 29 */
/* fixme: these should be a function of font size */
#define FONTHEIGHT 29.0
#define FONTWIDTH 17.75
#define THRESH 12.0 /* 0.005 is minimal, 12.0 is for the stupid alignment problem in E1.*.dxf */

float 
absf(float i) 
{
  if(i < 0)
    return -1.0*i;
  else
    return i;
}

int
floatEqZero(float i) 
{
  return absf(i) < THRESH;
}

int
chkLabel_helper(Label *l, int state)
{
  float delta;

  if(!l->floor_rotate) {
    if(allRotate(l))
      return 20;

    switch(state) {
    case 2:
      delta = strlen(l->floor_l) * FONTWIDTH;
      if(!(floatEqZero(l->floor_v.x + delta - l->room_v.x)))
	return 1;
      if(!(l->floor_v.y == l->room_v.y))
	return 2;
      break;
    case 3:
      if(!(l->floor_v.x == l->type_v.x))
	return 3;
      if(!(floatEqZero(l->floor_v.y - l->type_v.y - FONTHEIGHT)))
	return 4;
      break;
    case 4:
      if(!(l->floor_v.x == l->misc_v.x))
	return 5;
      if(!(floatEqZero(l->type_v.y - l->misc_v.y - FONTHEIGHT)))
	return 6;
      break;
    case 5:
      if(!(l->floor_v.x == l->size_v.x))
	return 7;
      if(!(floatEqZero(l->misc_v.y > l->size_v.y - FONTHEIGHT)))
	return 8;
      break;
    }
  }
  else { /* when labels are rotated 90 degrees ccw */
    if(!allRotate(l))
      return 21;

    switch(state) {
    case 2:
      delta = strlen(l->floor_l) * FONTWIDTH;
      if(!(l->floor_v.x == l->room_v.x))
	return 9;
      if(!(floatEqZero(l->floor_v.y + delta - l->room_v.y)))
	return 10;
      break;
    case 3:
      if(!(l->floor_v.y == l->type_v.y))
	return 11;
      if(!(floatEqZero(l->floor_v.x + FONTHEIGHT - l->type_v.x)))
	return 12;
      break;
    case 4:
      if(!(l->floor_v.y == l->misc_v.y))
	return 13;
      if(!(floatEqZero(l->type_v.x + FONTHEIGHT - l->misc_v.x)))
	return 14;
      break;
    case 5:
      if(!(l->floor_v.y == l->size_v.y))
	return 15;
      if(!(floatEqZero(l->misc_v.x + FONTHEIGHT - l->size_v.x)))
	return 16;
      break;
    }
  }
  return 0;
}

int
chkLabel(Label *l, int state)
{
  /* heuristic to check labelling convention
   
     There are three labels, A, B, C, which stands for
     floor, room, and type labels

     The convention for the position of these labels is 
     AB
     C

     So A, C shares the same x coordinate while A and B
     shares the same y coordinate.  Moreover, the y coordinates
     of A and B are larger than C's.
  */

  int result = 0;

  result = chkLabel_helper(l, state);

  /*
    if(result != 0)
    fprintf(stderr, "chkLabel: result=%d rotate=%d state=%d\n", 
    result, l->floor_rotate,state);
  */

  return result;
}

void
printLabel(FILE *f, Label *l)
{
  fprintf(f, "fl_ref=%s rm_ref=%s ty_ref=%s mc_ref=%s sz_ref=%s ln_ref=%s\n", 
	 l->floor_acadref, l->room_acadref, l->type_acadref, l->misc_acadref,
	 l->size_acadref, l->line_acadref );
  fprintf(f, "floor : l=%s x=%f y=%f z=%f\n", l->floor_l, l->floor_v.x, l->floor_v.y, l->floor_v.z);
  fprintf(f, "room  : l=%s x=%f y=%f z=%f\n", l->room_l, l->room_v.x, l->room_v.y, l->room_v.z);
  fprintf(f, "type  : l=%s x=%f y=%f z=%f\n", l->type_l, l->type_v.x, l->type_v.y, l->type_v.z);
  fprintf(f, "misc  : l=%s x=%f y=%f z=%f\n", l->misc_l, l->misc_v.x, l->misc_v.y, l->misc_v.z);
  fprintf(f, "size  : l=%s x=%f y=%f z=%f\n", l->size_l, l->size_v.x, l->size_v.y, l->size_v.z);

  fprintf(f, "start : x=%f y=%f z=%f\n", l->start.x, l->start.y, l->start.z);
  fprintf(f, "finish : x=%f y=%f z=%f\n", l->finish.x, l->finish.y, l->finish.z);
  fprintf(f, "\n");
}

void
exportLabel(Label *l, int state)
{
  int retValue = 0;
  if(!(l->floor_l[0]))
    return;
  printLabel(stdout, l);
  retValue = chkLabel(l, state);
  if(retValue != 0) {
    fprintf(stderr, "exportLabel: %d\n", retValue);
    error();
  }
}

void 
initLabel(Label *l) 
{
  memset(l, 0, sizeof(Label));
  /*
    l->floor_acadref[0] = '\0';
    l->room_acadref[0]  = '\0';
    l->type_acadref[0]  = '\0';
    l->line_acadref[0]  = '\0';
  */
}

void
eraseLabelData(Label *l, int index) 
{
  switch(index) {
  case 0:
    memset(l->floor_acadref, 0, sizeof(char)*ACADREFLEN);
    memset(&(l->floor_v), 0, sizeof(VERTEX));
    memset(l->floor_l, 0, sizeof(char)*LABELLEN);
    break;
  case 1:
    memset(l->room_acadref, 0, sizeof(char)*ACADREFLEN);
    memset(&(l->room_v), 0, sizeof(VERTEX));
    memset(l->room_l, 0, sizeof(char)*LABELLEN);
    break;
  case 2:
    memset(l->type_acadref, 0, sizeof(char)*ACADREFLEN);
    memset(&(l->type_v), 0, sizeof(VERTEX));
    memset(l->type_l, 0, sizeof(char)*LABELLEN);
    break;
  case 3:
    memset(l->misc_acadref, 0, sizeof(char)*ACADREFLEN);
    memset(&(l->misc_v), 0, sizeof(VERTEX));
    memset(l->misc_l, 0, sizeof(char)*LABELLEN);
    break;
  case 4:
    memset(l->size_acadref, 0, sizeof(char)*ACADREFLEN);
    memset(&(l->size_v), 0, sizeof(VERTEX));
    memset(l->size_l, 0, sizeof(char)*LABELLEN);
    break;

    /*
      case 3:
      memset(l->line_acadref, 0, sizeof(char)*ACADREFLEN);
      memset(&(l->start), 0, sizeof(VERTEX));
      memset(&(l->finish), 0, sizeof(VERTEX));
      break;
    */
  default:
    fprintf(stderr, "eraseLabelData: invalid index %d\n", index);
    error();
    break;
  }
}

void
rollbackLabel(Label *l, int index)
{
  char acadref[ACADREFLEN];
  VERTEX v;
  char label[LABELLEN];
  int rotate;

  switch(index) {
  case 0:
    memcpy(acadref, l->floor_acadref, sizeof(char)*ACADREFLEN);
    memcpy(&v, &(l->floor_v), sizeof(VERTEX));
    memcpy(label, l->floor_l, sizeof(char)*LABELLEN);
    rotate = l->floor_rotate;
    break;
  case 1:
    memcpy(acadref, l->room_acadref, sizeof(char)*ACADREFLEN);
    memcpy(&v, &(l->room_v), sizeof(VERTEX));
    memcpy(label, l->room_l, sizeof(char)*LABELLEN);
    rotate = l->room_rotate;
    break;
  case 2:
    memcpy(acadref, l->type_acadref, sizeof(char)*ACADREFLEN);
    memcpy(&v, &(l->type_v), sizeof(VERTEX));
    memcpy(label, l->type_l, sizeof(char)*LABELLEN);
    rotate = l->type_rotate;
    break;
  case 3:
    memcpy(acadref, l->misc_acadref, sizeof(char)*ACADREFLEN);
    memcpy(&v, &(l->misc_v), sizeof(VERTEX));
    memcpy(label, l->misc_l, sizeof(char)*LABELLEN);
    rotate = l->misc_rotate;
    break;
  case 4:
    memcpy(acadref, l->size_acadref, sizeof(char)*ACADREFLEN);
    memcpy(&v, &(l->size_v), sizeof(VERTEX));
    memcpy(label, l->size_l, sizeof(char)*LABELLEN);
    rotate = l->size_rotate;
    break;
  default:
    fprintf(stderr, "rollbackLabel: invalid index %d\n", index);
    error();
    break;
  }

  initLabel(l);
  memcpy(l->floor_acadref, acadref, sizeof(char)*ACADREFLEN);
  memcpy(&(l->floor_v), &v, sizeof(VERTEX));
  memcpy(l->floor_l, label, sizeof(char)*LABELLEN);
  l->floor_rotate = rotate;
}

void ProcessLabelLine(Label*);

void
acadref_cpy(int index, Label *l, char* value)
{
  assert(strlen(value) < ACADREFLEN);
  switch(index) {
  case 0:
    strcpy(l->floor_acadref, value);
    break;
  case 1:
    strcpy(l->room_acadref, value);
    break;
  case 2:
    strcpy(l->type_acadref, value);
    break;
  case 3:
    strcpy(l->misc_acadref, value);
    break;
  case 4:
    strcpy(l->size_acadref, value);
    break;
  case 10:
    strcpy(l->line_acadref, value);
    break;
  default:
    fprintf(stderr, "acadref_cpy: invalid index %d\n", index);
    error();
    break;
  }
}

void
label_cpy(int index, Label *l, char* value)
{
  assert(strlen(value) < LABELLEN);
  switch(index) {
  case 0:
    strcpy(l->floor_l, value);
    break;
  case 1:
    strcpy(l->room_l, value);
    break;
  case 2:
    strcpy(l->type_l, value);
    break;
  case 3:
    strcpy(l->misc_l, value);
    break;
  case 4:
    strcpy(l->size_l, value);
    break;
  default:
    fprintf(stderr, "label_cpy: invalid index %d\n", index);
    error();
    break;
  }
}

void
coord_cpy(char *c, int index, Label *l, char* value)
{
  double *target = 0;
  switch(index) {
  case 0:
    if(!strcmp(c, "x"))
      target = &(l->floor_v.x);
    else if(!strcmp(c, "y"))
      target = &(l->floor_v.y);
    else
      target = &(l->floor_v.z);
    break;
  case 1:
    if(!strcmp(c, "x"))
      target = &(l->room_v.x);
    else if(!strcmp(c, "y"))
      target = &(l->room_v.y);
    else
      target = &(l->room_v.z);
    break;
  case 2:
    if(!strcmp(c, "x"))
      target = &(l->type_v.x);
    else if(!strcmp(c, "y"))
      target = &(l->type_v.y);
    else
      target = &(l->type_v.z);
    break;
  case 3:
    if(!strcmp(c, "x"))
      target = &(l->misc_v.x);
    else if(!strcmp(c, "y"))
      target = &(l->misc_v.y);
    else
      target = &(l->misc_v.z);
    break;
  case 4:
    if(!strcmp(c, "x"))
      target = &(l->size_v.x);
    else if(!strcmp(c, "y"))
      target = &(l->size_v.y);
    else
      target = &(l->size_v.z);
    break;  
  default:
    fprintf(stderr, "coord_cpy: invalid index %d\n", index);
    error();
    return;
  }
  *target = atof(value);
}

void ProcessPolyline(Label* l);

void
ProcessText()
{
   int layerindex, chk;
   Label l, tempLabel;
   int state  = 0;
   int should_export = 0;
   char element_type[16];

   int isText = 0, isLine = 0, isPolyline = 0;

   initLabel(&l);
   strcpy(element_type, DXFgroupvalue);

   while(1){
      GetTwoLines();
      printf("read: %d, %s\n", DXFgroupcode, DXFgroupvalue);
      switch (DXFgroupcode){
      case 5:	/* id of the autocad element */
	acadref_cpy(state, &l, DXFgroupvalue);
	break;
      case 8:
	if (!(layerindex = Wantlayer(DXFgroupvalue)) ||
	    strcmp(DXFgroupvalue,"A-AREA-IDEN")) 
	  {
	    Skip(element_type);
	    exportLabel(&l, state);
	    return;
	  }
	break;
      case 6: /*  SOLID */
	break;
      case 10:
	coord_cpy("x", state, &l, DXFgroupvalue);
	break;
      case 20:
	coord_cpy("y", state, &l, DXFgroupvalue);
	break;
      case 30:
	coord_cpy("z", state, &l, DXFgroupvalue);
	break;
      case 40: /*  font size */
	if(strcmp(DXFgroupvalue, "18.0")) {
	  printLabel(stderr, &l);
	  fprintf(stderr, "invalid font size %s - assumption in chkLabel_helper becomes invalid\n", 
		  DXFgroupvalue);
	  error();
	}
	break;
      case 50:
	if(!strcmp(DXFgroupvalue, "90.0"))
	  setRotate(&l, state);
	break;
      case 1:  /* actual label */
	if(!strcmp(DXFgroupvalue, "UP") ||
	   !strcmp(DXFgroupvalue, "DN"))   /* ignore these labels */
	  return;
	label_cpy(state, &l, DXFgroupvalue);
	break;
      case 0:
	strcpy(element_type, DXFgroupvalue);

	/* if(!strcmp(element_type, "TEXT") && state < 2) */

	state++;

	isLine = 0;
	isText = !strcmp(element_type, "TEXT");
	if(!isText) {
	  isLine = !strcmp(element_type, "LINE");
	  if(isLine)
	    ProcessLabelLine(&l);
	  else {
	    isPolyline = !strcmp(element_type, "POLYLINE");
	    if(isPolyline) {
	      /* printLabel(stderr, &l); */
	      fprintf(stderr, "polyline dectected\n");
	      ProcessPolyline(&l);
	      /* error(); */
	    }
	  }
	}

	/* check if this text label belongs to the current label "group" */
	if(state > 1 && (chk = chkLabel(&l, state) > 0)) {
	  memcpy(&tempLabel, &l, sizeof(Label));
	  eraseLabelData(&tempLabel, state-1); /* index = state - 1 */
	  exportLabel(&tempLabel, state-1); /* prevstate = state - 1 */

	  rollbackLabel(&l, state-1); /* index = state - 1 */
	  printf("rollback state=%d\n", state);
	  state = 1;
	}	  

	/* assumes that any non-TEXT object terminates the label record */

	if(state == 5 || !isText) {
	  /* should_export = 1; */
	  exportLabel(&l, state);
	  return;
	}
	else if(state > 5) {
	  /* need to figure out how to skip non Text records  */
	  printLabel(stderr, &l);
	  fprintf(stderr, "lineno=%d state=%d value=%s\n", 
		  Lineno, state, DXFgroupvalue);
	  error();
	  return;
	}

	break;
      default: 
	printLabel(stderr, &l);
	fprintf(stderr,"TEXT : unknown group %d value %s lineno %d\n",
		DXFgroupcode, DXFgroupvalue, Lineno);
	break;
      }
      
   }
}

void
ProcessLabelLine(Label *l)
{
   int layerindex;
   while(1){
      GetTwoLines();
      switch (DXFgroupcode){
      case 5:	
	acadref_cpy(10, l, DXFgroupvalue);
	break;
      case 8:
	/*printf(" in layer %s",DXFgroupvalue);*/
	if (!(layerindex = Wantlayer(DXFgroupvalue)) ||
	    strcmp(DXFgroupvalue,"A-AREA-IDEN")) 
	  {
	    Skip("LINE");
	    return;
	  }
	break;
      case 6: /* SOLID */
	break;
      case 10:
	l->start.x = atof(DXFgroupvalue);break;
      case 20:
	l->start.y = atof(DXFgroupvalue);break;
      case 30:
	l->start.z = atof(DXFgroupvalue);break;
      case 11:
	l->finish.x = atof(DXFgroupvalue);break;
      case 21:
	l->finish.y = atof(DXFgroupvalue);break;
      case 31:
	l->finish.z = atof(DXFgroupvalue);break;
      case 0:
	return;
      default: 
	fprintf(Errorfile,"ProcessLabelLine : unknown group %d value %s\n",
		DXFgroupcode, DXFgroupvalue);
	break;
      }
   }
}

void
GetVertices(vertex,j,start_width,end_width)
VERTEX vertex[];
int *j;
double *start_width,*end_width;
{
   int flags;
   static float defaultz = 0.0;

   /* incase there is no x,y for this vertex */
   vertex[*j].x = vertex[*j].y = 0.0;
   /* incase there is no z for this vertex */
   vertex[*j].z = defaultz;
   start_width[*j] = 0.;
   end_width[*j] = 0.; 
   
   while(1){
      GetTwoLines();
      switch (DXFgroupcode){
	case 5:	    /* ignore id */
	case 8:
           break;
	case 10:
	   vertex[*j].x = atof(DXFgroupvalue);break;
	case 20:
	   vertex[*j].y = atof(DXFgroupvalue);break;
	case 30:
	case 38:
	case 39:
	   defaultz = vertex[*j].z = atof(DXFgroupvalue); break; 
	case 62: /*color */
          break;
	case 70:
	   flags = atoi(DXFgroupvalue);
	   if(flags & CONTROLVERTEX) {
	      /*ignore control vertices */
              /* if (*j > 0) */
		/* 	(*j)--; */
	      }
           break;
	case 40: 
             start_width[*j] = atof(DXFgroupvalue);
             break;
	case 41:
             end_width[*j] = atof(DXFgroupvalue);
             break;
	case 42:
             fprintf(Errorfile,"Bulge factor ignored;lineno:%d\n",CurLineno);
             break;
	case 50:
           break;
	case 0:
	    if (*j < MAXPOLYVERT-1)	{
		(*j)++;
		vertex[*j].z  = 0.0; /* incase there is no z for this vertex */
		}
	    else    {
		fprintf ( stderr, "overflowed MAXPOLYVERTS!  *j == %d in line %d\n", *j, CurLineno );
		}

           if (!strcmp(DXFgroupvalue,"SEQEND"))
	      return;
           else 
              break;
        default: 
           fprintf(stderr,"Vertex: unknown group %d\n",DXFgroupcode);
	   error();
           break;
      }
   }
}

void
ProcessPolyline(Label* l)
{
   int i=0,j=0,k=0;
   VERTEX v[MAXPOLYVERT];
   VERTEX w[4];
   VERTEX start;
   double thickness =0.0;
   int layerindex;
   double start_width[MAXPOLYVERT],end_width[MAXPOLYVERT];

    
   for(i=0;i<MAXPOLYVERT;i++)
       v[i].z =0.;

   while(1){
      GetTwoLines();
      switch (DXFgroupcode){
      case 5:	/* id */
	acadref_cpy(10, l, DXFgroupvalue);	
	break;
      case 8 :
	/*printf(" in layer %s",DXFgroupvalue);*/
	if (!(layerindex = Wantlayer(DXFgroupvalue)) ||
	    strcmp(DXFgroupvalue,"A-AREA-IDEN")) 
	  {
	    Skip("POLYLINE");
	    return;
	  }
	break;
      case 10:
	start.x = atof(DXFgroupvalue);break;
      case 20:
	start.y = atof(DXFgroupvalue);break;
      case 30:
      case 38:
	start.z = atof(DXFgroupvalue);break;
      case 39: /* thickness - ignore */
	break;
      case 40: /* start width - ignore */
	break;
      case 41: /* end width - ignore */
	break;
      case 62: /*color */
	break;
      case 66:
	break;
      case 70: /* flags */
	break;
      case 71: /* m */
	break;
      case 72: /* n */
	break;
      case 73: /* mdensity */
	break;
      case 74: /* ndensity */
	break;
      case 210: /* Ecs.x */
	break;
      case 220:
	break;
      case 230:
	break;
      case 0:
	GetVertices(v,&j,start_width,end_width);
	/* if last vertex is same as first one delete it and
	   set the closed flag on, so everything stays consistent */
	l->start.x = v[0].x;
	l->start.y = v[0].y;
	l->start.z = v[0].z;
	l->finish.x = v[j-1].x;
	l->finish.y = v[j-1].y;
	l->finish.z = v[j-1].z;
	printLabel(stderr, l);
	error();
	return;
      default:
	fprintf(stderr,"Polyline: unknown group %d\n",DXFgroupcode);
	error();
	break;
     }
  }
}


int
main(argc,argv)
int argc;
char *argv[];
{  
  /* char type[50]; */

   start_timer();
   Process_args(argc,argv);
   Setup_files();
  
   /* read the DXF file two lines at a time and process groups */
   GetTwoLines();
   while(1){
      if(!strcmp(DXFgroupvalue,"EOF")) break;
      /* printf("there\n"); */
      dispatch_on_group(DXFgroupcode,DXFgroupvalue);
   }

   fclose(Dxffile);
   /*MakeInstance("Entity");*/  /* Make the top instance */

   /* printextents();     */
   fclose(Errorfile);
   /*Write_ugfile();*/
   /*end_timer();*/
   /*get_time_diff();*/
   /*print_time_diff("convert");*/
   return 0;
}




