package navigator;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Controls extends JPanel 
    implements ItemListener, MouseListener
{
    public JCheckBox triangulate, e2ePath, localPath, curPath, 
	correction, wpgraph, coordinate, override;
    public JButton clear;
    GUI gui;

    public JTextField posUpdate;
    public JLabel  posLabel;

    public LocationManager lm; // demohack

    public Controls(GUI g, boolean interactive)
    {
	gui = g;

	posLabel  = new JLabel("Last Update");
	posUpdate = new JTextField("  0.0 ");
	override  = createCheckBox("Override", gui.ENABLE_LOCMANMOUSE_DEFAULT);

	add(posLabel);
	add(posUpdate);

	gui.setTriangulate(false);
	gui.setE2EPath(false);
	gui.setLocalPath(false);
	gui.setCurPath(false);
	gui.setWPGraph(false);
	gui.setCoordinate(false);
	gui.setCorrection(false);

	interactive = false;

	if(interactive) {
	    wpgraph      = createCheckBox("waypoint graph", gui.wpGraphEnable);
	    triangulate  = createCheckBox("triangulate", gui.triangulateEnable);
	    e2ePath      = createCheckBox("e2e path", gui.e2ePathEnable);
	    
	    localPath    = createCheckBox("local path", gui.localPathEnable);
	    curPath      = createCheckBox("current path", gui.curPathEnable);
	    
	    //correction   = createCheckBox("correction", gui.correctionEnable);
	    coordinate   = createCheckBox("coordinate", gui.coordEnable);
	    
	    //addClearButton();
	}
    }

    public void updateTimer(long delaySinceLastUpdate)
    {
	String s = Util.textOf(((double)delaySinceLastUpdate)/1000.0,1);
	posUpdate.setText(s);
    }

    public void addClearButton()
    {
	clear = new JButton("ClearAll");
	clear.addMouseListener(this);
	add(clear);
    }

    public JCheckBox createCheckBox(String label, boolean check)
    {
	JCheckBox result = new JCheckBox(label, check);
	result.addItemListener(this);
	add(result);
	return result;
    }

    public void itemStateChanged(ItemEvent e) 
    {
	Object source  = e.getItemSelectable();
	boolean selected = e.getStateChange() == ItemEvent.SELECTED;

	if(source == override) {
	    // demohack
	    //gui.setEnableLocManMouseListener(selected);
	    if (lm != null) {
		// all demohack here
		if(selected)
		    lm.testReset();
		else
		    lm.testEnable();
	    }
	}
	else if(source == triangulate)
	    gui.setTriangulate(selected);
	else if(source == e2ePath)
	    gui.setE2EPath(selected);
	else if(source == localPath)
	    gui.setLocalPath(selected);
	else if(source == curPath)
	    gui.setCurPath(selected);
	else if(source == correction)
	    gui.setCorrection(selected);
	else if(source == wpgraph)
	    gui.setWPGraph(selected);
	else if(source == coordinate)
	    gui.setCoordinate(selected);

    }

    /* MouseListener stuff */
    public void mouseClicked(MouseEvent e) {
	if(e.getSource() == clear) {
	    System.out.println("foobar");
	    gui.setTriangulate(false);
	    gui.setE2EPath(false);
	    gui.setLocalPath(false);
	    gui.setCurPath(false);
	    gui.setCorrection(false);
	    gui.setWPGraph(false);
	    gui.setCoordinate(false);

	    triangulate.setSelected(false);
	    e2ePath.setSelected(false);
	    localPath.setSelected(false);
	    curPath.setSelected(false); 
	    correction.setSelected(false); 
	    wpgraph.setSelected(false);
	    coordinate.setSelected(false);
	}
    }
    
    public void mouseEntered(MouseEvent e) { return; }
    public void mouseExited(MouseEvent e) { return; }
    public void mousePressed(MouseEvent e) { return; }
    public void mouseReleased(MouseEvent e) { return; }


}


