package navigator;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

class DrawingArea 
    extends JPanel 
{
    private Image   img;
    private Graphics gc;

    public DrawingArea() 
    {
	super();
	initialize();
    }

    void setImageAndGC(Image i, Graphics g) 
    {
	img = i; gc = g;
	repaint();
    }

    Graphics getContext() { return gc; }

    // Initialize data structure
    void initialize() 
    {
	setEnabled(true);
	setDoubleBuffered(true);
	repaint();
    }

    public void update(Graphics g)
    {
	//double buffering to avoid flickering
	if(img != null) {
	    //	    gc = img.getGraphics();
	    //paint(gc);
	    g.drawImage(img, 0, 0, this);
	}
    }

    public void paint(Graphics g) 
    {
	//super.paint(g);
	if(img != null)
	    g.drawImage(img, 0, 0, this);
    }

    void flush()
    {
	gc.clearRect(0, 0, 
		     getPreferredSize().width, 
		     getPreferredSize().height);
    }
}



