package navigator;

import java.awt.geom.*;
import java.awt.*;
import java.util.*;

// node represents the center of triangle
class TreeNode 
{
    NavPoint2D p;
    Edge[] e; // the three (triangle) Edges associated with TreeNode
    Polygon face;

    TreeNode parent;
    Vector   children;
    int      curDist;
    int      curHop;

    boolean isDoor;

    public boolean equals(Object o)
    {
	TreeNode other = (TreeNode) o;
	Util.assert(other != null, "foobar");
	
	/*
	  System.out.println(e[0]);
	  System.out.println(e[1]);
	  System.out.println(e[2]);
	  
	  System.out.println(other.e[0]);
	  System.out.println(other.e[1]);
	  System.out.println(other.e[2]);
	*/

	return 
	    (e[0] == other.e[0] && e[1] == other.e[1] && e[2] == other.e[2] );
	    /*||
	    (e[0] == other.e[0] && e[1] == other.e[2] && e[2] == other.e[1] ) ||
	    (e[0] == other.e[1] && e[1] == other.e[0] && e[2] == other.e[2] ) ||
	    (e[0] == other.e[2] && e[1] == other.e[0] && e[2] == other.e[1] ) ||
	    (e[0] == other.e[1] && e[1] == other.e[2] && e[2] == other.e[0] ) ||
	    (e[0] == other.e[2] && e[1] == other.e[1] && e[2] == other.e[0] );*/
    }

    public Object clone()
    {
	TreeNode result = new TreeNode();
	result.p    = p;
	result.e    = e;
	result.face = face;

	result.curDist = curDist;
	result.isDoor  = isDoor;
	return result;
    }

    // assume consecutive edges are connected
    public TreeNode()
    {
	children = new Vector();
	face     = new Polygon();
	isDoor   = false;
    }

    public void init(Edge[] edges)
    {
	e = edges;
	p = e[0].org();

	for(int i = 0; i < 3; i++) {
	    int x = e[i].rot().dest().x;
	    int y = e[i].rot().dest().y;
	    // FIXME: loses some accuracy here...
	    face.addPoint(x, y);
	}
	reset();
    }

    public void reset()
    {
	curDist  = Integer.MAX_VALUE;
	curHop   = 0;
	parent   = null;
	children.clear();
    }

    public String toString()
    {
	String result = p+"\n";
	for(int i = 0; i < 3; i++) {
	    result += e[i].rot() +"\n";
	}
	result += "\n";
	return result;
    }
}
