package positiondemo;

import java.awt.*;

class BeaconLabel {
    private static final int size     = 8;
    private static final int sizeHalf = size/2;
    private static final Font font = new Font("Arial", Font.BOLD, 16);

    private int x, y;
    private String label;

    public BeaconLabel(int x, int y, String l) 
    {
	// optimization for drawing... store the value
	// subtract the size offset for rendering
	// Hence the abstract function maps x - sizeHalf to x
	// ie. AF(x) = x + sizeHalf; AF(y) = y + sizeHalf;
	this.x = x-sizeHalf;
	this.y = y-sizeHalf;
	label = l;
    }
    
    public int getX() { return x + size; }
    public int getY() { return y + size; }
    public String getLabel() { return label; }
    
    public void draw(Graphics gc) 
    {
	gc.fillRect(x, y, size, size);
	gc.setFont(font);
	gc.drawString(label, x, y-2);
    }
}
