package positiondemo;

import java.awt.*;
import java.util.*;

class GUI 
{
    private static final int size     = 16;
    private static final int sizeHalf = size/2;

    static int width  = 240;
    static int height = 300;

    private CustomFrame frame;
    private DrawingArea drawArea;
    private Map map;

    // current location
    private int x;
    private int y;

    // need an api that updates the mesh and labels dynamically
    GUI(Map m)
    {
	map   = m;
	frame = new CustomFrame("PositionDemo", width, height);
	frame.getContentPane().setLayout(new BorderLayout());
	
	drawArea = new DrawingArea();
	//drawArea.addMouseListener(this);
	//drawArea.addMouseMotionListener(this);
	
	frame.getContentPane().add(drawArea, "Center");	
	frame.setResizable(false);
	frame.validate();
	frame.pack();
	frame.setVisible(true);

	drawArea.setPreferredSize(new Dimension(width, height));
	Image img = frame.createImage(width, height);
	Graphics gc = img.getGraphics();
	drawArea.setImageAndGC(img, gc);

	setLocation(100,100);
    }

    public void setLocation(double x, double y) 
    { 
	this.x = map.transformX((float) x) - sizeHalf;
	this.y = map.transformY((float) y) - sizeHalf;
    }

    public void refresh()
    {
	drawArea.flush();
	Graphics gc = drawArea.getContext();
	map.draw(gc);
	drawLocation(gc);
	drawArea.repaint();
    }

    private void drawLocation(Graphics gc)
    {
	gc.setColor(Color.yellow);
	gc.fillOval(x, y, size, size);
    }
}
