package positiondemo;

import cricketdaemon.clientlib.*;
import cricketdaemon.clientlib.data.*;
import cricketdaemon.CricketDaemon;
import gnu.getopt.*;

import java.util.*;

public class PositionDemo
    implements Callback
{
    private GUI gui;

    public PositionDemo(String fileName, String hostname, int port)
    {
	// setup map
	Map map = new Map(fileName);
	gui = new GUI(map);
	gui.refresh();
	
	
	BitSet mask = new BitSet();
	mask.set(Broker.DEVICECOORD);

	ServerBroker s = new ServerBroker(hostname, port);
	s.register(this, mask);
	s.start();

    }

    public void callback(CricketData data, BitSet mask) 
    {
	if(mask.get(Broker.DEVICECOORD)) {
	    Position p = data.getDevicePosition();
	    gui.setLocation(p.x, p.y);
	    gui.refresh();
	}
    }
    
    public static void main(String args[]) 
    {
	String filename = "default.map";
	String hostname = "127.0.0.1";
	int port        = cricketdaemon.server.ServerModule.PORT;

	Getopt g = new Getopt("PositionDemo", args, "f::h::il::p::s::z");

	int c;
	while((c = g.getopt()) != -1) {
	    switch(c) {
	    case 'f':
		filename = CricketDaemon.getOpt(g, filename);
		break;
	    case 'h':
		hostname = CricketDaemon.getOpt(g, hostname);
		break;
	    case 'p':
		port = Integer.parseInt(CricketDaemon.getOpt(g, String.valueOf(port)));
		break;
	    default:
		usage();
	    }
	}

	new PositionDemo(filename, hostname, port);
    }

    private static void usage()
    {
	System.err.println("Usage: java positiondemo.PositionDemo [-fMAP] [-hHOSTADDR] [-pPORT]\n");
	System.exit(1);
    }
}




