/*
 * Copyright (c) 2000, 2001 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `LICENSE' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file CRICKETAUTHORS which should have accompanied 
 * this software for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the CRICKETAUTHORS file.
 */
package samplemon;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

/**
 * A frame for the GUI of ViewFinderApp.
 *
 * @author Allen Miu
 */
public class CustomFrame extends JFrame {

    Dimension preferredSize = null;

    public CustomFrame (String frameTitle) {
	super(frameTitle);
	//same thing
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	/*
	  addWindowListener(new WindowAdapter() {
	  public void windowClosing(WindowEvent event) {
	  System.exit(1);
	  } 
	  });
	*/
    }

    public CustomFrame (String frameTitle, int x, int y) {
	super(frameTitle);
	preferredSize = new Dimension(x,y);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

    public Dimension getPreferredSize() 
    {
	if(preferredSize != null)
	    return preferredSize;
	else 
	    return super.getPreferredSize();
    }

    public void finishInit()
    {
	validate();
	pack();
	setVisible(true);
    }
}

