package spacedemo;

import java.util.*;

public class Util 
{
    public static boolean debugMode = false;

    public static void dbgPrintln(String s) 
    {
	if(debugMode) 
	    System.out.println(s);
    }
    
    public static void assert(boolean pred, String errMsg) 
    {
	try {
	    if(!pred)
		throw new Exception();
	}
	catch (Exception e) {
	    System.err.println("ASSERTION FAILED--> "+errMsg);
	    e.printStackTrace();
	    System.exit(1);
	}
    }

    public static String textOf(double d, int places) 
    {
	String s = String.valueOf(d);
	int endIndex = s.length();
	int decIndex = s.indexOf(".");
	if(decIndex >= 0)
	    endIndex = min(endIndex, decIndex + places + 1);
	
	return s.substring(0, endIndex);
    }

    public static int min(int a, int b)
    {
	if(b < a)
	    return b;
	return a;
    }

}
