package streamredirector;

/**
 * This exception gets raised by the SinkProxy if it fails to connect the server and
 * sink input and output streams (specifically, if either the setInputStream() or
 * setOutputStream() methods in the ServerConnection or SinkConnection (respectively) fail).
 *
 * @see streamredirector.SinkProxy, streamredirector.ServerConnection, streamredirector.SinkConnection
 * @author Jorge Rafael Nogueras
 */

public class CannotConnectServerToSinkException extends Exception
{
	/**
	 * Calls the constructor in Exception that takes a descriptive text message.
	 *
	 * @param message the descriptive text that gives more information about the exception
	 */

	public CannotConnectServerToSinkException (String message)
	{
		super (message);
	}
}