package streamredirector;

/**
 * This exception gets raised by the SinkProxy if it fails to establish a connection
 * to the server (specifically, if there is an error calling establishServerConnection()).
 *
 * @see streamredirector.SinkProxy, streamredirector.ServerConnection
 * @author Jorge Rafael Nogueras
 */

public class CannotEstablishServerConnectionException extends Exception
{
	/**
	 * Calls the constructor in Exception that takes a descriptive text message.
	 *
	 * @param message the descriptive text that gives more information about the exception
	 */

	public CannotEstablishServerConnectionException (String message)
	{
		super (message);
	}
}