package streamredirector;

/**
 * This exception gets raised by the SinkProxy if it fails to establish a connection
 * to the sink (specifically, if there is an error calling establishSinkConnection()).
 *
 * @see streamredirector.SinkProxy, streamredirector.SinkConnection
 * @author Jorge Rafael Nogueras
 */

public class CannotEstablishSinkConnectionException extends Exception
{
	/**
	 * Calls the constructor in Exception that takes a descriptive text message.
	 *
	 * @param message the descriptive text that gives more information about the exception
	 */

	public CannotEstablishSinkConnectionException (String message)
	{
		super (message);
	}
}