package streamredirector;

import java.io.*;

/**
 * This abstract class should be extended by any command that can be sent to the sink proxy. A
 * generic command does not have to implement any methods, and thus this class serves to "tag"
 * all commands under one name. Commands that are meant to be sent to the server are called
 * ServerCommands, and these are specific to the protocol the server uses; commands that are ment
 * for sinks are called SinkCommands.
 *
 * @see streamredirector.ServerCommand, streamredirector.SinkCommand
 * @author Jorge Rafael Nogueras
 */

public abstract class Command implements Serializable
{
  /**
   * Prints a useful description of this object.
   *
   * @return a String with a useful description of this object
   */

	public String toString()
	{
		return "[Command]";
	}
}