package streamredirector;

/**
 * This exception gets raised by the TCPListeningTransportInstance if it reads a method
 * descriptor with a name that does not match any of the commands specified in the
 * CommandListener interface.
 *
 * @see streamredirector.TCPListeningTransportInstance, streamredirector.MethodDescriptor, streamredirector.CommandListener
 * @author Jorge Rafael Nogueras
 */

public class InvalidMethodNameException extends Exception
{
	/**
	 * Calls the constructor in Exception that takes a descriptive text message.
	 *
	 * @param message the descriptive text that gives more information about the exception
	 */

	public InvalidMethodNameException (String message)
	{
		super (message);
	}
}