package streamredirector;

/**
 * This exception gets raised by a concrete ServerConnection object if it cannot find
 * the resource that the controller has told it to open and send to the sink.
 *
 * @see streamredirector.SinkProxy, streamredirector.ServerConnection, streamredirector.SinkConnection
 * @author Jorge Rafael Nogueras
 */

public class InvalidResourceException extends Exception
{
	/**
	 * Calls the constructor in Exception that takes a descriptive text message.
	 *
	 * @param message the descriptive text that gives more information about the exception
	 */

	public InvalidResourceException (String message)
	{
		super (message);
	}
}