package streamredirector;

/**
 * This class stores the location information of its listener. It keeps track of the old
 * location as well as the new one.
 *
 * @see streamredirector.LocationUpdateListener
 * @author Jorge Rafael Nogueras
 */

public class LocationInformation
{
  /** the previous location of the listener */
  public String oldLocation;

  /** the new location of the listener */
  public String newLocation;

  /**
   * Initializes the location information with the pertinent old and new locations.
   *
   * @param the_oldLocation the previous location of the listener
   * @param the_newLocation the new location of the listener
   */

  public LocationInformation (String the_oldLocation, String the_newLocation)
  {
    oldLocation = the_oldLocation;
    newLocation = the_newLocation;
  }
  
  /**
   * Returns the previous location of the listener.
   *
   * @return the previous location of the listener
   */
  
  public String getOldLocation()
  {
    return oldLocation;
  }
  
  /**
   * Returns the new location of the listener.
   *
   * @return the new location of the listener
   */
  
  public String getNewLocation()
  {
    return newLocation;
  }
  
  /**
   * Prints a useful description of this object.
   *
   * @return a String with a useful description of this object
   */

  public String toString()
  {
    return "[" + this.getClass().getName() + ": old location = " + oldLocation +
            ", new location = " + newLocation + "]";
  }
}