package streamredirector;

/**
 * This interface should be implemented by any class that is interested in being notified
 * when its location information changes.
 *
 * @see streamredirector.LocationInformation
 * @author Jorge Rafael Nogueras
 */

public interface LocationUpdateListener
{
  /*
   * Notifies the listener that its location has changed.
   *
   * @param info the object that contains the location information (new and old)
   */

  public void updateLocation (LocationInformation info);
}