package streamredirector;

/**
 * This abstract class should be extended by any command that is meant for the server:
 * these commands are specific to the protocol the server uses. Its only method is for
 * returning a wire representation of the command that can be written out to the server.
 *
 * @see streamredirector.Command
 * @author Jorge Rafael Nogueras
 */

public abstract class ServerCommand extends Command
{
	/**
	 * Returns a wire representation of the command that is suitable for writing to the server.
   *
   * @return the wire representation of the command
	 */
	
	public abstract Object translateCommand();
}