package streamredirector;

import ins.api.*;
import ins.namespace.*;

import java.util.*;
import java.io.*;
import java.net.*;
import java.rmi.*;
import java.lang.reflect.*;

/**
 * This is class is a sink connection that writes all the input it receives to
 * a specified filename. It has a listening thread that gets data from an input stream
 * and writes it out to the file. Note that only the fileName data member is not transient
 * since it is the only one that should be serialized and sent along with the object;
 * the rest of the variables will get initialized only after the "establishConnection()"
 * method is called.
 *
 * @see streamredirector.SinkConnection
 * @author Jorge Rafael Nogueras
 */

public class TestMainApplication
{
  protected int count = 5;
  protected String test = "this is a test";
  protected Hashtable table = new Hashtable();
  
  public TestMainApplication()
  {
    table.put ("one", "the value of 1");
  }
  
  public static void main (String args []) throws Exception
  {
    // <HERE> testing new resource entry class
    ServerDatabaseManager.initialize();
//    ServerDatabaseManager.printDatabaseInfo();
    System.out.println ("Got resource: " + ServerDatabaseManager.getEntry (new URL ("http://beacon.lcs.mit.edu:80/FourTops-ICantHelpMyself.mp3")));
    System.out.println ("Got resource: " + ServerDatabaseManager.getEntry (new URL ("http://beacon.lcs.mit.edu:80/Aerosmith-HoleInMySoul.mp3")));
// size is 5.7 MB
    ResourceEntry e = ServerDatabaseManager.getEntry (new URL ("http://beacon.lcs.mit.edu:80/Aerosmith-HoleInMySoul.mp3"));
    ServerDatabaseManager.writeServerDatabase();
    
    System.out.println ("Got resource: " + ServerDatabaseManager.getEntry (new URL ("http://beacon.lcs.mit.edu:80/Aerosmith-HoleInMySoul.mp3")));

//    Package p = new TestMainApplication().getClass().getPackage();
//    System.out.println ("Package: "+ p +  ", name: " + p.getName());
/*
//    INSTCPSinkProxyDescriptor ns = new INSTCPSinkProxyDescriptor ("[location=mit [building=NE43] [place=earth]]");
//    INSTCPSinkProxyDescriptor ns = new INSTCPSinkProxyDescriptor ("[location=mit [building=NE43 [room=503]]]");
    INSTCPSinkProxyDescriptor ns = new INSTCPSinkProxyDescriptor ("[location=mit [building=NE43 [room=503]]][MIME_types=3[0=video/mpeg][1=audio/x-wav][2=audio/mpeg]]");
//    INSTCPSinkProxyDescriptor ns = new INSTCPSinkProxyDescriptor ("[location=mit]");
    
    System.out.println (ns);
//    System.out.println ("Location: " + ns.getLocation());
    
    String [] m = ns.getAllMIMETypes();
    
    for (int i = 0; i < m.length; i++)
    {
      System.out.println ("Mime type [" + i + "] = " + m [i]);
    }
*/
//    AVelement av = ns.getAVelement (new Attribute ("location"));
//    String num = ns.getAVelement (new Attribute ("location")).getValue().toString();
//    System.out.println (av);
//    System.out.println (num);
//    
//    StringBuffer buf = new StringBuffer();
//    buf.append (num);
//    
//    System.out.println ("Enumeration:");
//    Enumeration e = av.getAVelements();
//    
//    while (e.hasMoreElements())
//    {
//      String s = ((AVelement) e.nextElement()).toString();
//      
//      buf.append (s);
//      System.out.println (s);
//    }
//    
//    System.out.println ("Full location: " + buf);

//    String m1 = ns.getAVelement (new Attribute ("location")).getAVelement (new Attribute ("mit")).getValue().toString();
//    System.out.println (m1);
/*
    TestMainApplication.class.getResourceAsStream ("caca");
    System.out.println ("Is it active? " +
        Controller.proxyIsActive (new INSTCPSinkProxyDescriptor ("[vspace=wind]" +
            "[service=sink_proxy][transport_type=TCP]" +
            "[hostname=localhost][port=3337]")));
*/      
//    WebServerManager.initialize (".", new String [] {"streamredirector.jar"});

    /*
    String webServerHost = WebServerManager.getLocalHost();
    int webServerPort = WebServerManager.getLocalPort();

    // we set the "java.rmi.server.codebase" property; this causes all object encapsulated by a MarshalledObject
    // to be annotated with this codebase; when a remote JVM needs to dynamically load a class, it will ask for
    // our web server to the "streamredirector.jar" class, which will contain all the classes
    System.setProperty ("java.rmi.server.codebase", "http://" + webServerHost + ":" + webServerPort + "/streamredirector.jar");

System.out.println ("Set codebase property to: " + System.getProperty ("java.rmi.server.codebase"));

    TCPTransport t = new TCPTransport ("localhost", 1372);
    
    Long cookie = t.establishConnection (new HTTPServerConnection (new URL ("http://localhost/test")), new NullSinkConnection());
    
*/
//System.out.println ("Codebase: " + System.getProperty ("java.rmi.server.codebase"));
//    System.setProperty ("java.rmi.server.codebase", "http://rafaeln.ne.mediaone.net/something.jar");
//    
//System.out.println ("Codebase: " + System.getProperty ("java.rmi.server.codebase"));
//System.out.println ("Caca: " + System.getProperty ("java.caca"));
//    ObjectOutputStream oos = null;
//    try {
//      oos = new ObjectOutputStream(new BufferedOutputStream(
//                              new FileOutputStream("test.ser")));
//      oos.writeObject(new MarshalledObject(new HTTPGetCommand(
//                                     "a marshalled string")));
//    }
//    finally {
//      if (oos != null) oos.close();
//    }
//    System.out.println("Wrote to " + "test.ser");
//
//    WebProxyManager.initialize (8080);
//    
//    new HTTPGetCommand ("/1234566789/this/is_a_test.mp3");
//    
//System.out.println ("Web proxy at port: " + WebProxyManager.getLocalPort());
    
//    new ClassMonitor (new TestMainApplication());

//    WebServerManager.initialize();
//System.out.println ("Web server at port: " + WebServerManager.getLocalPort());

/*
    long cookie = 1123456789;
    String fileName = "temp.dat";
    
    File cookieDirectory = new File (WebServerManager.getResourceDirectory(), Long.toString (cookie));

System.out.println ("Creating cookie directory: " + cookieDirectory);
    cookieDirectory.mkdir();
    cookieDirectory.deleteOnExit();

    File resourceFile = new File (cookieDirectory, fileName);

System.out.println ("Creating resource file: " + resourceFile);
    resourceFile.createNewFile();
    resourceFile.deleteOnExit();

try { Thread.sleep (10 * 1000); } catch (Exception e) { }
System.exit (0);
*/
/*
    boolean found = false;
    
    do
    {
      Enumeration list = WebServerManager.getConnections();
      
      while (list.hasMoreElements())
      {
//        found = true;
        
        HTTPConnectionState state = (HTTPConnectionState) list.nextElement();

//System.out.println ("Analyzing state: " + state);
        try
        {
          while (state.status == HTTPConnectionState.STOPPED)
            state = (HTTPConnectionState) list.nextElement();
        }
        catch (Exception e)
        {
          continue;
        }

        WebServerInstance w = state.webServer;

try { Thread.sleep (10 * 1000); } catch (Exception e) { }
        
        w.interrupt();
System.out.println ("Interrupted at offset: " + state.offset);

try { Thread.sleep (10 * 1000); } catch (Exception e) { }

      }
    } while (!found);
*/

//System.out.println ("Connecting...");
//    Socket s = new Socket ("localhost", 80);
//    
//    BufferedReader br = new BufferedReader (new InputStreamReader (s.getInputStream()));
//    BufferedWriter bw = new BufferedWriter (new OutputStreamWriter (s.getOutputStream()));
//
//    String line = "GET /caca.jar HTTP/1.0\n\r";
//    bw.write (line, 0, line.length());
//    line = "Host: localhost\n\r";
//    bw.write (line, 0, line.length());
//    line = "Location: http://localhost:8080/caca.mp3\n\r";
//    bw.write (line, 0, line.length());
//    line = "User-agent: Sonique 1.50 (no stream save)\n\r";
//    bw.write (line, 0, line.length());
//    line = "x-audiocast-udpport: 4399\n\r";
//    bw.write (line, 0, line.length());
//    line = "From: @rafaeln\n\r";
//    bw.write (line, 0, line.length());
//    line = "\n\r";
//    bw.write (line, 0, line.length());
//    bw.flush();
//
//System.out.println ("Wrote data, waiting for response...");
//
//    while (!(line = br.readLine()).equals (""))
//    {
//System.out.println ("TestMainApplication::main -> read header: " + line);
//    }
//
//    while ((line = br.readLine()) != null)
//    {
// //System.out.println (line);
//    }
//
//    s.close();

/*
    INSTCPSinkProxyDescriptor ns = new INSTCPSinkProxyDescriptor ("[MIME_types=2 [0=audio/mpeg] [1=video/mpeg]]");
    
    AVelement av = ns.getAVelement (new Attribute ("MIME_types"));
    String num = ns.getAVelement (new Attribute ("MIME_types")).getValue().toString();
    System.out.println (num);
    System.out.println (av);
    String m1 = ns.getAVelement (new Attribute ("MIME_types")).getAVelement (new Attribute ("0")).getValue().toString();
    System.out.println (m1);

    System.out.println (ns.findMIMEType ("audio/caca"));
    System.out.println (ns.findMIMEType ("video/mpeg"));
    
    String [] mimeTypes = ns.getAllMIMETypes();
    
    for (int i = 0; i < mimeTypes.length; i++)
    {
      System.out.println ("Print MIME type: " + mimeTypes [i]);
    }
*/


/*
    File dirs = new File ("dir1/");
    File resourceFile = new File (dirs, "file");
System.out.println ("Making: " + resourceFile.getAbsolutePath());
    dirs.mkdirs();
    File resourceFile2 = new File (dirs, "file2");

    resourceFile.createNewFile();
    resourceFile2.createNewFile();
    dirs.deleteOnExit();
    resourceFile.deleteOnExit();
    resourceFile2.deleteOnExit();

try { Thread.sleep (5 * 1000); } catch (Exception e) { }
*/


/*
    try
    {
      ServerDatabaseManager.initialize ("tempServerDB.dat");
    }
    catch (Exception e)
    {
      System.out.println ("Controller::main -> Error creating database manager: " + e);
//      e.printStackTrace();
    }
    
    Vector temp = new Vector();

    Hashtable table = new Hashtable();
    table.put ("/somefile", new ResourceEntry ("/whatever", "audio/mpeg", "A file we have", "573484"));
    table.put ("/anothersomefile", new ResourceEntry ("/anothersomefile", "video/mpeg", "Some other file", "440"));
    temp.addElement (new ServerEntry ("caca.net", 80, "HTTP", table));
    
    table = new Hashtable();
    table.put ("/sjlfljomefile", new ResourceEntry ("/sjlfljomefile", "text/plain", "test", "65743"));
    table.put ("/anothee3r435rsomefile", new ResourceEntry ("/anothee3r435rsomefile", "text/html", "A desc", "96486"));
    temp.addElement (new ServerEntry ("ftp.myhost.com", 21, "FTP", table));

    ServerDatabaseManager.writeServerDatabase (temp);
*/
/*
    Controller controller = null;
    
    try
    {
      controller = new Controller("[vspace=wind][service=controller]" +
                                  "[location=mit [building=ne43 [floor=5 [room=503]]]]");
    }
    catch (Exception e)
    {
      System.out.println ("Controller::main -> Error creating Controller: " + e);
//      e.printStackTrace();
      System.exit (0);
    }
    
    INSTCPSinkProxyDescriptor sinkProxy = controller.getLocalSink();
    
    ServerEntry serverEntry = (ServerEntry) ServerDatabaseManager.getServerList().nextElement();
    ResourceEntry resourceEntry = (ResourceEntry) serverEntry.resourceList.elements().nextElement();

//    ServerInfo serverInfo = new HTTPServerInfo ("rafaeln.ne.mediaone.net", 80, "/~secret/speech.mp3");
    ServerInfo serverInfo = new HTTPServerInfo (serverEntry, resourceEntry);
    SinkInfo sinkInfo = new TCPSinkInfo (sinkProxy.getHostName(), sinkProxy.getPort());
    
    try
    {
      Long cookie = controller.establishConnection (serverInfo, sinkInfo);

      controller.sendCommand (cookie, new HTTPGetCommand (serverInfo.getSelectedResource()));

//try { Thread.sleep (10 * 1000); } catch (Exception e) { }

      ReturnCode returnCode = new ReturnCode();
      
      cookie = controller.moveConnection (cookie, new FileTCPSinkInfo (sinkProxy.getHostName(), sinkProxy.getPort(), "default2.mp3"), returnCode);

try { Thread.sleep (10 * 1000); } catch (Exception e) { }

      controller.endConnection (cookie);
    }
    catch (Exception e)
    {
      System.err.println ("Oops... something went wrong establishing the connection");
      e.printStackTrace();
    }
    System.exit (0);
*/
  }
}
