package streamredirector;

import ins.api.*;
import ins.namespace.*;

import java.util.*;
import java.io.*;
import java.net.*;
import java.rmi.*;
import java.security.*;

/**
 * This is class is a sink connection that writes all the input it receives to
 * a specified filename. It has a listening thread that gets data from an input stream
 * and writes it out to the file. Note that only the fileName data member is not transient
 * since it is the only one that should be serialized and sent along with the object;
 * the rest of the variables will get initialized only after the "establishConnection()"
 * method is called.
 *
 * @see streamredirector.SinkConnection
 * @author Jorge Rafael Nogueras
 */

public class TestMainApplication2
{
  public TestMainApplication2()
  {
  }
  
  public static void main (String args []) throws Exception
  {
    // we set a basic security manager and instruct it to allow connections to remote sockets
    // (from where it can load the bytecodes of class files not in the current classpath
    System.setSecurityManager (new RMISecurityManager()
    {
      public void checkPermission (Permission p)
      {
      }
    });
    
    SinkProxy s = SinkProxy.getInstance();

    TCPListeningTransport t = new TCPListeningTransport (s, 5050);
    t.startListening();
    
//    Player p = Player.getInstance ("c:/winamp/ewinamp.exe");
//    Player p2 = Player.getInstance ("c:/winamp/winamp.exe");
//
//System.out.println ("Player: " + p + ", are they equal? " + (p == p2));
//
//    PlayerManager.initialize ("streamredirector/players.dat");
//    Player p = MP3Player.getInstance ("C:/Program Files/Sonique/Sonique.exe%-ADD");
//    Player p2 = MP3Player.getInstance ("C:/Program Files/Sonique/Sonique.exe%-DROP");
//System.out.println ("Player: " + p + ", p2 = " + p2 + ", are they equal? " + (p == p2));
//
//((MP3Player) p).play ("test");
/*
    // we set a basic security manager and instruct it to allow connections to remote sockets
    // (from where it can load the bytecodes of class files not in the current classpath
    System.setSecurityManager (new RMISecurityManager()
    {
      public void checkPermission (Permission p)
      {
      }
    });

    System.out.println ("Properties: " + System.getProperties());
    
    Enumeration list = System.getProperties().propertyNames();
    
    while (list.hasMoreElements())
    {
      System.out.println ("Names: " + (String) list.nextElement());
    }
    

    ObjectInputStream ois = null;
    try {
      ois = new ObjectInputStream(new BufferedInputStream(
                                  new FileInputStream("test.ser")));
      MarshalledObject o = (MarshalledObject) ois.readObject();
      System.out.println("Read MarshalledObject from file " +
                        "test.ser"+ ", contents are:");
      Object containee = o.get();
      System.out.println(containee);
      
      Command c = (Command) containee;
System.out.println ("Command: " + containee);

//      HTTPCommand hc = (HTTPCommand) c;
//System.out.println ("HTTPCommand: " + hc);
//
//      HTTPGetCommand gc = (HTTPGetCommand) hc;
//System.out.println ("HTTPGetCommand: " + gc);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    finally {
      if (ois != null) ois.close();
    }
*/
  }
}