package streamredirector;

/**
 * This exception gets raised by a manager class whose static methods are used before the
 * "initialize()" method is called. This should not happen during the normal execution of
 * the program since the managers should be initialized at the beginning of the program
 * execution.
 *
 * @see streamredirector.PlayerManager, streamredirector.ServerDatabaseManager
 * @author Jorge Rafael Nogueras
 */

public class UninitializedManagerException extends RuntimeException
{
  /**
   * Calls the constructor in Exception that takes a descriptive text message.
   *
   * @param message the descriptive text that gives more information about the exception
   */

  public UninitializedManagerException (String message)
  {
    super (message);
  }
}