package streamredirector.player;

import java.awt.*;
import java.util.Vector;
import java.io.File;
import javax.media.*;
import javax.media.control.TrackControl;
import javax.media.control.QualityControl;
import javax.media.control.FramePositioningControl;
import javax.media.Format;
import javax.media.format.*;
import javax.media.datasink.*;
import javax.media.protocol.*;
import javax.media.protocol.DataSource;
import java.io.IOException;

/**
 * A sample program to cut an input file given the start and end points.
 */
public class Cut implements ControllerListener
{
    /**
     * Main program
     */
    VideoPlayer vp;
    long offset = 0L;
    Cut cut;

	public void play (String mediaLocator) throws Exception
	{
		play (mediaLocator, 0L);
	}

	public void play (String mediaLocator, long offset) throws Exception
	{
	// Generate the input and output media locators.
	MediaLocator iml;
	MediaLocator oml;

     this.offset = offset;

	if ((iml = createMediaLocator(mediaLocator)) == null) {
	    System.err.println("Cannot build media locator from: " + mediaLocator);
	    System.exit(0);
	}


	// Trancode with the specified parameters.
//	cut  = new Cut();

	long[] start = new long[1];
	start[0]=offset;
	long[] end = new long[1];
	end[0]=Long.MAX_VALUE;

	if (!doIt(iml, null, start, end, false)) {
	    System.err.println("Failed to cut the input");
	}

	}

	public void stop() throws Exception
	{
	try{
	System.out.println ("vp: " + vp);// + ", vp.player: " + vp.getPlayer());
	vp.getPlayer().stop();
	vp.getPlayer().deallocate();
	vp.setVisible(false);
	} catch (Exception e) { e.printStackTrace();}

	}

	public long getLastByteOffset() throws Exception
	{
	return vp.getPlayer().getMediaTime().getNanoseconds() + this.offset;
	}

    /**
     * Given a source media locator, destination media locator and
     * a start and end point, this program cuts the pieces out.
     */
    public boolean doIt(MediaLocator inML, MediaLocator outML,
		long start[], long end[], boolean frameMode) {

	// Guess the output content descriptor from the file extension.
 	ContentDescriptor cd;

/*	if ((cd = fileExtToCD(outML.getRemainder())) == null) {
	    System.err.println("Couldn't figure out from the file extension the type of output needed!");
	    return false;
	}
*/
	Processor p;

	try {
	    System.err.println("- Create processor for: " + inML);
	    p = Manager.createProcessor(inML);
	    System.out.println("Processor type is"+p.toString());
	} catch (Exception e) {
	    System.err.println("Yikes!  Cannot create a processor from the given url: " + e);
	    return false;
	}

	System.err.println("- Configure the processor for: " + inML);
	if (!waitForState(p, p.Configured)) {
	    System.err.println("Failed to configure the processor.");
	    return false;
	}

	checkTrackFormats(p);

	System.err.println("- Realize the processor for: " + inML);
	if (!waitForState(p, p.Realized)) {
	    System.err.println("Failed to realize the processor.");
	    return false;
	}

	// Set the JPEG quality to .5.
	setJPEGQuality(p, 0.5f);

	// Translate frame # into time.
	if (frameMode) {
	    FramePositioningControl fpc = (FramePositioningControl)p.getControl("javax.media.control.FramePositioningControl");

	    if (fpc != null) {
		Time t;
		for (int i = 0; i < start.length; i++) {
		    t = fpc.mapFrameToTime((int)start[i]);
		    if (t == FramePositioningControl.TIME_UNKNOWN) {
			fpc = null;
			break;
		    } else
			start[i] = t.getNanoseconds();
		    if (end[i] == Long.MAX_VALUE)
			continue;
		    t = fpc.mapFrameToTime((int)end[i]);
		    if (t == FramePositioningControl.TIME_UNKNOWN) {
			fpc = null;
			break;
		    } else
			end[i] = t.getNanoseconds();
		}
	    }

	    if (fpc == null) {
		System.err.println("Sorry... the given input media type does not support frame positioning.");
		return false;
	    }
	}

	SuperCutDataSource ds = new SuperCutDataSource(p, inML, start, end);

	// Create the processor to generate the final output.
/*	try {
	    p = Manager.createProcessor(ds);
	} catch (Exception e) {
	    System.err.println("Failed to create a processor to concatenate the inputs.");
	    return false;
	}

	p.addControllerListener(this);

	// Put the Processor into configured state.
	if (!waitForState(p, p.Configured)) {
	    System.err.println("Failed to configure the processor.");
	    return false;
	}

	// Set the output content descriptor on the final processor.
	System.err.println("- Set output content descriptor to: " + cd);
	if ((p.setContentDescriptor(cd)) == null) {
	    System.err.println("Failed to set the output content descriptor on the processor.");
	    return false;
	}

	// We are done with programming the processor.  Let's just
	// realize and prefetch it.
	if (!waitForState(p, p.Prefetched)) {
	    System.err.println("Failed to realize the processor.");
	    return false;
	}

	// Now, we'll need to create a DataSink.
	DataSink dsink;
	if ((dsink = createDataSink(p, outML)) == null) {
	    System.err.println("Failed to create a DataSink for the given output MediaLocator: " + outML);
	    return false;
	}

	dsink.addDataSinkListener(this);
	fileDone = false;
*/
	//We create the video player to play our file
	 vp=new VideoPlayer();
	 System.out.println ("Vp initialized to: " + vp);
	//vp.open(p.getDataOutput());
	vp.open(ds);
	System.out.println ("Vp after opening: " + vp);
	System.err.println("- Start cutting...");

	// OK, we can now start the actual concatenation.
//	try {
	    p.start();
	  //  dsink.start();
	    vp.getPlayer().start();
	    System.out.println ("Vp after starting: " + vp);
//	} catch (IOException e) {
//	    System.err.println("IO error during concatenation");
//	    return false;
//	}

	// Wait for EndOfStream event.
	//waitForFileDone();

	// Cleanup.
	//try {
	//    dsink.close();
	//} catch (Exception e) {}
	p.removeControllerListener(this);



	System.err.println("  ...done cutting.");
	for(int i=0;i<ds.getStreams().length;i++)
	System.out.println("total bytes read..."+ds.streams[i].totalBytesRead);
	for(int i=0;i<ds.getStreams().length;i++)
	System.out.println("bytes kept after cut "+ds.streams[i].totalBytesKept);

	return true;
    }


    /**
     * Transcode the MPEG audio to linear and video to JPEG so
     * we can do the cutting.
     */
    void checkTrackFormats(Processor p) {

	TrackControl tc[] = p.getTrackControls();
	VideoFormat mpgVideo = new VideoFormat(VideoFormat.MPEG);
	AudioFormat rawAudio = new AudioFormat(AudioFormat.LINEAR);

	for (int i = 0; i < tc.length; i++) {
	    Format preferred = null;

	    if (tc[i].getFormat().matches(mpgVideo)) {
		preferred = new VideoFormat(VideoFormat.JPEG);
	    } else if (tc[i].getFormat() instanceof AudioFormat &&
		     !tc[i].getFormat().matches(rawAudio)) {
		preferred = rawAudio;
	    }

	    if (preferred != null) {
		Format supported[] = tc[i].getSupportedFormats();
		Format selected = null;

		for (int j = 0; j < supported.length; j++) {
		    if (supported[j].matches(preferred)) {
			selected = supported[j];
			break;
		    }
		}

		if (selected != null) {
		    System.err.println("  Transcode:");
		    System.err.println("     from: " + tc[i].getFormat());
		    System.err.println("     to: " + selected);
		    tc[i].setFormat(selected);
		}
	    }
	}
    }


    /**
     * Setting the encoding quality to the specified value on the JPEG encoder.
     * 0.5 is a good default.
     */
    void setJPEGQuality(javax.media.Player p, float val) {

	Control cs[] = p.getControls();
	QualityControl qc = null;
	VideoFormat jpegFmt = new VideoFormat(VideoFormat.JPEG);

	// Loop through the controls to find the Quality control for
 	// the JPEG encoder.
	for (int i = 0; i < cs.length; i++) {

	    if (cs[i] instanceof QualityControl &&
		cs[i] instanceof Owned) {
		Object owner = ((Owned)cs[i]).getOwner();

		// Check to see if the owner is a Codec.
		// Then check for the output format.
		if (owner instanceof Codec) {
		    Format fmts[] = ((Codec)owner).getSupportedOutputFormats(null);
		    for (int j = 0; j < fmts.length; j++) {
			if (fmts[j].matches(jpegFmt)) {
			    qc = (QualityControl)cs[i];
	    		    qc.setQuality(val);
			    System.err.println("- Set quality to " +
					val + " on " + qc);
			    break;
			}
		    }
		}
		if (qc != null)
		    break;
	    }
	}
    }


    /**
     * Utility function to check for raw (linear) audio.
     */
    boolean isRawAudio(Format fmt) {
	return (fmt instanceof AudioFormat) &&
		fmt.getEncoding().equalsIgnoreCase(AudioFormat.LINEAR);
    }


    /**
     * Utility class to block until a certain state had reached.
     */
    public class StateWaiter implements ControllerListener {

	Processor p;
	boolean error = false;

	StateWaiter(Processor p) {
	    this.p = p;
	    p.addControllerListener(this);
	}

	public synchronized boolean waitForState(int state) {

	    switch (state) {
	    case Processor.Configured:
		p.configure(); break;
	    case Processor.Realized:
		p.realize(); break;
	    case Processor.Prefetched:
		p.prefetch(); break;
	    case Processor.Started:
		p.start(); break;
	    }

	    while (p.getState() < state && !error) {
		try {
		    wait(1000);
		} catch (Exception e) {
		}
	    }
	    //p.removeControllerListener(this);
	    return !(error);
	}

	public void controllerUpdate(ControllerEvent ce) {
	//System.out.println(ce);
	    if (ce instanceof ControllerErrorEvent) {
		error = true;
	    }
	    else if(ce instanceof EndOfMediaEvent){
	    System.out.println(vp.getPlayer().getMediaTime().getNanoseconds());
	    System.out.println("blah");
	    //vp.getPlayer().stop();
	    	}
	    synchronized (this) {
		notifyAll();
	    }
	}
    }


    /**
     * Create the DataSink.
     */
    DataSink createDataSink(Processor p, MediaLocator outML) {

	DataSource ds;

	if ((ds = p.getDataOutput()) == null) {
	    System.err.println("Something is really wrong: the processor does not have an output DataSource");
	    return null;
	}

	DataSink dsink;

	try {
	    System.err.println("- Create DataSink for: " + outML);
	    dsink = Manager.createDataSink(ds, outML);
	    dsink.open();
	} catch (Exception e) {
	    System.err.println("Cannot create the DataSink: " + e);
	    return null;
	}

	return dsink;
    }


    /**
     * Block until the given processor has transitioned to the given state.
     * Return false if the transition failed.
     */
    boolean waitForState(Processor p, int state) {
	return (new StateWaiter(p)).waitForState(state);
    }


    /**
     * Controller Listener.
     */
    public void controllerUpdate(ControllerEvent evt) {
	//System.out.println(evt);


	if (evt instanceof ControllerErrorEvent) {
	    System.err.println("Failed to cut the file.");
	    System.exit(-1);
	} else if (evt instanceof EndOfMediaEvent) {
	    //evt.getSourceController().close();
	}
    }


    Object waitFileSync = new Object();
    boolean fileDone = false;
    boolean fileSuccess = true;

    /**
     * Block until file writing is done.
     */
/*    boolean waitForFileDone() {
	System.err.print("  ");
	synchronized (waitFileSync) {
	    try {
		while (!fileDone) {
		    waitFileSync.wait(1000);
		    System.err.print(".");
		}
	    } catch (Exception e) {}
	}
	System.err.println("");
	return fileSuccess;
    }*/


    /**
     * Event handler for the file writer.
     */
/*    public void dataSinkUpdate(DataSinkEvent evt) {
	System.out.println("sink update");
	if (evt instanceof EndOfStreamEvent) {
	    synchronized (waitFileSync) {
		fileDone = true;
		waitFileSync.notifyAll();
	    }
	} else if (evt instanceof DataSinkErrorEvent) {
	    synchronized (waitFileSync) {
		fileDone = true;
		fileSuccess = false;
		waitFileSync.notifyAll();
	    }
	}
    }

*/
    /**
     * Convert a file name to a content type.  The extension is parsed
     * to determine the content type.
     */
/*    ContentDescriptor fileExtToCD(String name) {

	String ext;
	int p;

	// Extract the file extension.
	if ((p = name.lastIndexOf('.')) < 0)
	    return null;

	ext = (name.substring(p + 1)).toLowerCase();

	String type;

	// Use the MimeManager to get the mime type from the file extension.
	if ( ext.equals("mp3")) {
	    type = FileTypeDescriptor.MPEG_AUDIO;
        } else {
	    if ((type = com.sun.media.MimeManager.getMimeType(ext)) == null)
		return null;
	    type = ContentDescriptor.mimeTypeToPackageName(type);
	}

	return new FileTypeDescriptor(type);
    }

*/
    /**
     * Create a media locator from the given string.
     */
    static MediaLocator createMediaLocator(String url) {

	MediaLocator ml;

	if (url.indexOf(":") > 0 && (ml = new MediaLocator(url)) != null)
	    return ml;

	if (url.startsWith(File.separator)) {
	    if ((ml = new MediaLocator("file:" + url)) != null)
		return ml;
	} else {
	    String file = "file:" + System.getProperty("user.dir") + File.separator + url;
	    if ((ml = new MediaLocator(file)) != null)
		return ml;
	}

	return null;
    }


    static void prUsage() {
	System.err.println("Usage: java Cut -o <output> <input> [-f] -s <startTime> -e <endTime> ...");
	System.err.println("     <output>: input URL or file name");
	System.err.println("     <input>: output URL or file name");
	System.err.println("     <startTime>: start time in milliseconds");
	System.err.println("     <endTime>: end time in milliseconds");
	System.err.println("     -f: specify the times in video frames instead of milliseconds");
	System.exit(0);
    }


    ////////////////////////////////////////
    //
    // Inner classes.
    ////////////////////////////////////////

    /**
     * The customed DataSource to cut input.
     */
    class SuperCutDataSource extends PushBufferDataSource {

	Processor p;
	MediaLocator ml;
	PushBufferDataSource ds;
	SuperCutStream streams[];

	public SuperCutDataSource(Processor p, MediaLocator ml,
			long start[], long end[]) {
	    this.p = p;
	    this.ml = ml;
	    this.ds = (PushBufferDataSource)p.getDataOutput();

	    TrackControl tcs[] = p.getTrackControls();
	    PushBufferStream pbs[] = ds.getStreams();

	    streams = new SuperCutStream[pbs.length];
	    for (int i = 0; i < pbs.length; i++) {
		streams[i] = new SuperCutStream(tcs[i], pbs[i], start, end);
	    }
	}

	public void connect() throws java.io.IOException {
	}

	public PushBufferStream [] getStreams() {
	    return streams;
	}

	public void start() throws java.io.IOException {
	    p.start();
	    ds.start();
	}

	public void stop() throws java.io.IOException {
	}

	public Object getControl(String name) {
	    // No controls
	    return null;
	}

	public Object [] getControls() {
	    // No controls
	    return new Control[0];
	}

	public Time getDuration() {
	    return ds.getDuration();
	}

	public void disconnect() {
	}

	public String getContentType() {
	    return ContentDescriptor.RAW;
	}

	public MediaLocator getLocator() {
	    return ml;
	}

	public void setLocator(MediaLocator ml) {
	    System.err.println("Not interested in a media locator");
	}
    }


    /**
     * Utility Source stream for the SuperCutDataSource.
     */
    class SuperCutStream implements PushBufferStream, BufferTransferHandler {

	TrackControl tc;
	PushBufferStream pbs;

	long start[], end[];
	boolean startReached[], endReached[];
	int idx = 0;

	BufferTransferHandler bth;
	long timeStamp = 0;
	long lastTS = 0;
	int audioLen = 0;
	int audioElapsed = 0;
	boolean eos = false;
	Format format;

	// Single buffer Queue.
	Buffer buffer;
	int bufferFilled = 0;

	//Checking for the total bytes read. //nikos
	long totalBytesRead=0;
	long totalBytesKept=0;
	long startByte[];
	long endByte[];
	int numberOfBuffers=0;
	//using the following to read from offset
//	DataSourceReader r;
	boolean filedone=false;

	public SuperCutStream(TrackControl tc, PushBufferStream pbs,
			long start[], long end[]) {
	    this.tc = tc;
	    this.pbs = pbs;
	    this.start = start;
	    this.end = end;
	    startReached = new boolean[start.length];
	    endReached = new boolean[end.length];

	    startByte=new long[start.length]; //nikos
	    endByte=new long[end.length]; //nikos

	    for (int i = 0; i < start.length; i++) {
		startReached[i] = endReached[i] = false;
	    }

	    //nikos
	    for(int i=0;i<start.length; i++){
	    startByte[i]=endByte[i]=0;
	    }
	    //r=new DataSourceReader(10559);

	    buffer = new Buffer();
	    pbs.setTransferHandler(this);
	}


	/**
	 * Called from the transferData to read data from the input.
	 */
	void processData() {

	    // We have a synchronized buffer Q of 1.
	    synchronized (buffer) {
		while (bufferFilled == 1) {
		    try {
		   //totalBytesRead+=buffer.getLength(); //nikos
			buffer.wait();

		    } catch (Exception e) {}
		}
	    }

	    // Read from the real source.
	    try {
		pbs.read(buffer);
	    } catch (IOException e) {}

	    format = buffer.getFormat();
	   // System.out.println(format);

	    //nikos diagnostics
	    int bufferLength=buffer.getLength();
	   //System.out.println("length="+bufferLength);
	    //Object o=buffer.getData();
	    //for(int i=0;i<100;i++)
	    //System.out.print((char) ((byte[]) o)[i]);
	   // System.out.println(o instanceof byte[]);
	   // System.out.println(o.toString());
	    Object o2=buffer.getHeader();
	  //  System.out.println(o2 instanceof byte[]);
	  //  System.out.println(o2.toString());

	    if (idx >= end.length || filedone) {
		// We are done with all the end points.
		// Let's just generate an EOM to stop the processing.
		//totalBytesRead+=buffer.getLength(); //nikos
		//totalBytesKept+=buffer.getLength();
		buffer.setOffset(0);
		buffer.setLength(0);
		buffer.setEOM(true);
	    }

	    if (buffer.isEOM())
		eos = true;

	    int len = buffer.getLength();

		totalBytesRead+=buffer.getLength(); //nikos


	    // Skip the buffers if it's to be cut.
	    if (checkTimeToSkip(buffer)) {
		// Update the audio len counter.
		if (isRawAudio(buffer.getFormat()))
		    audioLen += len;
		return;
	    }

	    // Update the audio len counter.
	    if (isRawAudio(buffer.getFormat()))
		audioLen += len;

	    // We can now allow the processor to read from our stream.
	    synchronized (buffer) {
	    bufferFilled = 1;
		buffer.notifyAll();
	    }

	    // Notify the processor.
	    if (bth != null)
		//nikos
		//totalBytesKept+=len;
		totalBytesKept+=buffer.getLength();
		//numberOfBuffers++;
		//System.out.println("number of buffers="+numberOfBuffers);

		bth.transferData(this);
	}


	/**
 	 * This is invoked from the consumer processor to read
	 * a frame from me.
	 */
	public void read(Buffer rdBuf) throws IOException {

	    /**
	     * Check if there's any buffer in the Q to read.
	     */
	    synchronized (buffer) {
		while (bufferFilled == 0) {
		    try {

			buffer.wait();
		    } catch (Exception e) {}
		}
	    }
		//nikos
		//r.makeBuffer(rdBuf.getLength());
		//filedone=!(r.processBytes(r.getBuffer()));
	    // Copy the data from the queue.
	    //byte[] bytesRead=r.getBuffer();
	    //rdBuf.setData(bytesRead);
	    Object oldData = rdBuf.getData();
		//Object oldData=r.getBuffer();
		//System.out.println(oldData instanceof byte[]);

	    rdBuf.copy(buffer);

	    //rdBuf.setData(bytesRead);

	    buffer.setData(oldData);
	  //  totalBytesRead+=rdBuf.getLength();  //nikos

	    // Remap the time stamps.

	    if (isRawAudio(rdBuf.getFormat())) {
		// Raw audio has a accurate to compute time.
		rdBuf.setTimeStamp(computeDuration(audioElapsed, rdBuf.getFormat()));
		audioElapsed += buffer.getLength();
	    } else if (rdBuf.getTimeStamp() != Buffer.TIME_UNKNOWN) {
		long diff = rdBuf.getTimeStamp() - lastTS;
		//System.out.println("diff="+diff);
		lastTS = rdBuf.getTimeStamp();
		if (diff > 0)
		    timeStamp += diff;
		rdBuf.setTimeStamp(timeStamp);
	    }

	    synchronized (buffer) {

		bufferFilled = 0;
		buffer.notifyAll();
	    }
	}


	/**
	 * Given a buffer, check to see if this should be included or
	 * skipped based on the start and end times.
	 */
	boolean checkTimeToSkip(Buffer buf) {

	    if (idx >= startReached.length)
		return false;

	    if (!eos && !startReached[idx]) {
		if (!(startReached[idx] = checkStartTime(buf, start[idx]))) {
		    return true;
		}
	    }

	    if (!eos && !endReached[idx]) {
		if (endReached[idx] = checkEndTime(buf, end[idx])) {
		    idx++;	// move on to the next set of start & end pts.
		    return true;
		}
	    } else if (endReached[idx]) {
		if (!eos) {
		    return true;
		} else {
		    buf.setOffset(0);
		    buf.setLength(0);
		}
	    }

	    return false;
	}


	/**
	 * Check the buffer against the start time.
	 */
	boolean checkStartTime(Buffer buf, long startTS) {
	    if (isRawAudio(buf.getFormat())) {
		long ts = computeDuration(audioLen+buf.getLength(),
					buf.getFormat());
		if (ts > startTS) {
		//basically if the start time falls inside the buffer we
		//create a new buffer by breaking up the old one by shifting
		//offset and shortening the length //nikos
		    int len = computeLength(ts - startTS, buf.getFormat());
		    buf.setOffset(buf.getOffset() + buf.getLength() - len);
		    buf.setLength(len);
		    lastTS = buf.getTimeStamp();
		    //nikos
		    //this is also where I check for the offset byte.
		    //totalBytesKept+=buf.getLength();
		    return true;
		}
	    } else if (buf.getTimeStamp() >= startTS) {
		if (buf.getFormat() instanceof VideoFormat) {
		    // The starting frame needs to be a key frame.
		    if ((buf.getFlags() & Buffer.FLAG_KEY_FRAME) != 0) {
			lastTS = buf.getTimeStamp();
			return true;
		    }
		} else {
		    lastTS = buf.getTimeStamp();
		    return true;
		}
	    }
	    return false;
        }


	/**
	 * Check the buffer against the end time.
	 */
	boolean checkEndTime(Buffer buf, long endTS) {
	    if (isRawAudio(buf.getFormat())) {
		if (computeDuration(audioLen, buf.getFormat()) >= endTS)
		    return true;
		else {
		    long ts = computeDuration(audioLen+buf.getLength(),
					buf.getFormat());
		    if (ts >= endTS) {
			int len = computeLength(ts - endTS, buf.getFormat());
			buf.setLength(buf.getLength() - len);
			// We still need to process this last buffer.
//			totalBytesKept-=len; //nikos
		    }
		}
	    } else if (buf.getTimeStamp() > endTS) {
		return true;
	    }

	    return false;
	}


	/**
	 * Compute the duration based on the length and format of the audio.
	 */
	public long computeDuration(int len, Format fmt) {
	    if (!(fmt instanceof AudioFormat))
		return -1;
	    return ((AudioFormat)fmt).computeDuration(len);
	}


	/**
	 * Compute the length based on the duration and format of the audio.
	 */
	public int computeLength(long duration, Format fmt) {
	    if (!(fmt instanceof AudioFormat))
		return -1;
	    AudioFormat af = (AudioFormat)fmt;
	    // Multiplication is done is stages to avoid overflow.
	    return (int) ((((duration /1000) * (af.getChannels() * af.getSampleSizeInBits()))/1000) * af.getSampleRate() / 8000);
	}


	public ContentDescriptor getContentDescriptor() {
	    return new ContentDescriptor(ContentDescriptor.RAW);
	}

	public boolean endOfStream() {
	    return eos;
	}

	public long getContentLength() {
	    return LENGTH_UNKNOWN;
	}

	public Format getFormat() {
	    return tc.getFormat();
	}

	public void setTransferHandler(BufferTransferHandler bth) {
	    this.bth = bth;
	}

	public Object getControl(String name) {
	    // No controls
	    return null;
	}

	public Object [] getControls() {
	    // No controls
	    return new Control[0];
	}

	public synchronized void transferData(PushBufferStream pbs) {
	   processData();
	}

    } // class SuperCutStream
}

