#!/bin/sh

export CLASSPATH=.:/linux2/archive/courses/thesis/streamredir:/linux2/archive/courses/thesis/streamredir/streamredirector

# See how we were called.
case "$1" in
    dsr)
	echo "Starting DSR..."
	xterm -T DSR -geometry 80x5+0+25 -e java ins.dsr.DSR&
	;;
    inr)
	echo "Starting INR..."
	xterm -T INR -geometry 80x25+0+125 -e java ins.inr.Resolver wind -d localhost&
	;;
    sink)
	echo "Starting FileSinkProxy..."
	xterm -T FileSinkProxy -geometry 80x15+0+500 -e java streamredirector.FileSinkProxy -p streamredirector/players.dat -v wind -d localhost -l "[location=mit[building=ne43[floor=1[room=DEFAULT]]]]" &
	;;
    gui)
	echo "Starting ControllerGUI..."
	xterm -T ControllerGUI -geometry 80x15-25+25 -e java streamredirector.gui.ControllerGUI&
	;;
    *)
	./start.sh dsr
	sleep 5
	./start.sh inr
	sleep 5
	./start.sh sink
	sleep 5
	./start.sh gui
esac

exit 0
