/*
 * Copyright (c) 2000, 2001 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `LICENSE' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file CRICKETAUTHORS which should have accompanied 
 * this software for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the CRICKETAUTHORS file.
 */
package viewfinder;

import java.awt.*;
import javax.swing.*;

class StatusBar extends JPanel 
{
    JLabel x, y, orient;

    public StatusBar() {
	x = _addInfoLabel("x:", "0.0");
	y = _addInfoLabel("y:", "0.0");
	orient = _addInfoLabel("a:", "0.0");
    }

    private JLabel _addInfoLabel(String title, String value) 
    {
	JLabel t = new JLabel(title, JLabel.LEFT);
	add(t);
	
	if( value != null ) {
	    JLabel v = new JLabel(value, JLabel.RIGHT);
	    add(v);
	    return v;
	}
	return null;
    }

    public static int min(int a, int b)
    {
	if(b < a)
	    return b;
	return a;
    }

    public static String textOf(double d, int places) 
    {
	String s = String.valueOf(d);
	int endIndex = s.length();
	int decIndex = s.indexOf(".");
	if(decIndex >= 0)
	    endIndex = min(endIndex, decIndex + places);
	
	return s.substring(0, endIndex);
    }

    public void setOrient(double v)
    {
	orient.setText(textOf(v, 2));
    }

    public void setX(double v)
    {
	x.setText(textOf(v, 2));
    }

    public void setY(double v)
    {
	y.setText(textOf(v, 2));
    }

}
