/*
 * Copyright (c) 2000, 2001 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `LICENSE' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file CRICKETAUTHORS which should have accompanied 
 * this software for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the CRICKETAUTHORS file.
 */
package cricketdaemon.clientlib.data;


/**
 * X, Y, Z coordinate.
 *
 *
 * @author Allen Miu
 */
public class Position
{
    public double x, y, z;
    
    public Position(double x, double y, double z)
    {
       this.x = x; this.y = y; this.z = z;
    }
    
    public String toString()
    {
	return "( "+x+" "+y+" "+z+" )";
    }

    public boolean equals(Object o)
    {
	if(!(o instanceof Position))
	    return false;
	Position p = (Position) o;

	return (p.x == x) && (p.y == y) && (p.z == z);
    }

    public static double sqr(double v) {
	return v*v;
    }

    public double dist(Position o)
    {
	return Math.sqrt( sqr(x-o.x) + sqr(y-o.y) + sqr(z-o.z) );
    }

    public boolean invalid()
    {
	return (Double.isNaN(x) || Double.isNaN(y) || Double.isNaN(z));
    }
}

