/*
 * Copyright (c) 2000, 2001 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `LICENSE' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file CRICKETAUTHORS which should have accompanied 
 * this software for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the CRICKETAUTHORS file.
 */
package cricketdaemon.clientlib.parse;

import cricketdaemon.Util;
import cricketdaemon.clientlib.data.*;
import java.io.*;
import java.util.*;

/**
 * Parses subtypes contained within a "pos"ition type.
 *
 * @author Allen Miu
 */
class PosParseHandlerMap extends ParseHandlerMap
{
    public static PosParseHandlerMap instance = 
	new PosParseHandlerMap();

    protected PosParseHandlerMap()
    {
	super();
	register("x", "check_coord", "parse_x");
	register("y", "check_coord", "parse_y");
	register("z", "check_coord", "parse_z");

    }

    public boolean check_coord(Object o)
    {
	return o instanceof Position;
    }

    public void parse_x(Object dataStructure, String value)
	throws IOException 
    {
	Position a = (Position) dataStructure;
	a.x = Util.parseDouble(value);
    }

    public void parse_y(Object dataStructure, String value)
	throws IOException 
    {
	Position a = (Position) dataStructure;
	a.y = Util.parseDouble(value);
    }

    public void parse_z(Object dataStructure, String value)
	throws IOException 
    {
	Position a = (Position) dataStructure;
	a.z = Util.parseDouble(value);
    }
}
