package cricketdaemon.evaluate;

import cricketdaemon.*;
import cricketdaemon.beaconstat.*;
import cricketdaemon.reader.*;
import java.util.*;

public class BeaconFilter extends BeaconStatModule implements Algorithm
{
    long currentTime;
    DataCapsule result;

    public BeaconFilter(int w, int bs, int ss)
    {
	super();
	window  = w;
	statSelect = ss;
	binSize = bs;
    }	

    public void start()
    {
	Util.assert(false, "BeaconFilter::start() is not supported");
    }

    public DataCapsule exec(DataCapsule d)
    {
	result = null;
	Beacon b = (Beacon) d.data;
	currentTime = b.timeStamp;
	processBeacon(b, d.mask);
	periodicallyProcess();
	return result;
    }

    protected void transfer(Data data, BitSet mask)
    {
	if(data != null)
	    result = new DataCapsule(data, mask);
	else
	    result = null;
    }

    protected long curTime()
    {
	return currentTime;
    }
}



