package cricketdaemon.evaluate;

import cricketdaemon.*;
import cricketdaemon.position.*;
import cricketdaemon.beaconstat.*;
import java.util.*;

public class PositionFilter extends PositionModule implements Algorithm
{
    static long currentTime;
    DataCapsule result;

    public PositionFilter(double thresh)
    {
	super( thresh );
    }	

    public void start()
    {
	Util.assert(false, "PositionFilter::start() is not supported");
    }

    public DataCapsule exec(DataCapsule d)
    {
	result = null;
	if(d != null) {
	    BeaconStatData b = (BeaconStatData) d.data;
	    currentTime = b.timeStamp;
	    processBeaconStatData(b, d.mask);
	}
	return result;
    }

    protected void transfer(Data data, BitSet mask)
    {
	if(data != null)
	    result = new DataCapsule(data, mask);
	else
	    result = null;
    }

    protected long curTime()
    {
	return currentTime;
    }
}
