import java.awt.event.*;

class Beacon extends Vertex
{
    Circle known;

    public static boolean snap = true;

    protected Beacon(double x, double y)
    {
	super(x, y);
	double r = Math.sqrt(distSqr(DrawingArea.device));
	known = new Circle(x, y, r);
	super.beacons.add(this);
	super.knownPositions.add(known);
    }
    
    public static Vertex createInstance()
    {
	return new Beacon(0, 0);
    }

    public void mousePressed(double x, double y, int modifier)
    {
	if((modifier & MouseEvent.CTRL_MASK) > 0) {
	    snapCircle();
	}
    }

    public void snapCircle()
    {
	double r = Math.sqrt(distSqr(DrawingArea.device));
	known.update(this.x, this.y, r);
    }

    public void mouseDragged(double x, double y, Vertex anchor, 
			     int modifier) 
    {
	super.mouseDragged(x, y, anchor, modifier);
	known.update(x, y, known.radius);
	if(snap)
	    snapCircle();
    }

    public void remove()
    {
	Util.assert(beacons.remove(beacons.indexOf(this)) != null,
				   "Beacon::remove()");
	Util.assert(knownPositions.remove(knownPositions.indexOf(known)) != null,
					  "Beacon::remove() 2");
    }

    public static void snapAll()
    {
	for(int i = 0; i < beacons.size(); i++) {
	    ((Beacon) beacons.get(i)).snapCircle();
	}
    }
}
