import java.awt.*;
import java.awt.event.*;
import java.util.*;

// no rotation
class Circle extends Vertex
{
    public static final double TOLERANCE = 15;

    public double radius;

    public Circle(double x, double y, double r)
    {
	super(x, y);
	update(x, y, r);
    }

    public void update(double x, double y, double r)
    {
	radius = r;
	this.x = x;
	this.y = y;
    }

    public boolean inBound(double x, double y)
    {
	double dist = rad2D(this.x, this.y, x, y);
	return Math.abs(dist - radius) <= TOLERANCE;
    }

    public double rad2D(double px, double py, double qx, double qy)
    {
	return Math.sqrt(sqr(px - qx) + sqr(py - qy));
    }

    public double sqr(double r)
    {
	return r*r;
    }

    public void draw(Graphics g, DrawingArea drawArea)
    {
	Vertex pp = drawArea.transform(this.x-radius, this.y+radius);
	Vertex qq = drawArea.transform(this.x+radius, this.y-radius);

	g.setColor(Color.red.darker().darker());

	// java-ism
	g.drawOval(Math.round((float)pp.x), Math.round((float)pp.y), 
		   Math.round((float)Math.abs(qq.x-pp.x)), Math.round((float)Math.abs(qq.y-pp.y)));

    }

    public void mouseDragged(double x, double y, Vertex anchor, 
			     int modifier) 
    { 
	double newRad = rAnchor;
	double newX   = cAnchor.x;
	double newY   = cAnchor.y;

	System.out.println("world");
	newRad = Math.sqrt(distSqr(cAnchor.x, cAnchor.y, cAnchor.z, x, y, z));
	update(newX, newY, newRad);
    }

    Vertex cAnchor = new Vertex(0, 0);
    double rAnchor;
    public void mousePressed(double x, double y, int modifier) 
    { 
	cAnchor.x = this.x;
	cAnchor.y = this.y;
	cAnchor.z = this.z;
	rAnchor   = radius;
    }
}

