import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Controls extends JPanel 
    implements ActionListener, ItemListener, KeyListener
{
    DrawingArea drawArea;
    SolverPanel solver;
    JButton reset;
    JButton addBeacon;
    JCheckBox snap;

    public Controls(DrawingArea d, SolverPanel s)
    {
	((FlowLayout)getLayout()).setHgap(10);
	drawArea = d;
	solver   = s;

	reset = new JButton("reset");
	reset.setActionCommand(reset.getText());
	reset.addActionListener(this);
	add(reset);

	addBeacon = new JButton("AddBeacon");
	addBeacon.setActionCommand(addBeacon.getText());
	addBeacon.addActionListener(this);
	add(addBeacon);

	snap = new JCheckBox("Snap", true);
	snap.addItemListener(this);
	add(snap);
    }
    
    public void actionPerformed(ActionEvent e) 
    {
	if(e.getActionCommand().equals(reset.getText())) {
	    resetEverything();
	}
	if(e.getActionCommand().equals(addBeacon.getText())) {
	    drawArea.addBeacon();
	}
    }

    public void resetEverything()
    {
	drawArea.initialize();
    }

    public void itemStateChanged(ItemEvent e)
    {
	Object source = e.getItemSelectable();
	boolean selected = e.getStateChange() == ItemEvent.SELECTED;
	if(source == snap) {
	    Beacon.snap = selected;
	    if(selected) {
		Beacon.snapAll();
		drawArea.repaint();
	    }
	}
    }

    public void keyPressed(KeyEvent e) 
    {
	int k = KeyEvent.VK_UNDEFINED;
	if(e.isActionKey())
	    k = e.getKeyCode();
	if(k == 0)
	    k = (int) Character.toLowerCase(e.getKeyChar());
	System.out.println("keypressed: "+k);
	switch(k) {
	case KeyEvent.VK_UP:
	    solver.K_NOMINAL += 0.05;
	    solver.constantK.setValue(solver.K_NOMINAL);
	    solver.update();
	    break;
	case KeyEvent.VK_DOWN:
	    solver.K_NOMINAL -= 0.05;
	    solver.constantK.setValue(solver.K_NOMINAL);
	    solver.update();
	    break;
	}
    }
    
    public void keyReleased(KeyEvent e) { return; }

    public void keyTyped(KeyEvent e) { return; }
}

