public class Util 
{
    public static boolean debugMode = true;

    public static void dbgPrintln(String s) 
    {
	if(debugMode) 
	    System.out.println(s);
    }
    
    public static void assert(boolean pred, String errMsg) 
    {
	try {
	    if(!pred)
		throw new Exception();
	}
	catch (Exception e) {
	    System.err.println("ASSERTION FAILED--> "+errMsg);
	    e.printStackTrace();
	    System.exit(1);
	}
    }

    public static double min(double a, double b)
    {
	if(a < b) return a; else return b;
    }

    public static double max(double a, double b)
    {
	if(a >= b) return a; else return b;
    }

    public static String textOf(double d, int places) 
    {
	String s = String.valueOf(d);
	int eIndex = s.indexOf("E");
	if(eIndex >= 0) {
	    return s.substring(0, places+2)+s.substring(eIndex, s.length());
	}
	int endIndex = s.length();
	int decIndex = s.indexOf(".");
	if(decIndex >= 0)
	    endIndex = min(endIndex, decIndex + places);
	
	return s.substring(0, endIndex);
    }

    public static int min(int a, int b)
    {
	if(b < a)
	    return b;
	return a;
    }

}
