/*
 * Copyright (c) 2000, 2001 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `LICENSE' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file CRICKETAUTHORS which should have accompanied 
 * this software for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the CRICKETAUTHORS file.
 */
package cricketdaemon.reader.parse;

import cricketdaemon.Util;
/**
 * A FieldParser that parses the input bytes as an ASCII String.
 *
 * @author Allen Miu
 */
public class FieldParser_ASCII implements FieldParser
{
    public static FieldParser instance = new FieldParser_ASCII();

    private FieldParser_ASCII()
    {
    }

    public Object parse(byte[] beacon, int offset, int length)
    {
	String result = null;
	try {
	    result = new String(beacon, offset, length, "US-ASCII");
	}
	catch (java.io.UnsupportedEncodingException e) {
	    Util.warn(e.getMessage());
	} 
	//System.out.println("FieldParser_ASCII::parse() "+result);
	return result;
    }

    public Object stringToReturnType(String s) 
    {
	return s;
    }

    public Object GPSDStringToReturnType(String s)
    {
	return stringToReturnType(s);
    }

    public byte[] unparse(Object o)
    {
	return ((String) o).getBytes();
    }
}
