package cricketdaemon.reader.sim;

import navigator.*;
import cricketdaemon.Util;
import viewfinder.Coord;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;

class MapGUI extends navigator.GUI
{
    ArrayList activeBeacons;
    Point2D device;

    public MapGUI(Mesh mesh, ArrayList labels)
    {
	super(mesh, labels, true);
	//Controls c = new Controls(cntl);
	//f.addKeyListner(c);
	//f.getContentPane.add(c, "North");

	//f.validate();
	//f.pack();

	device = new Point2D.Double();
	demo = false;
    }
    
    public void drawEdge(Edge e)
    {
	if(e.isInvalid() || e.isDoorJamb())
	    super.drawEdge(e);
    }

    private static final int BEACONSIZE = 4;
    private ArrayList beacons;

    private void drawBeacons(Graphics gc, int curWinWidth,
			     int curWinHeight, AffineTransform trans)
    {
	Point2D p2D = new Point2D.Double();

	if( beacons != null ) {
	    gc.setColor(Color.green);		    
	    for(int i = 0; i < beacons.size(); i++) {
		Coord p = (Coord) beacons.get(i);
		p2D.setLocation(p.x, p.y);
		
		Point2D pt = trans.transform(p2D, null);

		int ix = Math.round((float)pt.getX())-BEACONSIZE/2;
		int iy = Math.round((float)pt.getY())-BEACONSIZE/2;

		if(ix <= curWinWidth && iy <= curWinHeight) {
		    gc.fillRect(ix, iy, BEACONSIZE, BEACONSIZE);
		    gc.drawString(p.name, ix, iy);
		}
	    }
	}	
    }


    public void setBeacons(ArrayList b) { beacons = b; }
    public void setActiveBeacons(ArrayList v) { activeBeacons = v; }
    public void setCurLoc(double x, double y) 
    { 
	device.setLocation(x,y); 
	snapWindowToWorldCoord(device);
    }

    private static final Point2D ORIGIN = new Point2D.Double(0, 0);
    private static double rad = Math.sqrt(SimReader.RANGE*SimReader.RANGE - SimMapReader.z*SimMapReader.z);
    private static final Point2D RADIUS = new Point2D.Double(0, rad);
    private Rectangle2D rect = new Rectangle2D.Double();
    private void drawActiveBeacons(Graphics gc, int curWinWidth,
				   int curWinHeight, AffineTransform trans)
    {
	Point2D p2D = new Point2D.Double();

	if( activeBeacons != null ) {
	    gc.setColor(Color.red);		    
	    for(int i = 0; i < activeBeacons.size(); i++) {
		Coord p = (Coord) activeBeacons.get(i);
		p2D.setLocation(p.x, p.y);
		
		Point2D pt = trans.transform(p2D, null);

		int ix = Math.round((float)pt.getX())-BEACONSIZE/2;
		int iy = Math.round((float)pt.getY())-BEACONSIZE/2;

		// calc transformed radius
		
		Point2D or = trans.transform(ORIGIN, null);
		Point2D r  = trans.transform(RADIUS, null);
		
		double radius = or.distance(r);

		int ixx = (int) Math.round(pt.getX()-radius);
		int iyy = (int) Math.round(pt.getY()-radius);
		int ir  = (int) Math.round(2*radius);

		rect.setRect(0, 0, curWinWidth, curWinHeight);
		if(rect.intersects(ixx, iyy, ir, ir)) {
		    gc.fillRect(ix, iy, BEACONSIZE, BEACONSIZE);
		    gc.drawString(p.name, ix, iy);
		    gc.drawOval(ixx, iyy, ir, ir);
		}
	    }
	}	
    }
    
    private static final int DEVICESIZE = 6;
    private void drawDevice(Graphics gc, AffineTransform trans)
    {
	gc.setColor(Color.yellow);
	Point2D p = trans.transform(device, null);
	int ix = Math.round((float)p.getX())-DEVICESIZE/2;
	int iy = Math.round((float)p.getY())-DEVICESIZE/2;
	gc.fillOval(ix, iy, DEVICESIZE, DEVICESIZE);
    }

    protected void drawChild(Graphics gc, int curWinWidth,
			     int curWinHeight, AffineTransform trans)
    {
	drawBeacons(gc, curWinWidth, curWinHeight, trans);
	drawActiveBeacons(gc, curWinWidth, curWinHeight, trans);
	drawDevice(gc, trans);
	return;
    }

    // draw permanent beacons
}
