package cricketdaemon.reader.sim;

import navigator.*;
import viewfinder.Coord;
import cricketdaemon.module.*;

import java.util.*;

public class SimMapReader extends SimReader
{
    private MapGUI mapgui;
    private Mesh mesh;
    private QuadEdgeWalker walk;
    static double z = 50;

    public SimMapReader(String beaconConfig, String mapFile, String labelFile)
    {
	super(beaconConfig);

	mesh = NavigatorApp.parseFile(mapFile);

	ArrayList spaceLabels = SpaceLabel.parse(labelFile);

	mapgui  = new MapGUI(mesh, spaceLabels);
	mapgui.setBeacons(beacons);

	walk = new QuadEdgeWalker(mapgui, mesh, null, false, null);
	Edge curEdge = mesh.currentEdge.rot();
	System.out.println(curEdge);
	mapgui.refresh(curEdge);
    }

    // find active beacons (randomized)
    // model interference
    // pass packet up
    
    // animate set of active beacons (with circles)
    //public void setBeacons(ArrayList v) { beacons = v; }
    //public void setActiveBeacons(ArrayList v) { activeBeacons = v; }
    //public void setCurLoc(double x, double y) { device.setLocation(x,y); }
    // mapgui.refresh(walk.getEdge());

    // should not use Controls as KeyListener... coord updates by "walk"
    
    // walk steps in increments, updates curX, curY, Edge, controls refreshes
    // Controls steps continuously, controls z value and status value

    // all distance measurements are assumed to be in centimeters
    protected void process()
    {
	ArrayList active = activeBeacons(cycle++);
	//System.out.println("cycle "+cycle);
	for(int i = 0; i < active.size(); i++) {
	    Coord activeBeacon = (Coord) active.get(i);
	    if(!interfere(walk.getX(), walk.getY(), z, activeBeacon, active)) {
		double dist = activeBeacon.dist(walk.getX(), walk.getY(), z);
		//System.out.println(dist+" "+walk.getX()+" "+walk.getY());
		send(dist, activeBeacon); // tests for inRange in send
	    }
	}
	mapgui.setActiveBeacons(active);
	mapgui.setCurLoc(walk.getX(), walk.getY());
	mapgui.refresh(walk.getEdge());
    }
    
    private boolean interfere(double x, double y, double z, Coord beacon,
			      ArrayList beacons)
    {
	return false;
    }
			      
    private ArrayList activeBeacons(int clock)
    {
	return beacons;
    }

    public static void main(String[] args)
    {
	SimMapReader r = new SimMapReader(args[0], args[1], args[2]);
	DebugModule dm = new DebugModule(r);
	dm.start();
	r.start();
    }
}
