
package ejmf.toolkit.multiplayer;

import java.awt.*;
import java.awt.event.*;
import java.io.Serializable;
import java.beans.*;
import java.util.*;

import javax.swing.plaf.basic.BasicSliderUI;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.plaf.*;

/**
* L&F for TrackSlider
*/
public class TrackSliderUI extends BasicSliderUI 
{
    private TrackListener	trackListener;
    private boolean		isDragging;

	/**
	* Create UI for UIManager
	* @return A ComponentUI
	* @see javax.swing.plaf.ComponentUI
	*/
    public static ComponentUI createUI(JComponent c)    {
        return new TrackSliderUI((JSlider) c);
    } 

	/** Create TrackSliderUI
	*/
    public TrackSliderUI(JSlider s)   {
	super(s);
    }

	/**
	* Calculate the bounds of the slider bounds
	*/
    public void calculateThumbBounds()	{
// <HERE> Commented out by Rafa
//  setThumbBounds(xPositionForValue(slider.getValue()),
//       getScrollTrackRect().y, 
//      xPositionForValue(slider.getExtent()), 
//      getScrollTrackRect().height);
    }

	/**
	* Install UI
	* @param c JComponent depicting UI
	* 
	* @see javax.swing.plaf.ComponentUI
	*/
    public void installUI(JComponent c) {
	super.installUI(c);
 	slider = (JSlider) c;	
	
	// Install my own mouse listeners
 	trackListener = new TrackListener();
	slider.addMouseListener(trackListener);
	slider.addMouseMotionListener(trackListener);
    }

	/**
	* Uninstall UI
	* @param c JComponent depicting UI
	* 
	* @see javax.swing.plaf.ComponentUI
	*/
    public void uninstallUI(JComponent c) {
	super.uninstallUI(c);
	slider.removeMouseListener(trackListener);
	slider.removeMouseMotionListener(trackListener);
    }

	/** 
	* @return the JSlider used to display this TrackSliderUI
	*/
    protected JSlider getSlider() {
	return slider;
    }

    protected javax.swing.Timer getScrollTimer() {
	return scrollTimer;
    }

    protected int getTrackBuffer() {
	return trackBuffer;
    }
	
    protected class TrackListener extends MouseAdapter 
			implements MouseMotionListener, Serializable {

	protected int 	offset;	
	protected int	currentMouseX, currentMouseY;
     
  	public void mouseMoved(MouseEvent e) {}

	public void mousePressed(MouseEvent e) {
	    if(!getSlider().isEnabled())
     		return;

	    currentMouseX = e.getX();
	    currentMouseY = e.getY();

	    getSlider().requestFocus();

// <HERE> Commented out by Rafa
//	    if(getThumbRect().contains(currentMouseX, currentMouseY)) {
//         	offset = currentMouseX - getThumbRect().x;
//     	    }
     	    isDragging = true;
            getSlider().setValueIsAdjusting(true);
     	    return;
	}

      	public void mouseDragged(MouseEvent e) {
// <HERE> Commented out by Rafa
// 	    Rectangle scrollTrackRect = getScrollTrackRect();
      Rectangle scrollTrackRect = null;
      
 	    if(!getSlider().isEnabled())
     	        return;

 	    currentMouseX = e.getX();
 	    currentMouseY = e.getY();

 	    if(!isDragging)
     	        return;

	    int thumbLeft = e.getX() - offset;
	    int trackLeft = scrollTrackRect.x + getTrackBuffer();
	    int trackRight = (scrollTrackRect.x + 
				(scrollTrackRect.width - 1)) - getTrackBuffer();

	    thumbLeft = Math.max( thumbLeft, trackLeft);
	    thumbLeft = Math.min( thumbLeft, trackRight);

// <HERE> Commented out by Rafa
//	    setThumbLocation( thumbLeft, getThumbRect().y);

	    getSlider().setValue( valueForXPosition( thumbLeft ) );
	} 
    
        public void mouseReleased(MouseEvent e) {
	    if(!getSlider().isEnabled())
		return;

  	    offset = 0;
  	    getScrollTimer().stop();
	}
    }

    public int valueForXPosition( int xPos ) {
	    JSlider slider = getSlider();
            int value;
            int minValue = slider.getMinimum();
            int maxValue = slider.getMaximum();
// <HERE> Commented out by Rafa
//            Rectangle trackRect = getScrollTrackRect();
            Rectangle trackRect = null;
            int trackLength = trackRect.width - (getTrackBuffer() * 2);
            int trackLeft = trackRect.x + getTrackBuffer();
            int trackRight = (trackRect.x + (trackRect.width - 1)) - 
				getTrackBuffer();

            if ( xPos <= trackLeft ) {
                value = slider.getInverted() ? maxValue : minValue;
            }
            else if ( xPos >= trackRight ) {
                value = slider.getInverted() ? minValue : maxValue;
            }
            else {
                int distanceFromTrackLeft = xPos - trackLeft;
                int valueRange = maxValue - minValue;
                double valuePerPixel = (double)valueRange / (double)trackLength;
                int valueFromTrackLeft = (int)Math.round( distanceFromTrackLeft
* valuePerPixel );

               value = slider.getInverted() ? maxValue - valueFromTrackLeft :
                                              minValue + valueFromTrackLeft;
           }

           return value;
       }
}
